
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega16L
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16L
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _meny=R5
	.DEF _sek=R4
	.DEF _chislo=R7
	.DEF _mesec=R6
	.DEF _god=R9
	.DEF _den_nedeli=R8
	.DEF _td10=R11
	.DEF _tu10=R10
	.DEF _bud_temp=R13
	.DEF _stroka=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  _timer2_comp_isr
	JMP  _timer2_ovf_isr
	JMP  0x00
	JMP  _timer1_compa_isr
	JMP  0x00
	JMP  0x00
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _ana_comp_isr
	JMP  0x00
	JMP  0x00
	JMP  _timer0_comp_isr
	JMP  0x00

_simvol:
	.DB  0x3E,0x7F,0x41,0x7F,0x3E,0x0,0x2,0x7F
	.DB  0x7F,0x0,0x62,0x73,0x59,0x4F,0x46,0x22
	.DB  0x63,0x49,0x7F,0x36,0x18,0x14,0x12,0x7F
	.DB  0x7F,0x2F,0x6F,0x45,0x7D,0x39,0x3E,0x7F
	.DB  0x49,0x7B,0x32,0x3,0x73,0x79,0xF,0x7
	.DB  0x36,0x7F,0x49,0x7F,0x36,0x2E,0x6F,0x49
	.DB  0x7F,0x3E,0x7C,0x12,0x12,0x7C,0xAA,0x7E
	.DB  0x4A,0x4A,0x32,0xAA,0x7E,0x4A,0x4A,0x34
	.DB  0xAA,0x7E,0x2,0x2,0xAA,0x0,0x60,0x3C
	.DB  0x22,0x3E,0x60,0x7E,0x4A,0x4A,0xAA,0x0
	.DB  0x24,0x42,0x4A,0x34,0x0,0x66,0x18,0x7E
	.DB  0x18,0x66,0x7E,0x10,0x8,0x7E,0xAA,0x7C
	.DB  0x11,0x9,0x7C,0xAA,0x7E,0x18,0x24,0x42
	.DB  0xAA,0x78,0x4,0x2,0x7E,0xAA,0x7E,0x4
	.DB  0x8,0x4,0x7E,0x7E,0x8,0x8,0x7E,0xAA
	.DB  0x3C,0x42,0x42,0x3C,0xAA,0x7E,0x2,0x2
	.DB  0x7E,0xAA,0x7E,0x12,0x12,0xC,0xAA,0x3C
	.DB  0x42,0x42,0x24,0xAA,0x2,0x7E,0x2,0xAA
	.DB  0x0,0x4E,0x50,0x50,0x3E,0xAA,0xC,0x12
	.DB  0x7E,0x12,0xC,0x66,0x18,0x18,0x66,0xAA
	.DB  0x7E,0x40,0x40,0x7E,0xC0,0xE,0x10,0x10
	.DB  0x7E,0xAA,0x7E,0x40,0x7E,0x40,0x7E,0x7E
	.DB  0x40,0x7E,0x40,0xFE,0x2,0x7E,0x48,0x30
	.DB  0xAA,0x7E,0x48,0x30,0x0,0x7E,0x7E,0x48
	.DB  0x30,0xAA,0x0,0x24,0x42,0x4A,0x3C,0xAA
	.DB  0x7E,0x8,0x3C,0x42,0x3C,0x4C,0x32,0x12
	.DB  0x7E,0xAA,0x0,0x0,0xAA,0xAA,0x0,0x40
	.DB  0xAA,0xAA,0xAA,0x0,0xAA,0xAA,0xAA,0xAA
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x8
	.DB  0x8,0x8,0x8,0x8,0x8,0x3E,0x8,0x8
	.DB  0x6,0x9,0x9,0x6,0xAA,0x3E,0x41,0x41
	.DB  0x41,0x22,0x4,0x3F,0x44,0x20,0xAA,0x8
	.DB  0x8,0x8,0xAA,0x0,0x3F,0x40,0x40,0x3F
	.DB  0x0,0x40,0x40,0x40,0xAA,0x0,0x80,0xAA
	.DB  0xAA,0xAA,0xAA,0x0,0x0,0x0,0x0,0x0
_dnei_v_mesc:
	.DB  0x1F,0x1D,0x1F,0x1E,0x1F,0x1E,0x1F,0x1F
	.DB  0x1E,0x1F,0x1E,0x1F
_bit_mask_G100:
	.DB  0xF8,0xFF,0xFC,0xFF,0xFE,0xFF,0xFF,0xFF

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x1240

;DATA STACK END MARKER INITIALIZATION
__DSTACK_END_INIT:
	.DB  'D','S','T','A','C','K','E','N','D',0

;HARDWARE STACK END MARKER INITIALIZATION
__HSTACK_END_INIT:
	.DB  'H','S','T','A','C','K','E','N','D',0

_0x3:
	.DB  0x1
_0x4:
	.DB  0x1C
_0x5:
	.DB  0xB,0x1D,0xE,0x12,0x15,0x26,0x17,0x12
	.DB  0x14,0x2A,0xFF
_0x6:
	.DB  0x14,0x18,0x1A,0x1A,0xF,0x14,0x20,0x12
	.DB  0x29,0x2A,0x2A,0xFF
_0x7:
	.DB  0x1D,0x1B,0x1C,0xA,0x17,0x18,0xC,0x14
	.DB  0x12,0x2A,0xFF
_0x8:
	.DB  0xE,0xF,0x17,0x26,0xFF
_0x9:
	.DB  0xE,0xA,0x1C,0xA,0xFF
_0xA:
	.DB  0xD,0x18,0xE,0xFF
_0xB:
	.DB  0x17,0xA,0x1B,0x1C,0x1A,0x18,0x13,0x14
	.DB  0xA,0x2A,0xFF
_0xC:
	.DB  0x1B,0x14,0x18,0x1A,0x18,0x1B,0x1C,0x26
	.DB  0x2A,0xB,0xF,0xD,0x1D,0x23,0xF,0x13
	.DB  0x2A,0x1B,0x1C,0x1A,0x18,0x14,0x12,0x2A
	.DB  0xFF
_0xD:
	.DB  0x19,0xF,0x1A,0xF,0x17,0xA,0x10,0x17
	.DB  0xA,0x21,0xF,0x17,0x12,0xF,0x2A,0xE
	.DB  0xA,0x1C,0x21,0x12,0x14,0x18,0xC,0x2A
	.DB  0xFF
_0xE:
	.DB  0xE,0x15,0x12,0x1C,0xF,0x15,0x26,0x17
	.DB  0x18,0x1B,0x1C,0x26,0x2A,0x1B,0x12,0xD
	.DB  0x17,0xA,0x15,0xA,0x2A,0xFF
_0xF:
	.DB  0x19,0x18,0x17,0xF,0xE,0xF,0x15,0x26
	.DB  0x17,0x12,0x14,0xFF,0xC,0x1C,0x18,0x1A
	.DB  0x17,0x12,0x14,0xFF,0x0,0x0,0x0,0x0
	.DB  0x1B,0x1A,0xF,0xE,0xA,0xFF,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x21,0xF,0x1C,0xC
	.DB  0xF,0x1A,0xD,0xFF,0x0,0x0,0x0,0x0
	.DB  0x19,0x29,0x1C,0x17,0x12,0x20,0xA,0xFF
	.DB  0x0,0x0,0x0,0x0,0x1B,0x1D,0xB,0xB
	.DB  0x18,0x1C,0xA,0xFF,0x0,0x0,0x0,0x0
	.DB  0xC,0x18,0x1B,0x14,0x1A,0xF,0x1B,0xF
	.DB  0x17,0x26,0xF,0xFF
_0x10:
	.DB  0x19,0x17,0xC,0x1C,0x1B,0x1A,0x21,0x1C
	.DB  0x19,0x1C,0x1B,0xB,0xC,0x1B
_0x11:
	.DB  0x29,0x17,0xC,0xA,0x1A,0x29,0xFF,0x0
	.DB  0x0,0x1E,0xF,0xC,0x1A,0xA,0x15,0x29
	.DB  0xFF,0x0,0x16,0xA,0x1A,0x1C,0xA,0xFF
	.DB  0x0,0x0,0x0,0xA,0x19,0x1A,0xF,0x15
	.DB  0x29,0xFF,0x0,0x0,0x16,0xA,0x29,0xFF
	.DB  0x0,0x0,0x0,0x0,0x0,0x12,0x28,0x17
	.DB  0x29,0xFF,0x0,0x0,0x0,0x0,0x12,0x28
	.DB  0x15,0x29,0xFF,0x0,0x0,0x0,0x0,0xA
	.DB  0xC,0xD,0x1D,0x1B,0x1C,0xA,0xFF,0x0
	.DB  0x1B,0xF,0x17,0x1C,0x29,0xB,0x1A,0x29
	.DB  0xFF,0x18,0x14,0x1C,0x29,0xB,0x1A,0x29
	.DB  0xFF,0x0,0x17,0x18,0x29,0xB,0x1A,0x29
	.DB  0xFF,0x0,0x0,0xE,0xF,0x14,0xA,0xB
	.DB  0x1A,0x29,0xFF
_0x12:
	.DB  0xD0,0x2
_0x13:
	.DB  0xA,0x0,0x14,0x0,0x1E,0x0,0x28,0x0
	.DB  0x32,0x0,0x3C,0x0,0x46,0x0,0x50,0x0
	.DB  0x5A,0x0,0x64,0x0,0x6E,0x0,0x78
_0x27E:
	.DB  0x0,0xA,0x4,0xA,0x0,0xC,0x1,0x0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x09
	.DW  __SRAM_START
	.DW  __DSTACK_END_INIT*2

	.DW  0x09
	.DW  0x3A3
	.DW  __HSTACK_END_INIT*2

	.DW  0x01
	.DW  _flg_korr
	.DW  _0x3*2

	.DW  0x01
	.DW  _speed
	.DW  _0x4*2

	.DW  0x0B
	.DW  _budilnik_txt
	.DW  _0x5*2

	.DW  0x0C
	.DW  _korekt_txt
	.DW  _0x6*2

	.DW  0x0B
	.DW  _nastroiki_txt
	.DW  _0x7*2

	.DW  0x05
	.DW  _den_txt
	.DW  _0x8*2

	.DW  0x05
	.DW  _data_txt
	.DW  _0x9*2

	.DW  0x04
	.DW  _god_txt
	.DW  _0xA*2

	.DW  0x0B
	.DW  _nastr_stroki_txt
	.DW  _0xB*2

	.DW  0x19
	.DW  _speed_txt
	.DW  _0xC*2

	.DW  0x19
	.DW  _perenazna_datchik
	.DW  _0xD*2

	.DW  0x16
	.DW  _budilnik_Interval_txt
	.DW  _0xE*2

	.DW  0x54
	.DW  _den_nedeli_txt
	.DW  _0xF*2

	.DW  0x0E
	.DW  _den_nedeli_letter
	.DW  _0x10*2

	.DW  0x6B
	.DW  _name_mesec_txt
	.DW  _0x11*2

	.DW  0x02
	.DW  _time
	.DW  _0x12*2

	.DW  0x17
	.DW  _temperature_G000
	.DW  _0x13*2

	.DW  0x08
	.DW  0x04
	.DW  _0x27E*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/***********************************************************************************************
;   -  ATmega16/16L/32A/32L    (       3  )
;  - 8,000000 MHz
;**********************************************************************************************/
;#define   VER                1004      //    10-04-12 _____ 1.08 O-LED
;//*********************************************************************************************/
;//     
;#define   ATMEGA16          1
;#define   ATMEGA32          0
;//*********************************************************************************************/
;//     
;#define   OK                1         //    ""  (  5, 2, 7, 1, 12, 8, 14, 9  )
;#define   OA                0        //    ""  (  5, 2, 7, 1, 12, 8, 14, 9   )
;//*********************************************************************************************/
;//  FONT      ( 0  6)
;#define   FONT              5         //   
;//*********************************************************************************************/
;//**********************************************************************************************/
;#define   RET_CLOCK        120      //        ( )
;//*********************************************************************************************/
;
;# if ATMEGA16
;#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;# endif
;# if ATMEGA32
;#include <mega32.h>
;# endif
;
;#include <1wire.h>
;#include <ds18b20_.h>
;#include <delay.h>
;
;#define   BUT_OK      button==1
;#define   BUT_STEP    button==2
;#define   POWER       power
;#define   ON          1
;#define   OFF         0
;//*********************************************************************************************/
;
;bit                 mig, mig_vrem, flg_min=0,  sek0=0, bud_flg=0, budilnik=0, sek_ind=1, but_flg=0,  zv_kn=0,  zv_chs=1, but_on=0, line=0, power=1, temp5=0, flg_adch, flg_ds18b20;
;unsigned char       meny=10, sek=0, chislo=10, mesec=04, god=12, den_nedeli, td10=0, tu10=1,  bud_temp, stroka, button, but_pause=0,  z, z1, bud, temp, temp1=0, temp2=0, t, flg_korr=1, speed=28, foto_r=0,

	.DSEG
;
;                    ekran            [24],         //   
;                    beg_info         [99],         //     
;                    rom_code         [2][9],       //      DS18B20
;                    //column_ram       [24],//={16,22,23,11,13,8,14,15,21,19,1,7,6,0,5,3,20,18,17,12,10,9,4,2},         //        
;                    budilnik_Install [9],          //   
;                    budilnik_Interval[9];          //     
;unsigned   int      budilnik_time    [9];          //    
;const unsigned char
;        budilnik_txt          []= {11,29,14,18,21,38,23,18,20,42,255},       //  ""
;        korekt_txt            []= {20,24,26,26,15,20,32,18,41,42,42,255},    //  ""
;        nastroiki_txt         []= {29,27,28,10,23,24,12,20,18,42,255},       //  ""
;        den_txt               []= {14,15,23,38,255},                         //  ""
;        data_txt              []= {14,10,28,10,255},                         //  ""
;        god_txt               []= {13,24,14,255},                            //  ""
;        nastr_stroki_txt      []= {23,10,27,28,26,24,19,20,10,42,255},       //  ""
;        speed_txt             []= {27,20,24,26,24,27,28,38,42,11,15,13,29,35,15,19,42,27,28,26,24,20,18,42,255},  //  "  "
;        perenazna_datchik     []= {25,15,26,15,23,10,16,23,10,33,15,23,18,15,42,14,10,28,33,18,20,24,12,42,255},  //  " "
;        budilnik_Interval_txt []= {14,21,18,28,15,21,38,23,24,27,28,38,42,27,18,13,23,10,21,10,42,255},              //  " "
;        den_nedeli_txt  [7][12]= {{25,24,23,15,14,15,21,38,23,18,20,255},   //      //    
;                                 {12,28,24,26,23,18,20,255},                //          //
;                                 {27,26,15,14,10,255},                      //            //
;                                 {33,15,28,12,15,26,13,255},                //          //
;                                 {25,41,28,23,18,32,10,255},                //          //
;                                 {27,29,11,11,24,28,10,255},                //          //
;                                 {12,24,27,20,26,15,27,15,23,38,15,255}},   //      //
;        den_nedeli_letter[7][2]= {{25,23},                                  //               //     
;                                 {12,28},                                   //               //
;                                 {27,26},                                   //               //
;                                 {33,28},                                   //               //
;                                 {25,28},                                   //               //
;                                 {27,11},                                   //               //
;                                 {12,27}},                                  //               //
;        name_mesec_txt  [12][9]= {{41,23,12,10,26,41,255},                  // 
;                                 {30,15,12,26,10,21,41,255},                // 
;                                 {22,10,26,28,10,255},                      // 
;                                 {10,25,26,15,21,41,255},                   // 
;                                 {22,10,41,255},                            // 
;                                 {18,40,23,41,255},                         // 
;                                 {18,40,21,41,255},                         // 
;                                 {10,12,13,29,27,28,10,255},                // 
;                                 {27,15,23,28,41,11,26,41,255},             // 
;                                 {24,20,28,41,11,26,41,255},                // 
;                                 {23,24,41,11,26,41,255},                   // 
;                                 {14,15,20,10,11,26,41,255}};               // 
;flash  const unsigned char  simvol [][5]=
;    {
;    # if FONT==0    //    0
;    { 0x3E, 0x51, 0x49, 0x45, 0x3E },  // 0
;    { 0x00, 0x42, 0x7F, 0x40, 0x00 },  // 1
;    { 0x42, 0x61, 0x51, 0x49, 0x46 },  // 2
;    { 0x21, 0x41, 0x45, 0x4B, 0x31 },  // 3
;    { 0x18, 0x14, 0x12, 0x7F, 0x10 },  // 4
;    { 0x27, 0x45, 0x45, 0x45, 0x39 },  // 5
;    { 0x3C, 0x4A, 0x49, 0x49, 0x30 },  // 6
;    { 0x01, 0x71, 0x09, 0x05, 0x03 },  // 7
;    { 0x36, 0x49, 0x49, 0x49, 0x36 },  // 8
;    { 0x06, 0x49, 0x49, 0x29, 0x1E },  // 9
;    # endif
;    # if FONT==1    //    1
;    { 0x7F, 0x7F, 0x41, 0x7F, 0x7F },
;    { 0x00, 0x00, 0x7F, 0x7F, 0x00 },
;    { 0x61, 0x71, 0x59, 0x4F, 0x47 },
;    { 0x41, 0x49, 0x49, 0x7F, 0x7F },
;    { 0x1F, 0x1F, 0x10, 0x7F, 0x7F },
;    { 0x4F, 0x4F, 0x49, 0x79, 0x79 },
;    { 0x7F, 0x7F, 0x49, 0x79, 0x79 },
;    { 0x01, 0x71, 0x79, 0x0F, 0x07 },
;    { 0x7F, 0x7F, 0x49, 0x7F, 0x7F },
;    { 0x5F, 0x5F, 0x51, 0x7F, 0x7F },
;    # endif
;    # if FONT==2    //    2
;    { 0x7F, 0x7F, 0x41, 0x7F, 0x7F },
;    { 0x00, 0x01, 0x7F, 0x7F, 0x00 },
;    { 0x63, 0x73, 0x59, 0x4F, 0x47 },
;    { 0x63, 0x63, 0x49, 0x7F, 0x77 },
;    { 0x1F, 0x1F, 0x10, 0x7F, 0x7F },
;    { 0x6F, 0x6F, 0x49, 0x79, 0x79 },
;    { 0x7F, 0x7F, 0x49, 0x7B, 0x7B },
;    { 0x03, 0x73, 0x79, 0x0F, 0x07 },
;    { 0x77, 0x7F, 0x49, 0x7F, 0x77 },
;    { 0x6F, 0x6F, 0x49, 0x7F, 0x7F },
;    # endif
;    # if FONT==3    //    3
;    { 0x7F, 0x41, 0x41, 0x7F, 0x7F },
;    { 0x00, 0x00, 0x7F, 0x7F, 0x00 },
;    { 0x61, 0x71, 0x59, 0x4F, 0x47 },
;    { 0x41, 0x49, 0x49, 0x7F, 0x7F },
;    { 0x1F, 0x10, 0x10, 0x7F, 0x7F },
;    { 0x4F, 0x49, 0x49, 0x79, 0x79 },
;    { 0x7F, 0x49, 0x49, 0x79, 0x79 },
;    { 0x01, 0x01, 0x01, 0x7F, 0x7F },
;    { 0x7F, 0x49, 0x49, 0x7F, 0x7F },
;    { 0x1F, 0x11, 0x11, 0x7F, 0x7F },
;    # endif
;    # if FONT==4    //    4
;    { 0x7F, 0x41, 0x41, 0x7F, 0x7F },
;    { 0x00, 0x01, 0x7F, 0x7F, 0x00 },
;    { 0x63, 0x71, 0x59, 0x4F, 0x47 },
;    { 0x63, 0x41, 0x49, 0x7F, 0x7F },
;    { 0x1F, 0x10, 0x10, 0x7F, 0x7F },
;    { 0x6F, 0x49, 0x49, 0x79, 0x79 },
;    { 0x7F, 0x49, 0x49, 0x7B, 0x7B },
;    { 0x03, 0x01, 0x01, 0x7F, 0x7F },
;    { 0x7F, 0x49, 0x49, 0x7F, 0x7F },
;    { 0x1F, 0x11, 0x11, 0x7F, 0x7F },
;    # endif
;    # if FONT==5    //    5
;    { 0x3E, 0x7F, 0x41, 0x7F, 0x3E },
;    { 0x00, 0x02, 0x7F, 0x7F, 0x00 },
;    { 0x62, 0x73, 0x59, 0x4F, 0x46 },
;    { 0x22, 0x63, 0x49, 0x7F, 0x36 },
;    { 0x18, 0x14, 0x12, 0x7F, 0x7F },
;    { 0x2F, 0x6F, 0x45, 0x7D, 0x39 },
;    { 0x3E, 0x7F, 0x49, 0x7B, 0x32 },
;    { 0x03, 0x73, 0x79, 0x0F, 0x07 },
;    { 0x36, 0x7F, 0x49, 0x7F, 0x36 },
;    { 0x2E, 0x6F, 0x49, 0x7F, 0x3E },
;    # endif
;    # if FONT==6    //    6
;    { 0x3E, 0x41, 0x41, 0x7F, 0x3E },
;    { 0x00, 0x02, 0x7F, 0x7F, 0x00 },
;    { 0x62, 0x71, 0x59, 0x4F, 0x46 },
;    { 0x22, 0x41, 0x49, 0x7F, 0x36 },
;    { 0x18, 0x14, 0x12, 0x7F, 0x7F },
;    { 0x2F, 0x45, 0x45, 0x7D, 0x39 },
;    { 0x3E, 0x49, 0x49, 0x7B, 0x32 },
;    { 0x03, 0x71, 0x79, 0x0F, 0x07 },
;    { 0x36, 0x49, 0x49, 0x7F, 0x36 },
;    { 0x26, 0x49, 0x49, 0x7F, 0x3E },
;    # endif
;	{ 0x7C, 0x12, 0x12, 0x7C, 0xAA },  //   10
;	{ 0x7E, 0x4A, 0x4A, 0x32, 0xAA },  //   11
;	{ 0x7E, 0x4A, 0x4A, 0x34, 0xAA },  //   12
;	{ 0x7E, 0x02, 0x02, 0xAA, 0x00 },  //   13
;	{ 0x60, 0x3C, 0x22, 0x3E, 0x60 },  //   14
;	{ 0x7E, 0x4A, 0x4A, 0xAA, 0x00 },  //   15
;	{ 0x24, 0x42, 0x4A, 0x34, 0x00 },  //   16
;	{ 0x66, 0x18, 0x7E, 0x18, 0x66 },  //   17
;	{ 0x7E, 0x10, 0x08, 0x7E, 0xAA },  //   18
;	{ 0x7C, 0x11, 0x09, 0x7C, 0xAA },  //   19
;	{ 0x7E, 0x18, 0x24, 0x42, 0xAA },  //   20
;	{ 0x78, 0x04, 0x02, 0x7E, 0xAA },  //   21
;	{ 0x7E, 0x04, 0x08, 0x04, 0x7E },  //   22
;	{ 0x7E, 0x08, 0x08, 0x7E, 0xAA },  //   23
;	{ 0x3C, 0x42, 0x42, 0x3C, 0xAA },  //   24
;	{ 0x7E, 0x02, 0x02, 0x7E, 0xAA },  //   25
;	{ 0x7E, 0x12, 0x12, 0x0C, 0xAA },  //   26
;	{ 0x3C, 0x42, 0x42, 0x24, 0xAA },  //   27
;	{ 0x02, 0x7E, 0x02, 0xAA, 0x00 },  //   28
;	{ 0x4E, 0x50, 0x50, 0x3E, 0xAA },  //   29
;	{ 0x0C, 0x12, 0x7E, 0x12, 0x0C },  //   30
;	{ 0x66, 0x18, 0x18, 0x66, 0xAA },  //   31
;	{ 0x7E, 0x40, 0x40, 0x7E, 0xC0 },  //   32
;	{ 0x0E, 0x10, 0x10, 0x7E, 0xAA },  //   33
;	{ 0x7E, 0x40, 0x7E, 0x40, 0x7E },  //   34
;	{ 0x7E, 0x40, 0x7E, 0x40, 0xFE },  //   35
;	{ 0x02, 0x7E, 0x48, 0x30, 0xAA },  //   36
;	{ 0x7E, 0x48, 0x30, 0x00, 0x7E },  //   37
;	{ 0x7E, 0x48, 0x30, 0xAA, 0x00 },  //   38
;	{ 0x24, 0x42, 0x4A, 0x3C, 0xAA },  //   39
;	{ 0x7E, 0x08, 0x3C, 0x42, 0x3C },  //   40
;	{ 0x4C, 0x32, 0x12, 0x7E, 0xAA },  //   41
;	{ 0x00, 0x00, 0xAA, 0xAA, 0x00 },  //               42
;    { 0x40, 0xAA, 0xAA, 0xAA, 0x00 },  //                43
;    { 0xAA, 0xAA, 0xAA, 0xAA, 0x00 },  //      44
;    { 0x00, 0x00, 0x00, 0x00, 0x00 },  // ""      45
;    { 0x08, 0x08, 0x08, 0x08, 0x08 },  //                46
;	{ 0x08, 0x08, 0x3E, 0x08, 0x08 },  //                 47
;	{ 0x06, 0x09, 0x09, 0x06, 0xAA },  //          48
;    { 0x3E, 0x41, 0x41, 0x41, 0x22 },  //  C           49
;    { 0x04, 0x3F, 0x44, 0x20, 0xAA },  //  t         50
;    { 0x08, 0x08, 0x08, 0xAA, 0x00 },  //       51
;    { 0x3F, 0x40, 0x40, 0x3f, 0x00 },  //   V        52
;    { 0x40, 0x40, 0x40, 0xAA, 0x00 },  //  _     53
;    { 0x80, 0xAA, 0xAA, 0xAA, 0xAA },  //   _       54
;    { 0x00, 0x00, 0x00, 0x00, 0x00 },  //               55
;
;    },
;
;
;dnei_v_mesc     []= {31,29,31,30,31,30,31,31,30,31,30,31};           //    
;unsigned   int          time=720 , Interval , Interval_2, data1, time_meny ;          //     time=720
;float                   temperature_temp;
;eeprom signed int       korr_den, brigh_up_time, brigh_down_time;
;eeprom unsigned char    brigh_up, str=0x1B; //0x18;
;static unsigned char    devices, i;
;static  signed   int    temperature [12]={10,20,30,40,50,60,70,80,90,100,110,120};
;eeprom char ds1820_d, ds1820_y;
;unsigned char  error_ds18b20[];
;
;//___________________________   _____________________________________
;signed int abs (signed int x)
; 0000 00EB {

	.CSEG
_abs:
; 0000 00EC if (x<0) x=(x*(-1));
;	x -> Y+0
	LDD  R26,Y+1
	TST  R26
	BRPL _0x14
	LD   R30,Y
	LDD  R31,Y+1
	LDI  R26,LOW(65535)
	LDI  R27,HIGH(65535)
	CALL __MULW12
	ST   Y,R30
	STD  Y+1,R31
; 0000 00ED return x;
_0x14:
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R28,2
	RET
; 0000 00EE }
;
;//______    (  DANKO c  "" )))  )_________
;unsigned char Day_week (void)
; 0000 00F2 {
_Day_week:
; 0000 00F3 unsigned char y, m, myday;
; 0000 00F4 
; 0000 00F5    y = god;
	CALL __SAVELOCR4
;	y -> R17
;	m -> R16
;	myday -> R19
	MOV  R17,R9
; 0000 00F6    m = mesec;
	MOV  R16,R6
; 0000 00F7 
; 0000 00F8    if (m > 2) { m -= 2;       }
	CPI  R16,3
	BRLO _0x15
	MOV  R30,R16
	LDI  R31,0
	SBIW R30,2
	MOV  R16,R30
; 0000 00F9    else       { m += 10; y--; }
	RJMP _0x16
_0x15:
	SUBI R16,-LOW(10)
	SUBI R17,1
_0x16:
; 0000 00FA 
; 0000 00FB    myday = ((chislo + y + (y>>2) + ((31 * m) / 12)) % 7);
	MOV  R26,R7
	CLR  R27
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL SUBOPT_0x0
	CALL __ASRW2
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDI  R26,LOW(31)
	MUL  R16,R26
	MOVW R30,R0
	MOVW R26,R30
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	CALL __DIVW21
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	CALL __MODW21
	MOV  R19,R30
; 0000 00FC 
; 0000 00FD    if (myday)  return myday-1;  else  return  6;
	CPI  R19,0
	BREQ _0x17
	CALL SUBOPT_0x1
	SBIW R30,1
	CALL __LOADLOCR4
	RJMP _0x2020007
_0x17:
	LDI  R30,LOW(6)
	CALL __LOADLOCR4
	RJMP _0x2020007
; 0000 00FE }
;
;//___________________________________________ ___________________________________________
;void correkt (void)
; 0000 0102 {
_correkt:
; 0000 0103         if(korr_den<0) {TCNT2=255+((korr_den%10)*25); sek=59+((korr_den%600)/10);
	CALL SUBOPT_0x2
	BRPL _0x19
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	SUBI R30,-LOW(255)
	OUT  0x24,R30
	CALL SUBOPT_0x3
	CALL SUBOPT_0x5
	SUBI R30,-LOW(59)
	MOV  R4,R30
; 0000 0104                            if (sek==60) {sek=0;}
	LDI  R30,LOW(60)
	CP   R30,R4
	BRNE _0x1A
	CLR  R4
; 0000 0105                             time=1439;
_0x1A:
	LDI  R30,LOW(1439)
	LDI  R31,HIGH(1439)
	STS  _time,R30
	STS  _time+1,R31
; 0000 0106                         }
; 0000 0107         else {TCNT2=25*(korr_den%10); sek=((korr_den%600)/10);}
	RJMP _0x1B
_0x19:
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	OUT  0x24,R30
	CALL SUBOPT_0x3
	CALL SUBOPT_0x5
	MOV  R4,R30
_0x1B:
; 0000 0108 }
	RET
;
;
;//____________________________ . (  )________________________________
;interrupt [TIM0_COMP] void timer0_comp_isr(void)
; 0000 010D {
_timer0_comp_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 010E PORTA=0;     //        
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 010F PORTB&=0xFC; //           /---/
	IN   R30,0x18
	ANDI R30,LOW(0xFC)
	OUT  0x18,R30
; 0000 0110 PORTC=0;     //           /---/
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 0111 PORTD=0;     //           /---/
	OUT  0x12,R30
; 0000 0112 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;//________ .          _______________
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0116 {
_timer0_ovf_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0117 
; 0000 0118 //flg_din=1;
; 0000 0119 
; 0000 011A         stroka >>= 1;  if (stroka==0)  stroka=0b10000000;    //    
	MOV  R30,R12
	LDI  R31,0
	ASR  R31
	ROR  R30
	MOV  R12,R30
	TST  R12
	BRNE _0x1C
	LDI  R30,LOW(128)
	MOV  R12,R30
; 0000 011B         if (stroka==0b00000001)  PORTB.7= 1;  else  PORTB.7=0;
_0x1C:
	LDI  R30,LOW(1)
	CP   R30,R12
	BRNE _0x1D
	SBI  0x18,7
	RJMP _0x20
_0x1D:
	CBI  0x18,7
; 0000 011C 
; 0000 011D         PORTB.6=1;    //
_0x20:
	SBI  0x18,6
; 0000 011E 
; 0000 011F         //*********** ***************************
; 0000 0120         if(flg_adch)                    //       
	SBRS R3,6
	RJMP _0x25
; 0000 0121         {
; 0000 0122         flg_adch=0;                     //  ""  
	CLT
	BLD  R3,6
; 0000 0123         PORTA.7=0; DDRA.7=0;            //  .7   ,         ,
	CBI  0x1B,7
	CBI  0x1A,7
; 0000 0124         ADCSRA=0b11000011;              //   (   )
	LDI  R30,LOW(195)
	OUT  0x6,R30
; 0000 0125         while (ADCSRA&0b01000000){}     //     
_0x2A:
	SBIC 0x6,6
	RJMP _0x2A
; 0000 0126         DDRA.7=1;                       //  .7   
	SBI  0x1A,7
; 0000 0127         }
; 0000 0128         //***********************************************************
; 0000 0129 
; 0000 012A 
; 0000 012B         # if  OK
; 0000 012C         PORTC.3 = (ekran [0] & stroka);
_0x25:
	MOV  R30,R12
	LDS  R26,_ekran
	AND  R30,R26
	BRNE _0x2F
	CBI  0x15,3
	RJMP _0x30
_0x2F:
	SBI  0x15,3
_0x30:
; 0000 012D         PORTC.0 = (ekran [1] & stroka);
	__GETB1MN _ekran,1
	AND  R30,R12
	BRNE _0x31
	CBI  0x15,0
	RJMP _0x32
_0x31:
	SBI  0x15,0
_0x32:
; 0000 012E         PORTD.7 = (ekran [2] & stroka);
	__GETB1MN _ekran,2
	AND  R30,R12
	BRNE _0x33
	CBI  0x12,7
	RJMP _0x34
_0x33:
	SBI  0x12,7
_0x34:
; 0000 012F         PORTC.5 = (ekran [3] & stroka);
	__GETB1MN _ekran,3
	AND  R30,R12
	BRNE _0x35
	CBI  0x15,5
	RJMP _0x36
_0x35:
	SBI  0x15,5
_0x36:
; 0000 0130         PORTD.6 = (ekran [4] & stroka);
	__GETB1MN _ekran,4
	AND  R30,R12
	BRNE _0x37
	CBI  0x12,6
	RJMP _0x38
_0x37:
	SBI  0x12,6
_0x38:
; 0000 0131         PORTC.4 = (ekran [5] & stroka);
	__GETB1MN _ekran,5
	AND  R30,R12
	BRNE _0x39
	CBI  0x15,4
	RJMP _0x3A
_0x39:
	SBI  0x15,4
_0x3A:
; 0000 0132         PORTC.2 = (ekran [6] & stroka);
	__GETB1MN _ekran,6
	AND  R30,R12
	BRNE _0x3B
	CBI  0x15,2
	RJMP _0x3C
_0x3B:
	SBI  0x15,2
_0x3C:
; 0000 0133         PORTC.1 = (ekran [7] & stroka);
	__GETB1MN _ekran,7
	AND  R30,R12
	BRNE _0x3D
	CBI  0x15,1
	RJMP _0x3E
_0x3D:
	SBI  0x15,1
_0x3E:
; 0000 0134         PORTA.5 = (ekran [8] & stroka);
	__GETB1MN _ekran,8
	AND  R30,R12
	BRNE _0x3F
	CBI  0x1B,5
	RJMP _0x40
_0x3F:
	SBI  0x1B,5
_0x40:
; 0000 0135         PORTD.5 = (ekran [9] & stroka);
	__GETB1MN _ekran,9
	AND  R30,R12
	BRNE _0x41
	CBI  0x12,5
	RJMP _0x42
_0x41:
	SBI  0x12,5
_0x42:
; 0000 0136         PORTD.4 = (ekran [10] & stroka);
	__GETB1MN _ekran,10
	AND  R30,R12
	BRNE _0x43
	CBI  0x12,4
	RJMP _0x44
_0x43:
	SBI  0x12,4
_0x44:
; 0000 0137         PORTA.3 = (ekran [11] & stroka);
	__GETB1MN _ekran,11
	AND  R30,R12
	BRNE _0x45
	CBI  0x1B,3
	RJMP _0x46
_0x45:
	SBI  0x1B,3
_0x46:
; 0000 0138         PORTD.3 = (ekran [12] & stroka);
	__GETB1MN _ekran,12
	AND  R30,R12
	BRNE _0x47
	CBI  0x12,3
	RJMP _0x48
_0x47:
	SBI  0x12,3
_0x48:
; 0000 0139         PORTA.4 = (ekran [13] & stroka);
	__GETB1MN _ekran,13
	AND  R30,R12
	BRNE _0x49
	CBI  0x1B,4
	RJMP _0x4A
_0x49:
	SBI  0x1B,4
_0x4A:
; 0000 013A         PORTA.6 = (ekran [14] & stroka);
	__GETB1MN _ekran,14
	AND  R30,R12
	BRNE _0x4B
	CBI  0x1B,6
	RJMP _0x4C
_0x4B:
	SBI  0x1B,6
_0x4C:
; 0000 013B         PORTA.7 = (ekran [15] & stroka);
	__GETB1MN _ekran,15
	AND  R30,R12
	BRNE _0x4D
	CBI  0x1B,7
	RJMP _0x4E
_0x4D:
	SBI  0x1B,7
_0x4E:
; 0000 013C         PORTA.0 = (ekran [16] & stroka);
	__GETB1MN _ekran,16
	AND  R30,R12
	BRNE _0x4F
	CBI  0x1B,0
	RJMP _0x50
_0x4F:
	SBI  0x1B,0
_0x50:
; 0000 013D         PORTD.2 = (ekran [17] & stroka);
	__GETB1MN _ekran,17
	AND  R30,R12
	BRNE _0x51
	CBI  0x12,2
	RJMP _0x52
_0x51:
	SBI  0x12,2
_0x52:
; 0000 013E         PORTD.1 = (ekran [18] & stroka);
	__GETB1MN _ekran,18
	AND  R30,R12
	BRNE _0x53
	CBI  0x12,1
	RJMP _0x54
_0x53:
	SBI  0x12,1
_0x54:
; 0000 013F         PORTB.1 = (ekran [19] & stroka);
	__GETB1MN _ekran,19
	AND  R30,R12
	BRNE _0x55
	CBI  0x18,1
	RJMP _0x56
_0x55:
	SBI  0x18,1
_0x56:
; 0000 0140         PORTD.0 = (ekran [20] & stroka);
	__GETB1MN _ekran,20
	AND  R30,R12
	BRNE _0x57
	CBI  0x12,0
	RJMP _0x58
_0x57:
	SBI  0x12,0
_0x58:
; 0000 0141         PORTB.0 = (ekran [21] & stroka);
	__GETB1MN _ekran,21
	AND  R30,R12
	BRNE _0x59
	CBI  0x18,0
	RJMP _0x5A
_0x59:
	SBI  0x18,0
_0x5A:
; 0000 0142         PORTA.1 = (ekran [22] & stroka);
	__GETB1MN _ekran,22
	AND  R30,R12
	BRNE _0x5B
	CBI  0x1B,1
	RJMP _0x5C
_0x5B:
	SBI  0x1B,1
_0x5C:
; 0000 0143         PORTA.2 = (ekran [23] & stroka);
	__GETB1MN _ekran,23
	AND  R30,R12
	BRNE _0x5D
	CBI  0x1B,2
	RJMP _0x5E
_0x5D:
	SBI  0x1B,2
_0x5E:
; 0000 0144         # endif
; 0000 0145         # if OA
; 0000 0146         PORTC.1 = (ekran [0] & stroka);   //0
; 0000 0147         PORTC.3 = (ekran [1] & stroka);   //1
; 0000 0148         PORTD.5 = (ekran [2] & stroka);   //2
; 0000 0149         PORTC.2 = (ekran [3] & stroka);   //3
; 0000 014A         PORTD.3 = (ekran [4] & stroka);   //4
; 0000 014B         PORTD.6 = (ekran [5] & stroka);   //5
; 0000 014C         PORTD.4 = (ekran [6] & stroka);   //6
; 0000 014D         PORTD.7 = (ekran [7] & stroka);   //7
; 0000 014E         PORTD.1 = (ekran [8] & stroka);   //8
; 0000 014F         PORTD.2 = (ekran [9] & stroka);   //9
; 0000 0150         PORTA.3 = (ekran [10] & stroka);  //10
; 0000 0151         PORTD.0 = (ekran [11] & stroka);  //11
; 0000 0152         PORTB.1 = (ekran [12] & stroka);  //12
; 0000 0153         PORTA.2 = (ekran [13] & stroka);  //13
; 0000 0154         PORTB.0 = (ekran [14] & stroka);  //14
; 0000 0155         PORTA.0 = (ekran [15] & stroka);  //15
; 0000 0156         PORTA.1 = (ekran [16] & stroka);  //16
; 0000 0157         PORTA.4 = (ekran [17] & stroka);  //17
; 0000 0158         PORTC.0 = (ekran [18] & stroka);  //18
; 0000 0159         PORTA.7 = (ekran [19] & stroka);  //19
; 0000 015A         PORTA.5 = (ekran [20] & stroka);  //20
; 0000 015B         PORTC.4 = (ekran [21] & stroka);  //21
; 0000 015C         PORTA.6 = (ekran [22] & stroka);  //22
; 0000 015D         PORTC.5 = (ekran [23] & stroka);  //23
; 0000 015E         # endif
; 0000 015F 
; 0000 0160 
; 0000 0161 
; 0000 0162         PORTB.6=0;
	CBI  0x18,6
; 0000 0163 
; 0000 0164 
; 0000 0165         but_pause++;  if (but_pause==100)      { but_pause=0; but_on=1; }                 //         0,3  -    
	LDS  R30,_but_pause
	SUBI R30,-LOW(1)
	STS  _but_pause,R30
	LDS  R26,_but_pause
	CPI  R26,LOW(0x64)
	BRNE _0x61
	LDI  R30,LOW(0)
	STS  _but_pause,R30
	SET
	BLD  R3,2
; 0000 0166         if ((but_pause==30)&&(but_flg))        { but_flg=0; PORTB.5=0; TIMSK&=0xEF;}       //  ""   
_0x61:
	LDS  R26,_but_pause
	CPI  R26,LOW(0x1E)
	BRNE _0x63
	SBRC R2,7
	RJMP _0x64
_0x63:
	RJMP _0x62
_0x64:
	CLT
	BLD  R2,7
	CBI  0x18,5
	IN   R30,0x39
	ANDI R30,0xEF
	OUT  0x39,R30
; 0000 0167 
; 0000 0168         Interval++;   Interval_2++;                                                       //         
_0x62:
	LDI  R26,LOW(_Interval)
	LDI  R27,HIGH(_Interval)
	CALL SUBOPT_0x6
	LDI  R26,LOW(_Interval_2)
	LDI  R27,HIGH(_Interval_2)
	CALL SUBOPT_0x6
; 0000 0169 
; 0000 016A }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;
;//___________________________________  _______________________________________________
;unsigned char  button_read (void)
; 0000 016E {
_button_read:
; 0000 016F button=0;
	LDI  R30,LOW(0)
	STS  _button,R30
; 0000 0170 
; 0000 0171 if ( (PINB.2==0) && (but_on))
	LDI  R26,0
	SBIC 0x16,2
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x68
	SBRC R3,2
	RJMP _0x69
_0x68:
	RJMP _0x67
_0x69:
; 0000 0172 {
; 0000 0173 but_on=0;  but_pause=0;
	CLT
	BLD  R3,2
	LDI  R30,LOW(0)
	STS  _but_pause,R30
; 0000 0174 
; 0000 0175     switch (stroka)
	MOV  R30,R12
	LDI  R31,0
; 0000 0176         {
; 0000 0177         case 0b10000000: button=2;                             //  
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x6D
	LDI  R30,LOW(2)
	RJMP _0x258
; 0000 0178         break;
; 0000 0179         case 0b00000001: button=1;
_0x6D:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x6C
	LDI  R30,LOW(1)
_0x258:
	STS  _button,R30
; 0000 017A         break;
; 0000 017B         }
_0x6C:
; 0000 017C time_meny=0;
	CALL SUBOPT_0x7
; 0000 017D if (zv_kn) {but_flg=1; TIMSK|=0x10;}//    -       .
	SBRS R3,0
	RJMP _0x6F
	SET
	BLD  R2,7
	IN   R30,0x39
	ORI  R30,0x10
	OUT  0x39,R30
; 0000 017E if (bud_flg) {bud_flg=0; button=0;} //  (  )  .             .
_0x6F:
	SBRS R2,4
	RJMP _0x70
	CLT
	BLD  R2,4
	LDI  R30,LOW(0)
	STS  _button,R30
; 0000 017F bud_flg=0;
_0x70:
	CLT
	BLD  R2,4
; 0000 0180 }
; 0000 0181 return  button;
_0x67:
	LDS  R30,_button
	RET
; 0000 0182 }
;
;//______  (        )______
;interrupt [ANA_COMP] void ana_comp_isr(void)
; 0000 0186 {
_ana_comp_isr:
	CALL SUBOPT_0x8
; 0000 0187         if(ACSR&0x20)                //    
	SBIS 0x8,5
	RJMP _0x71
; 0000 0188         {
; 0000 0189         POWER = OFF;                 //      
	CLT
	BLD  R3,4
; 0000 018A         # if  ATMEGA16
; 0000 018B         MCUCR=0b01110000;            //      SLEEP ( 16)
	LDI  R30,LOW(112)
	OUT  0x35,R30
; 0000 018C         # endif
; 0000 018D         # if  (ATMEGA32)
; 0000 018E         MCUCR=0b10110000;            //      SLEEP ( 32)
; 0000 018F         # endif
; 0000 0190         TCCR0=0x00;                  //  /0
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0191         ADCSRA=0x00;                 //  
	OUT  0x6,R30
; 0000 0192         TIMSK&=0x7f;                 //     2
	IN   R30,0x39
	ANDI R30,0x7F
	OUT  0x39,R30
; 0000 0193         ADMUX= 0b00100111;           //    
	LDI  R30,LOW(39)
	OUT  0x7,R30
; 0000 0194         PORTA=0;  DDRB=0b11110111;   //      
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	LDI  R30,LOW(247)
	OUT  0x17,R30
; 0000 0195         PORTB=0; PORTC=0; PORTD=0;
	LDI  R30,LOW(0)
	OUT  0x18,R30
	OUT  0x15,R30
	OUT  0x12,R30
; 0000 0196         }
; 0000 0197         else                         //      
	RJMP _0x72
_0x71:
; 0000 0198         {
; 0000 0199         devices=w1_search(0xf0,rom_code);//    "" /  DS18B20,      ""
	CALL SUBOPT_0x9
; 0000 019A         POWER = ON;                  //    
	SET
	BLD  R3,4
; 0000 019B         MCUCR=0b00110000;            //       SLEEP
	LDI  R30,LOW(48)
	OUT  0x35,R30
; 0000 019C         DDRB=0xE3;                   //      
	LDI  R30,LOW(227)
	OUT  0x17,R30
; 0000 019D         TCCR0=0x03;                  //  /0
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 019E         ADCSRA=0b10000011;           //  
	LDI  R30,LOW(131)
	OUT  0x6,R30
; 0000 019F         TIMSK|=0x80;                 //     2
	IN   R30,0x39
	ORI  R30,0x80
	OUT  0x39,R30
; 0000 01A0         ADMUX= 0b01100111;           //    
	LDI  R30,LOW(103)
	OUT  0x7,R30
; 0000 01A1        if (devices==1){if (ds1820_d!=0)ds1820_d=0; if(ds1820_y!=1)ds1820_y=1;}
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRNE _0x73
	LDI  R26,LOW(_ds1820_d)
	LDI  R27,HIGH(_ds1820_d)
	CALL __EEPROMRDB
	CPI  R30,0
	BREQ _0x74
	CALL SUBOPT_0xA
_0x74:
	LDI  R26,LOW(_ds1820_y)
	LDI  R27,HIGH(_ds1820_y)
	CALL __EEPROMRDB
	CPI  R30,LOW(0x1)
	BREQ _0x75
	LDI  R26,LOW(_ds1820_y)
	LDI  R27,HIGH(_ds1820_y)
	LDI  R30,LOW(1)
	CALL __EEPROMWRB
_0x75:
; 0000 01A2 
; 0000 01A3         }
_0x73:
_0x72:
; 0000 01A4 }
	RJMP _0x27D
;
;//__________________________________________ __________________________________________________
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)
; 0000 01A8 {
_timer1_compa_isr:
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 01A9 static char dl_1=0,dl_2=0;
; 0000 01AA dl_2++; if (dl_2>=150) {dl_2=0; dl_1++;  if (dl_1>=5) dl_1=0; }
	LDS  R30,_dl_2_S0000007000
	SUBI R30,-LOW(1)
	STS  _dl_2_S0000007000,R30
	LDS  R26,_dl_2_S0000007000
	CPI  R26,LOW(0x96)
	BRLO _0x76
	LDI  R30,LOW(0)
	STS  _dl_2_S0000007000,R30
	LDS  R30,_dl_1_S0000007000
	SUBI R30,-LOW(1)
	STS  _dl_1_S0000007000,R30
	LDS  R26,_dl_1_S0000007000
	CPI  R26,LOW(0x5)
	BRLO _0x77
	LDI  R30,LOW(0)
	STS  _dl_1_S0000007000,R30
_0x77:
; 0000 01AB if (but_flg) OCR1A=20;      //   ""   ,  ""   
_0x76:
	SBRS R2,7
	RJMP _0x78
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP _0x259
; 0000 01AC else  OCR1A = dl_1+3;      //   "" ,   ""
_0x78:
	LDS  R30,_dl_1_S0000007000
	LDI  R31,0
	ADIW R30,3
_0x259:
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 01AD PORTB ^= (1 << 5);
	IN   R30,0x18
	LDI  R26,LOW(32)
	EOR  R30,R26
	OUT  0x18,R30
; 0000 01AE }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	RETI
;
;//____________________________  ________________________________
;interrupt [TIM2_COMP] void timer2_comp_isr(void)
; 0000 01B2 {
_timer2_comp_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 01B3 
; 0000 01B4 if (foto_r)                           //   
	LDS  R30,_foto_r
	CPI  R30,0
	BREQ _0x7A
; 0000 01B5     {
; 0000 01B6     flg_adch=1;                       //   
	SET
	BLD  R3,6
; 0000 01B7     if (ADCH > brigh_up*70/100)       //  ""  70%
	IN   R22,5
	CALL SUBOPT_0xB
	LDI  R26,LOW(70)
	MUL  R30,R26
	MOVW R30,R0
	CALL SUBOPT_0xC
	MOV  R26,R22
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x7B
; 0000 01B8         {
; 0000 01B9         TIMSK&=0xFD;                  //      (     )
	IN   R30,0x39
	ANDI R30,0xFD
	RJMP _0x25A
; 0000 01BA         }
; 0000 01BB     else                              //  ""  70%
_0x7B:
; 0000 01BC         {
; 0000 01BD         OCR0=ADCH;                    //    .
	IN   R30,0x5
	OUT  0x3C,R30
; 0000 01BE         if (OCR0<20) OCR0=10;         //   ,         0
	IN   R30,0x3C
	CPI  R30,LOW(0x14)
	BRSH _0x7D
	LDI  R30,LOW(10)
	OUT  0x3C,R30
; 0000 01BF         TIMSK|=0x02;                  //     0
_0x7D:
	IN   R30,0x39
	ORI  R30,2
_0x25A:
	OUT  0x39,R30
; 0000 01C0         }
; 0000 01C1     }
; 0000 01C2 else                                  //    
	RJMP _0x7E
_0x7A:
; 0000 01C3     {
; 0000 01C4     if (brigh_down_time<brigh_up_time)//     ""    ( )
	CALL SUBOPT_0xD
	MOVW R0,R30
	CALL SUBOPT_0xE
	CP   R0,R30
	CPC  R1,R31
	BRGE _0x7F
; 0000 01C5         {
; 0000 01C6         if ( (time>=brigh_down_time)&&(time<brigh_up_time) )//
	CALL SUBOPT_0xD
	CALL SUBOPT_0xF
	BRLO _0x81
	CALL SUBOPT_0xE
	CALL SUBOPT_0xF
	BRLO _0x82
_0x81:
	RJMP _0x80
_0x82:
; 0000 01C7             {
; 0000 01C8             OCR0=(brigh_up*23)+1;     //    .
	CALL SUBOPT_0xB
	CALL SUBOPT_0x10
; 0000 01C9             TIMSK|=0x02;              //     0
	RJMP _0x25B
; 0000 01CA             }
; 0000 01CB         else                          //
_0x80:
; 0000 01CC             {
; 0000 01CD             TIMSK&=0xFD;              //      (     )
	IN   R30,0x39
	ANDI R30,0xFD
_0x25B:
	OUT  0x39,R30
; 0000 01CE             }
; 0000 01CF         }
; 0000 01D0     else                              //     ""    ( )
	RJMP _0x84
_0x7F:
; 0000 01D1         {
; 0000 01D2         if ( (time<brigh_down_time)&&(time>=brigh_up_time) )//
	CALL SUBOPT_0xD
	CALL SUBOPT_0xF
	BRSH _0x86
	CALL SUBOPT_0xE
	CALL SUBOPT_0xF
	BRSH _0x87
_0x86:
	RJMP _0x85
_0x87:
; 0000 01D3             {
; 0000 01D4             TIMSK&=0xFD;              //      (     )
	IN   R30,0x39
	ANDI R30,0xFD
	RJMP _0x25C
; 0000 01D5             }
; 0000 01D6         else                          //
_0x85:
; 0000 01D7             {
; 0000 01D8             OCR0=(brigh_up*23)+1;     //    .
	CALL SUBOPT_0xB
	CALL SUBOPT_0x10
; 0000 01D9             TIMSK|=0x02;              //     0
_0x25C:
	OUT  0x39,R30
; 0000 01DA             }
; 0000 01DB         }
_0x84:
; 0000 01DC     }
_0x7E:
; 0000 01DD //_______________________________________________________________________________
; 0000 01DE flg_ds18b20=1; //        
	SET
	BLD  R3,7
; 0000 01DF }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;//____________________________________________ ________________________________________________
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 01E3 
; 0000 01E4 {
_timer2_ovf_isr:
	CALL SUBOPT_0x8
; 0000 01E5 mig++;
	LDI  R30,LOW(1)
	EOR  R2,R30
; 0000 01E6 sek++;     //   
	INC  R4
; 0000 01E7 if(!mig_vrem) time_meny++;  else  time_meny=0;
	SBRC R2,1
	RJMP _0x89
	LDI  R26,LOW(_time_meny)
	LDI  R27,HIGH(_time_meny)
	CALL SUBOPT_0x6
	RJMP _0x8A
_0x89:
	CALL SUBOPT_0x7
; 0000 01E8 if (sek==60)
_0x8A:
	LDI  R30,LOW(60)
	CP   R30,R4
	BREQ PC+3
	JMP _0x8B
; 0000 01E9         {sek=0; time++; flg_min=1;
	CLR  R4
	LDI  R26,LOW(_time)
	LDI  R27,HIGH(_time)
	CALL SUBOPT_0x6
	SET
	BLD  R2,2
; 0000 01EA          if (time==1440)
	CALL SUBOPT_0x11
	CPI  R26,LOW(0x5A0)
	LDI  R30,HIGH(0x5A0)
	CPC  R27,R30
	BRNE _0x8C
; 0000 01EB                 {
; 0000 01EC                 if(flg_korr)  {correkt(); flg_korr=0;  if(korr_den<0) goto m2;}  //   00-00,       -  .
	LDS  R30,_flg_korr
	CPI  R30,0
	BREQ _0x8D
	RCALL _correkt
	LDI  R30,LOW(0)
	STS  _flg_korr,R30
	CALL SUBOPT_0x2
	BRMI _0x8F
; 0000 01ED                 time=0;  chislo++; if (chislo > dnei_v_mesc[mesec-1])
_0x8D:
	LDI  R30,LOW(0)
	STS  _time,R30
	STS  _time+1,R30
	INC  R7
	CALL SUBOPT_0x12
	SUBI R30,LOW(-_dnei_v_mesc*2)
	SBCI R31,HIGH(-_dnei_v_mesc*2)
	LPM  R30,Z
	CP   R30,R7
	BRSH _0x90
; 0000 01EE                         {chislo=1; mesec++; if (mesec==13)
	LDI  R30,LOW(1)
	MOV  R7,R30
	INC  R6
	LDI  R30,LOW(13)
	CP   R30,R6
	BRNE _0x91
; 0000 01EF                                 {mesec=1; god++;
	LDI  R30,LOW(1)
	MOV  R6,R30
	INC  R9
; 0000 01F0                                 }
; 0000 01F1                         }
_0x91:
; 0000 01F2                 if ( (god%4) && (mesec==2) && (chislo==29) )  {mesec=3; chislo=1;}      //   ,  29.02>>>>>01.03
_0x90:
	MOV  R26,R9
	CLR  R27
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CALL __MODW21
	SBIW R30,0
	BREQ _0x93
	LDI  R30,LOW(2)
	CP   R30,R6
	BRNE _0x93
	LDI  R30,LOW(29)
	CP   R30,R7
	BREQ _0x94
_0x93:
	RJMP _0x92
_0x94:
	LDI  R30,LOW(3)
	MOV  R6,R30
	LDI  R30,LOW(1)
	MOV  R7,R30
; 0000 01F3                 flg_korr=1;
_0x92:
	LDI  R30,LOW(1)
	STS  _flg_korr,R30
; 0000 01F4                 m2:
_0x8F:
; 0000 01F5                 }
; 0000 01F6         }
_0x8C:
; 0000 01F7 
; 0000 01F8 
; 0000 01F9 
; 0000 01FA }
_0x8B:
_0x27D:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;
;
;
;//______________________     +    _________________________
; void ekran_cifri (unsigned  int data)
; 0000 0201 {
_ekran_cifri:
; 0000 0202     unsigned char           x,x1,x2,x3,y,y1,y2,y3,temp;
; 0000 0203     static unsigned char    Shift_zn;
; 0000 0204 
; 0000 0205 
; 0000 0206 x  =  data/600;              // 
	SBIW R28,3
	CALL __SAVELOCR6
;	data -> Y+9
;	x -> R17
;	x1 -> R16
;	x2 -> R19
;	x3 -> R18
;	y -> R21
;	y1 -> R20
;	y2 -> Y+8
;	y3 -> Y+7
;	temp -> Y+6
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CALL SUBOPT_0x13
	MOV  R17,R30
; 0000 0207 x1 =  (data%600)/60;
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CALL SUBOPT_0x14
	MOV  R16,R30
; 0000 0208 x2 =  (data%60)/10;
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CALL SUBOPT_0x15
	MOV  R19,R30
; 0000 0209 x3 =  data%10;
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CALL SUBOPT_0x16
	MOV  R18,R30
; 0000 020A 
; 0000 020B y  =  data1/600;
	CALL SUBOPT_0x17
	CALL SUBOPT_0x13
	MOV  R21,R30
; 0000 020C y1 =  (data1%600)/60;
	CALL SUBOPT_0x17
	CALL SUBOPT_0x14
	MOV  R20,R30
; 0000 020D y2 =  (data1%60)/10;
	CALL SUBOPT_0x17
	CALL SUBOPT_0x15
	STD  Y+8,R30
; 0000 020E y3 =  data1%10;
	CALL SUBOPT_0x17
	CALL SUBOPT_0x16
	STD  Y+7,R30
; 0000 020F 
; 0000 0210 if ((budilnik_Install[0] & 0x80) | (budilnik_Install[1] & 0x80)                                                    //    
; 0000 0211                  | (budilnik_Install[2] & 0x80) | (budilnik_Install[3] & 0x80) | (budilnik_Install[4] & 0x80)
; 0000 0212                  | (budilnik_Install[5] & 0x80) | (budilnik_Install[6] & 0x80)| (budilnik_Install[7] & 0x80)
; 0000 0213                  | (budilnik_Install[8] & 0x80) ) {  budilnik=1;   }
	LDS  R30,_budilnik_Install
	ANDI R30,LOW(0x80)
	MOV  R26,R30
	__GETB1MN _budilnik_Install,1
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,2
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,3
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,4
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,5
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,6
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,7
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,8
	ANDI R30,LOW(0x80)
	OR   R30,R26
	BREQ _0x95
	SET
	RJMP _0x25D
; 0000 0214                       else  {  budilnik=0;  }
_0x95:
	CLT
_0x25D:
	BLD  R2,5
; 0000 0215 
; 0000 0216   if(mig_vrem) {      if (mig)  {ekran [12]=128;  ekran [11]=0;}
	SBRS R2,1
	RJMP _0x97
	SBRS R2,0
	RJMP _0x98
	LDI  R30,LOW(128)
	__PUTB1MN _ekran,12
	LDI  R30,LOW(0)
	RJMP _0x25E
; 0000 0217                                         else  {ekran [12]=0;  ekran [11]=128;}                                 //     
_0x98:
	LDI  R30,LOW(0)
	__PUTB1MN _ekran,12
	LDI  R30,LOW(128)
_0x25E:
	__PUTB1MN _ekran,11
; 0000 0218 
; 0000 0219                 }
; 0000 021A 
; 0000 021B 
; 0000 021C if (data != data1)                                                                                             //     -  
_0x97:
	LDS  R30,_data1
	LDS  R31,_data1+1
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CP   R30,R26
	CPC  R31,R27
	BRNE PC+3
	JMP _0x9A
; 0000 021D {
; 0000 021E     if (Interval_2>40){Interval_2=0; Shift_zn++;  if(Shift_zn==8) {Shift_zn=0;data1=data;}   }
	LDS  R26,_Interval_2
	LDS  R27,_Interval_2+1
	SBIW R26,41
	BRLO _0x9B
	LDI  R30,LOW(0)
	STS  _Interval_2,R30
	STS  _Interval_2+1,R30
	LDS  R30,_Shift_zn_S000000A000
	SUBI R30,-LOW(1)
	STS  _Shift_zn_S000000A000,R30
	LDS  R26,_Shift_zn_S000000A000
	CPI  R26,LOW(0x8)
	BRNE _0x9C
	LDI  R30,LOW(0)
	STS  _Shift_zn_S000000A000,R30
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	CALL SUBOPT_0x18
_0x9C:
; 0000 021F     {    mig_vrem=0;
_0x9B:
	CLT
	BLD  R2,1
; 0000 0220 
; 0000 0221     for (temp=0; temp<5; temp++)
	LDI  R30,LOW(0)
	STD  Y+6,R30
_0x9E:
	LDD  R26,Y+6
	CPI  R26,LOW(0x5)
	BRLO PC+3
	JMP _0x9F
; 0000 0222     {
; 0000 0223      if(sek0 || time>=600){if(x !=y ) {ekran [temp   ] =  (   (simvol [y ][temp]<<Shift_zn)  +   (simvol [x ][temp]>>(8-Shift_zn))   );}   else  {  if(sek0 || time>=600) {ekran [temp   ]=(simvol [x ][temp]);} else  {ekran [temp   ]=(simvol [55 ][temp]);} }
	SBRC R2,3
	RJMP _0xA1
	CALL SUBOPT_0x19
	BRLO _0xA0
_0xA1:
	CP   R21,R17
	BREQ _0xA3
	CALL SUBOPT_0x1A
	MOVW R22,R30
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	PUSH R31
	PUSH R30
	LDI  R26,LOW(5)
	MUL  R21,R26
	MOVW R30,R0
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1C
	MOVW R26,R30
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x1D
	POP  R26
	POP  R27
	RJMP _0x25F
_0xA3:
	SBRC R2,3
	RJMP _0xA6
	CALL SUBOPT_0x19
	BRLO _0xA5
_0xA6:
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x1F
	RJMP _0x25F
_0xA5:
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x20
_0x25F:
	ST   X,R30
; 0000 0224                           }
; 0000 0225     if(x1!=y1) {ekran [temp+ 6] =  (   (simvol [y1][temp]<<Shift_zn)  +   (simvol [x1][temp]>>(8-Shift_zn))   );}   else  { if(temp==4 & mig_vrem & budilnik & !mig) {ekran [temp+ 6]=(simvol [x1][temp])+128;}
_0xA0:
	CP   R20,R16
	BREQ _0xA9
	CALL SUBOPT_0x1A
	MOVW R22,R30
	__ADDW1MN _ekran,6
	PUSH R31
	PUSH R30
	LDI  R26,LOW(5)
	MUL  R20,R26
	MOVW R30,R0
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x21
	MOVW R26,R30
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x1D
	POP  R26
	POP  R27
	RJMP _0x260
_0xA9:
	CALL SUBOPT_0x22
	BREQ _0xAB
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x23
	CALL SUBOPT_0x24
	RJMP _0x261
; 0000 0226                                                                                                                              else  {ekran [temp+ 6]=(simvol [x1][temp]); } }
_0xAB:
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x23
	ADD  R30,R24
	ADC  R31,R25
	LPM  R30,Z
_0x261:
	MOVW R26,R22
_0x260:
	ST   X,R30
; 0000 0227     if(x2!=y2) {ekran [temp+13] =  (   (simvol [y2][temp]<<Shift_zn)  +   (simvol [x2][temp]>>(8-Shift_zn))   );}   else  { if(temp==0 & mig_vrem & budilnik & mig) {ekran [temp+13]=(simvol [x2][temp])+128;}
	LDD  R30,Y+8
	CP   R30,R19
	BREQ _0xAD
	CALL SUBOPT_0x1A
	MOVW R22,R30
	__ADDW1MN _ekran,13
	PUSH R31
	PUSH R30
	LDD  R30,Y+8
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x25
	MOVW R26,R30
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x1D
	POP  R26
	POP  R27
	RJMP _0x262
_0xAD:
	CALL SUBOPT_0x26
	BREQ _0xAF
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x27
	CALL SUBOPT_0x24
	RJMP _0x263
; 0000 0228                                                                                                                              else  {ekran [temp+13]=(simvol [x2][temp]);} }
_0xAF:
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x27
	ADD  R30,R24
	ADC  R31,R25
	LPM  R30,Z
_0x263:
	MOVW R26,R22
_0x262:
	ST   X,R30
; 0000 0229                 ekran [temp+19] =  (   (simvol [y3][temp]<<Shift_zn)  +   (simvol [x3][temp]>>(8-Shift_zn))   );
	CALL SUBOPT_0x1A
	MOVW R22,R30
	__ADDW1MN _ekran,19
	PUSH R31
	PUSH R30
	LDD  R30,Y+7
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	CALL SUBOPT_0x1B
	MUL  R18,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol*2)
	SBCI R31,HIGH(-_simvol*2)
	MOVW R26,R30
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x1D
	POP  R26
	POP  R27
	ST   X,R30
; 0000 022A 
; 0000 022B     }
	LDD  R30,Y+6
	SUBI R30,-LOW(1)
	STD  Y+6,R30
	RJMP _0x9E
_0x9F:
; 0000 022C     }
; 0000 022D 
; 0000 022E }
; 0000 022F else
	RJMP _0xB1
_0x9A:
; 0000 0230 {
; 0000 0231    for (temp=0; temp<5; temp++)
	LDI  R30,LOW(0)
	STD  Y+6,R30
_0xB3:
	LDD  R26,Y+6
	CPI  R26,LOW(0x5)
	BRLO PC+3
	JMP _0xB4
; 0000 0232     {
; 0000 0233     if(sek0 || time>=600) {ekran [temp   ]=(simvol [x ][temp]);} else  {ekran [temp   ]=(simvol [55 ][temp]);}                 // 0    .
	SBRC R2,3
	RJMP _0xB6
	CALL SUBOPT_0x19
	BRLO _0xB5
_0xB6:
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x1F
	RJMP _0x264
_0xB5:
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x20
_0x264:
	ST   X,R30
; 0000 0234 
; 0000 0235 
; 0000 0236    if(temp==4 & mig_vrem & budilnik & !mig) {ekran [temp+ 6]=(simvol [x1][temp])+128;}
	CALL SUBOPT_0x22
	BREQ _0xB9
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x23
	CALL SUBOPT_0x24
	RJMP _0x265
; 0000 0237                                  else  {ekran [temp+ 6]=(simvol [x1][temp]); }
_0xB9:
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x23
	ADD  R30,R24
	ADC  R31,R25
	LPM  R30,Z
_0x265:
	MOVW R26,R22
	ST   X,R30
; 0000 0238    if(temp==0 & mig_vrem & budilnik & mig) {ekran [temp+13]=(simvol [x2][temp])+128;}
	CALL SUBOPT_0x26
	BREQ _0xBB
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x27
	CALL SUBOPT_0x24
	RJMP _0x266
; 0000 0239                                 else  {ekran [temp+13]=(simvol [x2][temp]);}
_0xBB:
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x27
	ADD  R30,R24
	ADC  R31,R25
	LPM  R30,Z
_0x266:
	MOVW R26,R22
	ST   X,R30
; 0000 023A     ekran [temp+19]=(simvol [x3][temp]);
	CALL SUBOPT_0x1A
	MOVW R24,R30
	__ADDW1MN _ekran,19
	MOVW R22,R30
	LDI  R26,LOW(5)
	MUL  R18,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol*2)
	SBCI R31,HIGH(-_simvol*2)
	CALL SUBOPT_0x1F
	ST   X,R30
; 0000 023B     }
	LDD  R30,Y+6
	SUBI R30,-LOW(1)
	STD  Y+6,R30
	RJMP _0xB3
_0xB4:
; 0000 023C 
; 0000 023D 
; 0000 023E     Interval_2=0;
	LDI  R30,LOW(0)
	STS  _Interval_2,R30
	STS  _Interval_2+1,R30
; 0000 023F }
_0xB1:
; 0000 0240 
; 0000 0241 }
	CALL __LOADLOCR6
	ADIW R28,11
	RET
;
;//___________________________     1 _________________________________
; void ekran_1_figure (unsigned char x,unsigned char x1,unsigned char x2,)
; 0000 0245 {
_ekran_1_figure:
; 0000 0246    unsigned char temp;
; 0000 0247    for (temp=0; temp<5; temp++)
	ST   -Y,R17
;	x -> Y+3
;	x1 -> Y+2
;	x2 -> Y+1
;	temp -> R17
	LDI  R17,LOW(0)
_0xBE:
	CPI  R17,5
	BRSH _0xBF
; 0000 0248    {
; 0000 0249    if (simvol [x][temp]==0xAA) return;
	CALL SUBOPT_0x28
	CALL SUBOPT_0x29
	BRNE _0xC0
	RJMP _0x2020006
; 0000 024A    if(x2!=0) {ekran [temp+x1]=(simvol [x][temp])  +(128*mig*line);}
_0xC0:
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0xC1
	CALL SUBOPT_0x2A
	__PUTW1R 23,24
	CALL SUBOPT_0x28
	CALL SUBOPT_0x2B
	MOV  R26,R30
	LDI  R30,0
	SBRC R3,3
	LDI  R30,1
	MULS R30,R26
	MOVW R30,R0
	ADD  R30,R22
	__GETW2R 23,24
	RJMP _0x267
; 0000 024B       else   {ekran [temp+x1]=(simvol [x][temp]) ;}
_0xC1:
	CALL SUBOPT_0x2A
	MOVW R22,R30
	CALL SUBOPT_0x28
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	MOVW R26,R22
_0x267:
	ST   X,R30
; 0000 024C    }
	SUBI R17,-1
	RJMP _0xBE
_0xBF:
; 0000 024D }
	RJMP _0x2020006
;
;//_______________________________________  __________________________________________________
;void ochistka (void)
; 0000 0251 {
_ochistka:
; 0000 0252 unsigned char temp;
; 0000 0253 for (temp=0;  temp<24; temp++) {ekran[temp]=0  ;}
	ST   -Y,R17
;	temp -> R17
	LDI  R17,LOW(0)
_0xC4:
	CPI  R17,24
	BRSH _0xC5
	CALL SUBOPT_0x0
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	SUBI R17,-1
	RJMP _0xC4
_0xC5:
; 0000 0254 }
	LD   R17,Y+
	RET
;
;//_________________________________________!__2_____________________________________________
;  unsigned  char ystanovki_2 (unsigned  char x,unsigned  char x1,unsigned  char x2)
; 0000 0258   {
_ystanovki_2:
; 0000 0259 
; 0000 025A   unsigned  char temp;
; 0000 025B 
; 0000 025C            if ((x==0) && (x1==15))x=1;
	ST   -Y,R17
;	x -> Y+3
;	x1 -> Y+2
;	x2 -> Y+1
;	temp -> R17
	LDD  R26,Y+3
	CPI  R26,LOW(0x0)
	BRNE _0xC7
	LDD  R26,Y+2
	CPI  R26,LOW(0xF)
	BREQ _0xC8
_0xC7:
	RJMP _0xC6
_0xC8:
	LDI  R30,LOW(1)
	STD  Y+3,R30
; 0000 025D         while ( (button_read() != 2)  &&  POWER )  // POWER
_0xC6:
_0xC9:
	RCALL _button_read
	CPI  R30,LOW(0x2)
	BREQ _0xCC
	SBRC R3,4
	RJMP _0xCD
_0xCC:
	RJMP _0xCB
_0xCD:
; 0000 025E         {        if(time_meny== RET_CLOCK) { ochistka();meny=10;return x;} ;
	CALL SUBOPT_0x2C
	BRNE _0xCE
	RCALL _ochistka
	LDI  R30,LOW(10)
	MOV  R5,R30
	RJMP _0x2020005
_0xCE:
; 0000 025F         if (BUT_OK ) {x++;   if (x>x1) { if ( ( x1==12 )|| (x1==31)|| (x1==15)){x=1;}                   //       snm 
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0xCF
	LDD  R30,Y+3
	SUBI R30,-LOW(1)
	STD  Y+3,R30
	LDD  R30,Y+2
	LDD  R26,Y+3
	CP   R30,R26
	BRSH _0xD0
	LDD  R26,Y+2
	CPI  R26,LOW(0xC)
	BREQ _0xD2
	CPI  R26,LOW(0x1F)
	BREQ _0xD2
	CPI  R26,LOW(0xF)
	BRNE _0xD1
_0xD2:
	LDI  R30,LOW(1)
	RJMP _0x268
; 0000 0260                                               else { x=0;};
_0xD1:
	LDI  R30,LOW(0)
_0x268:
	STD  Y+3,R30
; 0000 0261                                        }
; 0000 0262                      }
_0xD0:
; 0000 0263 
; 0000 0264                 for (temp=0; temp<5; temp++)
_0xCF:
	LDI  R17,LOW(0)
_0xD6:
	CPI  R17,5
	BRSH _0xD7
; 0000 0265                 {
; 0000 0266 
; 0000 0267 
; 0000 0268                      ekran [temp+x2]  =(simvol [x/10][temp])   +(128*mig);
	CALL SUBOPT_0x2D
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	__PUTW1R 23,24
	LDD  R26,Y+3
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2B
	ADD  R30,R22
	__GETW2R 23,24
	ST   X,R30
; 0000 0269 
; 0000 026A                      ekran [temp+x2+6]=(simvol [x%10][temp])   +(128*mig);
	CALL SUBOPT_0x2D
	__ADDW1MN _ekran,6
	__PUTW1R 23,24
	LDD  R26,Y+3
	CALL SUBOPT_0x30
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2B
	ADD  R30,R22
	__GETW2R 23,24
	ST   X,R30
; 0000 026B                 }
	SUBI R17,-1
	RJMP _0xD6
_0xD7:
; 0000 026C         }
	RJMP _0xC9
_0xCB:
; 0000 026D   ochistka();
	RCALL _ochistka
; 0000 026E 
; 0000 026F 
; 0000 0270                                   return x;
_0x2020005:
	LDD  R30,Y+3
_0x2020006:
	LDD  R17,Y+0
_0x2020007:
	ADIW R28,4
	RET
; 0000 0271   }
;
;//_________________________________________________________________________________________________
;  unsigned  int ystanovki_23_59 (unsigned  int x)
; 0000 0275   {
_ystanovki_23_59:
; 0000 0276   ochistka();
;	x -> Y+0
	RCALL _ochistka
; 0000 0277 
; 0000 0278   ekran_1_figure((x%60)/10,13,1);  ekran_1_figure(x%10,19,1);
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0x15
	CALL SUBOPT_0x31
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0x16
	CALL SUBOPT_0x32
; 0000 0279   x = (x%60)+   (ystanovki_2 ((x/60),23, 0))*60;
	CALL SUBOPT_0x33
	CALL __MODW21U
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x33
	CALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(23)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _ystanovki_2
	LDI  R26,LOW(60)
	MUL  R30,R26
	MOVW R30,R0
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	ST   Y,R30
	STD  Y+1,R31
; 0000 027A   ekran_1_figure(x/600,0,1);  ekran_1_figure((x/60)%10,6,1);
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0x13
	CALL SUBOPT_0x34
	CALL SUBOPT_0x33
	CALL __DIVW21U
	MOVW R26,R30
	CALL SUBOPT_0x16
	CALL SUBOPT_0x35
; 0000 027B   x = (x/60*60)+(ystanovki_2 ((x%60),59,13));
	CALL SUBOPT_0x33
	CALL SUBOPT_0x36
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x33
	CALL __MODW21U
	ST   -Y,R30
	LDI  R30,LOW(59)
	CALL SUBOPT_0x37
	LDI  R31,0
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	ST   Y,R30
	STD  Y+1,R31
; 0000 027C 
; 0000 027D   return x;
	ADIW R28,2
	RET
; 0000 027E   }
;
;//_________________________________________ ___________________________________________________
;unsigned char beg_stroka (unsigned char x[],)
; 0000 0282 {
_beg_stroka:
; 0000 0283   unsigned char temp;
; 0000 0284                     for (temp=0; temp<23; temp++)  {ekran[temp]=ekran[temp+1];}
	ST   -Y,R17
;	x -> Y+1
;	temp -> R17
	LDI  R17,LOW(0)
_0xD9:
	CPI  R17,23
	BRSH _0xDA
	CALL SUBOPT_0x38
	__ADDW1MN _ekran,1
	LD   R30,Z
	ST   X,R30
	SUBI R17,-1
	RJMP _0xD9
_0xDA:
; 0000 0285   if ((z==5)||(simvol[x[z1]][z]==0xAA)) {ekran[23]=0;z=0; z1++; if (x[z1]==255) {z1=0; for (temp=23; temp>0; temp--)  { ekran[temp] = ekran[temp-1]; } ;ekran[0]=0; return 255;} }
	LDS  R26,_z
	CPI  R26,LOW(0x5)
	BREQ _0xDC
	CALL SUBOPT_0x39
	CALL SUBOPT_0x3A
	CALL SUBOPT_0x29
	BRNE _0xDB
_0xDC:
	LDI  R30,LOW(0)
	__PUTB1MN _ekran,23
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x39
	LD   R26,X
	CPI  R26,LOW(0xFF)
	BRNE _0xDE
	LDI  R30,LOW(0)
	STS  _z1,R30
	LDI  R17,LOW(23)
_0xE0:
	CPI  R17,1
	BRLO _0xE1
	CALL SUBOPT_0x38
	SBIW R30,1
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	LD   R30,Z
	ST   X,R30
	SUBI R17,1
	RJMP _0xE0
_0xE1:
	LDI  R30,LOW(0)
	STS  _ekran,R30
	LDI  R30,LOW(255)
	RJMP _0x2020004
_0xDE:
; 0000 0286                   else  {ekran[23]=simvol[x[z1]][z]; z++;}
	RJMP _0xE2
_0xDB:
	CALL SUBOPT_0x39
	CALL SUBOPT_0x3A
	ADD  R30,R26
	ADC  R31,R27
	LPM  R0,Z
	__PUTBR0MN _ekran,23
	LDS  R30,_z
	SUBI R30,-LOW(1)
	STS  _z,R30
_0xE2:
; 0000 0287 
; 0000 0288 }
	RJMP _0x2020004
; //_________________________________________       ___________________________________________________
;unsigned char beg_stroka_revers (unsigned char x[],)
; 0000 028B {
_beg_stroka_revers:
; 0000 028C unsigned char temp,;
; 0000 028D 
; 0000 028E                 if  (simvol[x[z1]][4-z]==0xAA)  {z=4;};
	ST   -Y,R17
;	x -> Y+1
;	temp -> R17
	CALL SUBOPT_0x39
	CALL SUBOPT_0x3C
	LPM  R26,Z
	CPI  R26,LOW(0xAA)
	BRNE _0xE3
	LDI  R30,LOW(4)
	STS  _z,R30
_0xE3:
; 0000 028F                  if ((z==4) && (x[z1+1]==255)) { ekran[0]=0;z1=0; return 255;};
	LDS  R26,_z
	CPI  R26,LOW(0x4)
	BRNE _0xE5
	LDS  R30,_z1
	LDI  R31,0
	ADIW R30,1
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	CALL SUBOPT_0x3D
	BREQ _0xE6
_0xE5:
	RJMP _0xE4
_0xE6:
	LDI  R30,LOW(0)
	STS  _ekran,R30
	STS  _z1,R30
	LDI  R30,LOW(255)
	RJMP _0x2020004
_0xE4:
; 0000 0290 
; 0000 0291                 if (z==5) {ekran[0]=0;z=0; z1++; }
	LDS  R26,_z
	CPI  R26,LOW(0x5)
	BRNE _0xE7
	LDI  R30,LOW(0)
	STS  _ekran,R30
	CALL SUBOPT_0x3B
; 0000 0292                     else  {ekran[0]=simvol[x[z1]][4-z]; z++;}
	RJMP _0xE8
_0xE7:
	CALL SUBOPT_0x39
	CALL SUBOPT_0x3C
	LPM  R0,Z
	STS  _ekran,R0
	LDS  R30,_z
	SUBI R30,-LOW(1)
	STS  _z,R30
_0xE8:
; 0000 0293           for (temp=23; temp>0; temp--)  { ekran[temp] = ekran[temp-1]; }
	LDI  R17,LOW(23)
_0xEA:
	CPI  R17,1
	BRLO _0xEB
	CALL SUBOPT_0x38
	SBIW R30,1
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	LD   R30,Z
	ST   X,R30
	SUBI R17,1
	RJMP _0xEA
_0xEB:
; 0000 0294 
; 0000 0295 
; 0000 0296 }
_0x2020004:
	LDD  R17,Y+0
	ADIW R28,3
	RET
;//__________________________________  _______________________________________________
;void txt_ekran (unsigned char x[],)
; 0000 0299 {
_txt_ekran:
; 0000 029A unsigned char temp =0,  temp1=0, temp2=0;
; 0000 029B 
; 0000 029C     for(temp=0;temp<24;temp++)
	CALL __SAVELOCR4
;	x -> Y+4
;	temp -> R17
;	temp1 -> R16
;	temp2 -> R19
	LDI  R17,0
	LDI  R16,0
	LDI  R19,0
	LDI  R17,LOW(0)
_0xED:
	CPI  R17,24
	BRSH _0xEE
; 0000 029D     {
; 0000 029E     if ((temp2==5) || (simvol[x[temp1]][temp2] == 0xAA)) {ekran[temp]=0;   temp2=0; temp1++;}
	CPI  R19,5
	BREQ _0xF0
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x29
	BRNE _0xEF
_0xF0:
	CALL SUBOPT_0x0
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	LDI  R19,LOW(0)
	SUBI R16,-1
; 0000 029F         else {ekran[temp]=simvol[x[temp1]][temp2]; temp2++;}
	RJMP _0xF2
_0xEF:
	CALL SUBOPT_0x0
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	MOVW R22,R30
	CALL SUBOPT_0x3E
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	MOVW R26,R22
	ST   X,R30
	SUBI R19,-1
_0xF2:
; 0000 02A0     if (x[temp1]==255) return ; //{temp=24;}
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0xFF)
	BREQ _0x2020003
; 0000 02A1     }
	SUBI R17,-1
	RJMP _0xED
_0xEE:
; 0000 02A2 }
_0x2020003:
	CALL __LOADLOCR4
	ADIW R28,6
	RET
;
;//*****************************************************************************************************************//
;//*****************************************************************************************************************//
;//*****************************************************************************************************************//
;//*****************************************************************************************************************//
;void main(void)
; 0000 02A9 {
_main:
; 0000 02AA PORTA=0x00; DDRA=0xFF;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	LDI  R30,LOW(255)
	OUT  0x1A,R30
; 0000 02AB PORTB=0x00; DDRB=0xE3;
	LDI  R30,LOW(0)
	OUT  0x18,R30
	LDI  R30,LOW(227)
	OUT  0x17,R30
; 0000 02AC PORTC=0x00; DDRC=0x3F;
	LDI  R30,LOW(0)
	OUT  0x15,R30
	LDI  R30,LOW(63)
	OUT  0x14,R30
; 0000 02AD PORTD=0x00; DDRD=0xFF;
	LDI  R30,LOW(0)
	OUT  0x12,R30
	LDI  R30,LOW(255)
	OUT  0x11,R30
; 0000 02AE 
; 0000 02AF TCCR0=0x03;           //  0 125,000 kHz   (8000000/64)
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 02B0 OCR0=254;             //
	LDI  R30,LOW(254)
	OUT  0x3C,R30
; 0000 02B1 
; 0000 02B2 TCCR1B=0x0C;          //  1 125,000 kHz   (8000000/64)
	LDI  R30,LOW(12)
	OUT  0x2E,R30
; 0000 02B3 OCR1A=20;
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 02B4 
; 0000 02B5 ASSR=0x08;            //    TOSC1,2    32768
	LDI  R30,LOW(8)
	OUT  0x22,R30
; 0000 02B6 TCCR2=0x05;           // 32768/128=256
	LDI  R30,LOW(5)
	OUT  0x25,R30
; 0000 02B7 OCR1A=127;            //
	LDI  R30,LOW(127)
	LDI  R31,HIGH(127)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 02B8 
; 0000 02B9 TIMSK=0xC3;           //    
	LDI  R30,LOW(195)
	OUT  0x39,R30
; 0000 02BA 
; 0000 02BB ACSR= 0x48;           // .
	LDI  R30,LOW(72)
	OUT  0x8,R30
; 0000 02BC SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 02BD 
; 0000 02BE MCUCR|=0b00110000;    //     - Power Sawe
	IN   R30,0x35
	ORI  R30,LOW(0x30)
	OUT  0x35,R30
; 0000 02BF 
; 0000 02C0 ADCSRA=0b10000011;    //  .    - 1.
	LDI  R30,LOW(131)
	OUT  0x6,R30
; 0000 02C1 ADMUX= 0b01100111;    // -AVcc.     7,  
	LDI  R30,LOW(103)
	OUT  0x7,R30
; 0000 02C2 
; 0000 02C3 #asm                                //     1 Wire
; 0000 02C4    .equ __w1_port=0x18 ;PORTB       //     
   .equ __w1_port=0x18 ;PORTB       //     
; 0000 02C5    .equ __w1_bit=4                  //  4
   .equ __w1_bit=4                  //  4
; 0000 02C6 #endasm
; 0000 02C7 
; 0000 02C8 for (temp=0;temp<9;temp++){budilnik_time [temp] = budilnik_Install [temp] = budilnik_Interval[temp]= 0;}  bud_flg=0; budilnik=0 ; // ""  
	LDI  R30,LOW(0)
	STS  _temp,R30
_0xF5:
	LDS  R26,_temp
	CPI  R26,LOW(0x9)
	BRSH _0xF6
	LDS  R30,_temp
	CALL SUBOPT_0x3F
	MOVW R22,R30
	CALL SUBOPT_0x40
	SUBI R30,LOW(-_budilnik_Install)
	SBCI R31,HIGH(-_budilnik_Install)
	MOVW R0,R30
	LDS  R26,_temp
	LDI  R27,0
	SUBI R26,LOW(-_budilnik_Interval)
	SBCI R27,HIGH(-_budilnik_Interval)
	LDI  R30,LOW(0)
	CALL SUBOPT_0x41
	LDI  R31,0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x42
	RJMP _0xF5
_0xF6:
	CLT
	BLD  R2,4
	BLD  R2,5
; 0000 02C9 den_nedeli=Day_week ();             //   
	RCALL _Day_week
	MOV  R8,R30
; 0000 02CA devices=w1_search(0xf0,rom_code);   //   DS18B20,      
	CALL SUBOPT_0x9
; 0000 02CB if (devices==1){
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRNE _0xF7
; 0000 02CC if (ds1820_d!=0)ds1820_d=0; if(ds1820_y!=1)ds1820_y=1;
	CALL SUBOPT_0x43
	CPI  R30,0
	BREQ _0xF8
	CALL SUBOPT_0xA
_0xF8:
	CALL SUBOPT_0x44
	CPI  R30,LOW(0x1)
	BREQ _0xF9
	LDI  R26,LOW(_ds1820_y)
	LDI  R27,HIGH(_ds1820_y)
	LDI  R30,LOW(1)
	CALL __EEPROMWRB
; 0000 02CD                }
_0xF9:
; 0000 02CE 
; 0000 02CF //**********     .
; 0000 02D0 PORTB.6=1;                      //      Z  (     )
_0xF7:
	SBI  0x18,6
; 0000 02D1 PORTA.7=0; DDRA.7=0;            //  .7   ,         ,
	CBI  0x1B,7
	CBI  0x1A,7
; 0000 02D2 ADCSRA=0b11000011;              //   (   )
	LDI  R30,LOW(195)
	OUT  0x6,R30
; 0000 02D3 while (ADCSRA&0b01000000){}     //     
_0x100:
	SBIC 0x6,6
	RJMP _0x100
; 0000 02D4 DDRA.7=1;                       //  .7   
	SBI  0x1A,7
; 0000 02D5 if (ADCH>5) {foto_r=1; brigh_up=254;} //else brigh_up=9;   //
	IN   R30,0x5
	CPI  R30,LOW(0x6)
	BRLO _0x105
	LDI  R30,LOW(1)
	STS  _foto_r,R30
	LDI  R26,LOW(_brigh_up)
	LDI  R27,HIGH(_brigh_up)
	LDI  R30,LOW(254)
	CALL __EEPROMWRB
; 0000 02D6 ochistka();  //   
_0x105:
	RCALL _ochistka
; 0000 02D7 //#asm("cli")
; 0000 02D8 #asm("sei")
	sei
; 0000 02D9 //_______________________________________   ___________________________________________
; 0000 02DA ochistka();
	RCALL _ochistka
; 0000 02DB 
; 0000 02DC  //   ekran [10]=ekran [11]=ekran [12]=128;
; 0000 02DD   //  ekran_1_figure(52,0,1); ekran_1_figure(VER/100,5,1);  ekran_1_figure(VER%100/10,13,1); ekran_1_figure(VER%10,19,1);
; 0000 02DE    // delay_ms(1000);
; 0000 02DF 
; 0000 02E0 
; 0000 02E1 
; 0000 02E2  ochistka();    //   
	RCALL _ochistka
; 0000 02E3 
; 0000 02E4 //*****************************************************************************************************************//
; 0000 02E5 //*****************************************************************************************************************//
; 0000 02E6 while (1)
_0x106:
; 0000 02E7 {
; 0000 02E8 button_read();   //  
	RCALL _button_read
; 0000 02E9 if( time_meny== RET_CLOCK) { time_meny=0; ochistka(); meny=10;}            //     RET_CLOCK  .
	CALL SUBOPT_0x2C
	BRNE _0x109
	CALL SUBOPT_0x7
	RCALL _ochistka
	LDI  R30,LOW(10)
	MOV  R5,R30
; 0000 02EA 
; 0000 02EB 
; 0000 02EC switch (meny)
_0x109:
	MOV  R30,R5
	LDI  R31,0
; 0000 02ED         {
; 0000 02EE         case 10: //______ 
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x10D
; 0000 02EF 
; 0000 02F0          mig_vrem=1;
	SET
	BLD  R2,1
; 0000 02F1                  ekran_cifri(time);  //  
	CALL SUBOPT_0x45
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ekran_cifri
; 0000 02F2 
; 0000 02F3 
; 0000 02F4                 //______ 
; 0000 02F5                  if ( ( flg_ds18b20 ) && ( bud_flg == 0 ) )                                                      //               if ( flg_ds18b20 )
	SBRS R3,7
	RJMP _0x10F
	LDI  R26,0
	SBRC R2,4
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ _0x110
_0x10F:
	RJMP _0x10E
_0x110:
; 0000 02F6                         {
; 0000 02F7                         flg_ds18b20=0;
	CLT
	BLD  R3,7
; 0000 02F8                         for (i=0;i<devices;i++)
	LDI  R30,LOW(0)
	STS  _i_G000,R30
_0x112:
	LDS  R30,_devices_G000
	LDS  R26,_i_G000
	CP   R26,R30
	BRLO PC+3
	JMP _0x113
; 0000 02F9                                 {
; 0000 02FA                                 error_ds18b20[i]++;                                                               //      DS18B20
	LDI  R27,0
	SUBI R26,LOW(-_error_ds18b20)
	SBCI R27,HIGH(-_error_ds18b20)
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
; 0000 02FB                                 temperature_temp=ds18b20_read_temp (&rom_code[i][0]);                             //    DS18B20
	CALL SUBOPT_0x46
	CALL _ds18b20_read_temp
	STS  _temperature_temp,R30
	STS  _temperature_temp+1,R31
	STS  _temperature_temp+2,R22
	STS  _temperature_temp+3,R23
; 0000 02FC                                 if (temperature_temp!=(-9999))                                                    //    ,    "temperature"
	CALL SUBOPT_0x47
	__CPD2N 0xC61C3C00
	BREQ _0x114
; 0000 02FD                                                             {
; 0000 02FE                                                             temperature[i]=temperature_temp*10;
	CALL SUBOPT_0x48
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x47
	__GETD1N 0x41200000
	CALL __MULF12
	POP  R26
	POP  R27
	CALL __CFD1
	ST   X+,R30
	ST   X,R31
; 0000 02FF                                                             // temperature[i]+=5;                                 //      "temperature" + 0,5 C
; 0000 0300                                                             error_ds18b20[i]=0;                                   //      DS18B20
	CALL SUBOPT_0x49
	LDI  R26,LOW(0)
	STD  Z+0,R26
; 0000 0301                                                             }
; 0000 0302                                 if(error_ds18b20[i]==255)  temperature[i]=-999;                                   //   DS18B20  5     ,    (  -99,9 )
_0x114:
	CALL SUBOPT_0x49
	LD   R26,Z
	CPI  R26,LOW(0xFF)
	BRNE _0x115
	CALL SUBOPT_0x48
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(64537)
	LDI  R31,HIGH(64537)
	ST   X+,R30
	ST   X,R31
; 0000 0303                                 ds18b20_convert_temp(&rom_code[i][0]);                                            //    
_0x115:
	CALL SUBOPT_0x46
	CALL _ds18b20_convert_temp
; 0000 0304                                 }
	LDS  R30,_i_G000
	SUBI R30,-LOW(1)
	STS  _i_G000,R30
	RJMP _0x112
_0x113:
; 0000 0305                         }
; 0000 0306 
; 0000 0307                 if ((sek==9)  && (str != 0) &&  (mig_vrem))  {  temp2=str;                                                      //     10   
_0x10E:
	LDI  R30,LOW(9)
	CP   R30,R4
	BRNE _0x117
	CALL SUBOPT_0x4A
	CPI  R30,0
	BREQ _0x117
	SBRC R2,1
	RJMP _0x118
_0x117:
	RJMP _0x116
_0x118:
	CALL SUBOPT_0x4A
	STS  _temp2,R30
; 0000 0308                                                    if (( (temp2 & 0x01) || (temp2 & 0x02) || (temp2 & 0x04) ||
; 0000 0309                                                         ((temp2 & 0x08) && (devices>0)) || ((temp2 & 0x10) && (devices>0))      //          
; 0000 030A                                                       ) )
	ANDI R30,LOW(0x1)
	BRNE _0x11A
	LDS  R30,_temp2
	ANDI R30,LOW(0x2)
	BRNE _0x11A
	LDS  R30,_temp2
	ANDI R30,LOW(0x4)
	BRNE _0x11A
	LDS  R30,_temp2
	ANDI R30,LOW(0x8)
	BREQ _0x11B
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRSH _0x11A
_0x11B:
	LDS  R30,_temp2
	ANDI R30,LOW(0x10)
	BREQ _0x11D
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRSH _0x11A
_0x11D:
	RJMP _0x119
_0x11A:
; 0000 030B                                                          {  z=0; z1=0;temp=0; meny=11 ; temp2=str;  mig_vrem=1;}
	CALL SUBOPT_0x4B
	LDI  R30,LOW(11)
	MOV  R5,R30
	CALL SUBOPT_0x4A
	STS  _temp2,R30
	SET
	BLD  R2,1
; 0000 030C 
; 0000 030D 
; 0000 030E                                                 }
_0x119:
; 0000 030F              if (sek_ind) { if ((sek!=0)&& (sek%10==0) && (str != 0) && (mig_vrem) )  { z=0; z1=0;temp=0; meny=12 ; temp2=str;}};                   //       
_0x116:
	SBRS R2,6
	RJMP _0x120
	LDI  R30,LOW(0)
	CP   R30,R4
	BREQ _0x122
	MOV  R26,R4
	CALL SUBOPT_0x30
	SBIW R30,0
	BRNE _0x122
	CALL SUBOPT_0x4A
	CPI  R30,0
	BREQ _0x122
	SBRC R2,1
	RJMP _0x123
_0x122:
	RJMP _0x121
_0x123:
	CALL SUBOPT_0x4B
	LDI  R30,LOW(12)
	MOV  R5,R30
	CALL SUBOPT_0x4A
	STS  _temp2,R30
_0x121:
_0x120:
; 0000 0310                mig_vrem=0;
	CLT
	BLD  R2,1
; 0000 0311 
; 0000 0312                 if (BUT_STEP) {ochistka(); z=0; z1=0;  t=0; temp1=0;   meny=30;  bud_flg=0;data1=(((time-(time/60*60))*60)+sek);}
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x124
	CALL SUBOPT_0x4C
	CLT
	BLD  R2,4
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x18
; 0000 0313                 if (BUT_OK)   {  meny=20 ;z=0; z1=0; temp2=0xFF;}                //   0x18;
_0x124:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x125
	LDI  R30,LOW(20)
	CALL SUBOPT_0x4F
	LDI  R30,LOW(255)
	STS  _temp2,R30
; 0000 0314         break;
_0x125:
	JMP  _0x10C
; 0000 0315         case 12:  //_________//______        
_0x10D:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0x126
; 0000 0316                  mig_vrem=0;
	CALL SUBOPT_0x50
; 0000 0317                 t=0; temp1=0;
; 0000 0318                 beg_info[t++]=44;
	CALL SUBOPT_0x51
; 0000 0319                 beg_info[t++]= (sek%60)/10;          //      
	MOV  R26,R4
	CLR  R27
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL SUBOPT_0x52
; 0000 031A                 beg_info[t++]= sek%10;                //      
	MOV  R26,R4
	CALL SUBOPT_0x30
	CALL SUBOPT_0x53
; 0000 031B                 beg_info[t]=255;                     //      " "
	CALL SUBOPT_0x54
	CALL SUBOPT_0x55
; 0000 031C                 if (Interval >= speed)  {Interval=0; if (beg_stroka (beg_info)==255) {delay_ms(1000); t=0; temp1=0; meny=13; data1=time;}}   //
	BRLO _0x127
	CALL SUBOPT_0x56
	RCALL _beg_stroka
	CPI  R30,LOW(0xFF)
	BRNE _0x128
	CALL SUBOPT_0x57
	CALL SUBOPT_0x58
	LDI  R30,LOW(13)
	MOV  R5,R30
	CALL SUBOPT_0x59
_0x128:
; 0000 031D                 if (BUT_STEP) {ochistka();  z=0; z1=0; t=0; temp1=0; meny=30; }
_0x127:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x129
	CALL SUBOPT_0x4C
; 0000 031E                 if (BUT_OK)   { ochistka();meny=20;}
_0x129:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x12A
	RCALL _ochistka
	LDI  R30,LOW(20)
	MOV  R5,R30
; 0000 031F 
; 0000 0320          break;
_0x12A:
	JMP  _0x10C
; 0000 0321         case 13:   //______          
_0x126:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BRNE _0x12B
; 0000 0322                 mig_vrem=0;
	CALL SUBOPT_0x50
; 0000 0323                     t=0; temp1=0;
; 0000 0324                     beg_info[t++]=54;
	LDI  R26,LOW(54)
	CALL SUBOPT_0x5A
; 0000 0325                     beg_info[t++]=(time%600)/60;                            //     
	MOVW R22,R30
	CALL SUBOPT_0x11
	CALL SUBOPT_0x14
	MOVW R26,R22
	ST   X,R30
; 0000 0326                     if (time/600!=0) { beg_info[t++]=time/600;}              //     
	CALL SUBOPT_0x5B
	SBIW R30,0
	BREQ _0x12C
	CALL SUBOPT_0x5C
	MOVW R22,R30
	CALL SUBOPT_0x5B
	MOVW R26,R22
	ST   X,R30
; 0000 0327                               else   {beg_info[t++]=55;}
	RJMP _0x12D
_0x12C:
	CALL SUBOPT_0x5C
	LDI  R26,LOW(55)
	STD  Z+0,R26
_0x12D:
; 0000 0328                     beg_info[t]=255;                                        //      " "
	CALL SUBOPT_0x5D
	CALL SUBOPT_0x55
; 0000 0329                     if (Interval >= speed)  {Interval=0; if (beg_stroka_revers(beg_info)==255) { meny=10; ochistka(); data1=time;}}        //    
	BRLO _0x12E
	CALL SUBOPT_0x56
	RCALL _beg_stroka_revers
	CPI  R30,LOW(0xFF)
	BRNE _0x12F
	LDI  R30,LOW(10)
	MOV  R5,R30
	RCALL _ochistka
	CALL SUBOPT_0x59
_0x12F:
; 0000 032A                     if (BUT_STEP) {ochistka(); z=0; z1=0;  t=0; temp1=0;   meny=30; }
_0x12E:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x130
	CALL SUBOPT_0x4C
; 0000 032B                     if (BUT_OK)   {ochistka();meny=20;}
_0x130:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x131
	RCALL _ochistka
	LDI  R30,LOW(20)
	MOV  R5,R30
; 0000 032C         break;
_0x131:
	JMP  _0x10C
; 0000 032D 
; 0000 032E         //*******  .        . **********
; 0000 032F         case 11: //______    .
_0x12B:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x132
; 0000 0330 
; 0000 0331                  mig_vrem=0;
	CLT
	BLD  R2,1
; 0000 0332                 t=0; temp1=0;
	LDI  R30,LOW(0)
	CALL SUBOPT_0x58
; 0000 0333                  den_nedeli=Day_week ();
	CALL _Day_week
	MOV  R8,R30
; 0000 0334 
; 0000 0335                 beg_info[t++] = beg_info[t++] = beg_info[t++] = 42;            // 3    
	CALL SUBOPT_0x5C
	MOVW R22,R30
	CALL SUBOPT_0x5C
	MOVW R0,R30
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x5E
	ST   X,R30
; 0000 0336 
; 0000 0337                 if (temp2 & 0x01)                                              //  " "  
	LDS  R30,_temp2
	ANDI R30,LOW(0x1)
	BREQ _0x133
; 0000 0338                         {
; 0000 0339                         while (den_nedeli_txt[den_nedeli][t-3] != 255)         //
_0x134:
	CALL SUBOPT_0x5F
	LDI  R31,0
	SBIW R30,3
	CALL SUBOPT_0x3D
	BREQ _0x136
; 0000 033A                                 {                                              //
; 0000 033B                                 beg_info[t]=den_nedeli_txt[den_nedeli][t++-3]; //
	CALL SUBOPT_0x5D
	MOVW R22,R30
	CALL SUBOPT_0x5F
	CALL SUBOPT_0x60
	LDI  R31,0
	SBIW R30,3
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R22
	ST   X,R30
; 0000 033C                                 } beg_info[t++] = 42;                          //  
	RJMP _0x134
_0x136:
	CALL SUBOPT_0x5C
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 033D                         }
; 0000 033E                 if (temp2 & 0x02)                                              //   ""  
_0x133:
	LDS  R30,_temp2
	ANDI R30,LOW(0x2)
	BRNE PC+3
	JMP _0x137
; 0000 033F                         {                                                      //
; 0000 0340                         if (chislo>9) {beg_info[t++]=chislo/10;}               //     9,  "" 
	LDI  R30,LOW(9)
	CP   R30,R7
	BRSH _0x138
	CALL SUBOPT_0x5C
	MOVW R22,R30
	MOV  R26,R7
	CALL SUBOPT_0x2E
	MOVW R26,R22
	ST   X,R30
; 0000 0341                         beg_info[t++]=chislo%10;                               //   "" 
_0x138:
	CALL SUBOPT_0x5C
	MOVW R22,R30
	MOV  R26,R7
	CALL SUBOPT_0x30
	CALL SUBOPT_0x53
; 0000 0342                         beg_info[t++]=42;                                      //  
	CALL SUBOPT_0x60
	CALL SUBOPT_0x54
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0343                         temp1=t;
	LDS  R30,_t
	STS  _temp1,R30
; 0000 0344                         while (name_mesec_txt[mesec-1][(t-temp1)] != 255)      //   
_0x139:
	CALL SUBOPT_0x12
	CALL SUBOPT_0x61
	LDS  R26,_t
	CLR  R27
	CALL SUBOPT_0x62
	CALL SUBOPT_0x3D
	BREQ _0x13B
; 0000 0345                                 {
; 0000 0346                                 beg_info[t]=name_mesec_txt[mesec-1][t++-temp1];
	CALL SUBOPT_0x5D
	MOVW R24,R30
	CALL SUBOPT_0x12
	CALL SUBOPT_0x61
	LDS  R30,_t
	CALL SUBOPT_0x60
	CALL SUBOPT_0x63
	CALL SUBOPT_0x62
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R24
	ST   X,R30
; 0000 0347                                 } beg_info[t++] = 42;                          // 
	RJMP _0x139
_0x13B:
	CALL SUBOPT_0x5C
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0348                         }
; 0000 0349                 if (temp2 & 0x04)                                              //   ""  
_0x137:
	LDS  R30,_temp2
	ANDI R30,LOW(0x4)
	BREQ _0x13C
; 0000 034A                         {
; 0000 034B                         beg_info[t++]=2;                                       // ""  (2)
	CALL SUBOPT_0x5C
	LDI  R26,LOW(2)
	CALL SUBOPT_0x5A
; 0000 034C                         beg_info[t++]=0;                                       // ""   (0)
	LDI  R26,LOW(0)
	CALL SUBOPT_0x5A
; 0000 034D                         beg_info[t++]=(god%100)/10;                            // "" 
	MOVW R22,R30
	MOV  R26,R9
	CLR  R27
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL SUBOPT_0x52
; 0000 034E                         beg_info[t++]=god%10;                                  // "" 
	MOV  R26,R9
	CALL SUBOPT_0x30
	CALL SUBOPT_0x53
; 0000 034F                         beg_info[t++]=13;                                      // ""
	CALL SUBOPT_0x60
	CALL SUBOPT_0x54
	LDI  R26,LOW(13)
	CALL SUBOPT_0x5A
; 0000 0350                         beg_info[t++]=42; beg_info[t++]=42;                    // 2 
	LDI  R26,LOW(42)
	CALL SUBOPT_0x5A
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0351                         }
; 0000 0352                 if (  (temp2 & 0x08) && (devices>0) )                                       //   "  "  
_0x13C:
	LDS  R30,_temp2
	ANDI R30,LOW(0x8)
	BREQ _0x13E
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRSH _0x13F
_0x13E:
	RJMP _0x13D
_0x13F:
; 0000 0353                         {
; 0000 0354                         beg_info[t++]=42;                                                    // 
	CALL SUBOPT_0x5C
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0355                         if ((temp2 & 0x10) && (devices>1)) {
	LDS  R30,_temp2
	ANDI R30,LOW(0x10)
	BREQ _0x141
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRSH _0x142
_0x141:
	RJMP _0x140
_0x142:
; 0000 0356                                                             beg_info[t++]=14;  beg_info[t++]=24;   //  ""
	CALL SUBOPT_0x5C
	LDI  R26,LOW(14)
	CALL SUBOPT_0x5A
	LDI  R26,LOW(24)
	CALL SUBOPT_0x5A
; 0000 0357                                                             beg_info[t++]=22;  beg_info[t++]=10;   //  ""
	LDI  R26,LOW(22)
	CALL SUBOPT_0x5A
	LDI  R26,LOW(10)
	CALL SUBOPT_0x5A
; 0000 0358                                                             beg_info[t++]=42;                      // 
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0359                                                             }
; 0000 035A                         beg_info[t++]=44;                                                    //  
_0x140:
	CALL SUBOPT_0x5C
	LDI  R26,LOW(44)
	STD  Z+0,R26
; 0000 035B                          if (temperature[ds1820_d]!=0){
	CALL SUBOPT_0x43
	CALL SUBOPT_0x64
	SBIW R30,0
	BREQ _0x143
; 0000 035C                          if (temperature[ds1820_d]<0) beg_info[t++]=51;  else beg_info[t++]=47;              //     -   ,    -  
	CALL SUBOPT_0x43
	CALL SUBOPT_0x64
	TST  R31
	BRPL _0x144
	CALL SUBOPT_0x5C
	LDI  R26,LOW(51)
	RJMP _0x269
_0x144:
	CALL SUBOPT_0x5C
	LDI  R26,LOW(47)
_0x269:
	STD  Z+0,R26
; 0000 035D                                                       };
_0x143:
; 0000 035E                         if (abs(temperature[ds1820_d])>99) {beg_info[t++]=(abs(temperature[ds1820_d])/100);}//   >10,   ""  
	CALL SUBOPT_0x43
	CALL SUBOPT_0x64
	CALL SUBOPT_0x65
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x146
	CALL SUBOPT_0x5C
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x43
	CALL SUBOPT_0x64
	CALL SUBOPT_0x65
	CALL SUBOPT_0xC
	POP  R26
	POP  R27
	ST   X,R30
; 0000 035F                         if (td10==0){if (abs(temperature[ds1820_d]%10)>=5) {if (temperature[ds1820_d]<0){temperature[ds1820_d]-=1;}else{temperature[ds1820_d]+=1;}}}  //  1          0.5 C
_0x146:
	TST  R11
	BRNE _0x147
	CALL SUBOPT_0x43
	CALL SUBOPT_0x64
	CALL SUBOPT_0x66
	CALL SUBOPT_0x65
	SBIW R30,5
	BRLT _0x148
	CALL SUBOPT_0x43
	CALL SUBOPT_0x64
	TST  R31
	BRPL _0x149
	CALL SUBOPT_0x43
	CALL SUBOPT_0x67
	SBIW R30,1
	RJMP _0x26A
_0x149:
	CALL SUBOPT_0x43
	CALL SUBOPT_0x67
	ADIW R30,1
_0x26A:
	ST   -X,R31
	ST   -X,R30
_0x148:
; 0000 0360                         beg_info[t++]=(abs(temperature[ds1820_d])%100)/10;                   //  " "
_0x147:
	CALL SUBOPT_0x5C
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x43
	CALL SUBOPT_0x64
	CALL SUBOPT_0x65
	CALL SUBOPT_0x68
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0361                         //______________________________________________________     ____________________________________
; 0000 0362                         if (td10==1){beg_info[t++]=43;                                                 //  
	LDI  R30,LOW(1)
	CP   R30,R11
	BRNE _0x14B
	CALL SUBOPT_0x5C
	LDI  R26,LOW(43)
	CALL SUBOPT_0x5A
; 0000 0363                                    beg_info[t++]=abs(temperature[ds1820_d])%10;                      //   .
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x43
	CALL SUBOPT_0x64
	CALL SUBOPT_0x65
	CALL SUBOPT_0x66
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0364                                   }
; 0000 0365                         //____________________________________________________________________________________________________________________________
; 0000 0366                         beg_info[t++]=48;                                                    //  
_0x14B:
	CALL SUBOPT_0x5C
	LDI  R26,LOW(48)
	CALL SUBOPT_0x5A
; 0000 0367                         beg_info[t++]=42;                                                    // 
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0368                         }
; 0000 0369                 if ( (temp2 & 0x10) && (devices>1) )                                        //   "  "  
_0x13D:
	LDS  R30,_temp2
	ANDI R30,LOW(0x10)
	BREQ _0x14D
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRSH _0x14E
_0x14D:
	RJMP _0x14C
_0x14E:
; 0000 036A                         {
; 0000 036B                          beg_info[t++]=23;  beg_info[t++]=10;                                 //   ""
	CALL SUBOPT_0x5C
	LDI  R26,LOW(23)
	CALL SUBOPT_0x5A
	LDI  R26,LOW(10)
	CALL SUBOPT_0x5A
; 0000 036C                          beg_info[t++]=42;                                                    // 
	LDI  R26,LOW(42)
	CALL SUBOPT_0x5A
; 0000 036D                         beg_info[t++]=29;  beg_info[t++]=21;                                 //   ""
	LDI  R26,LOW(29)
	CALL SUBOPT_0x5A
	LDI  R26,LOW(21)
	CALL SUBOPT_0x5A
; 0000 036E                         beg_info[t++]=18;  beg_info[t++]=32;  beg_info[t++]=15;              //   ""
	LDI  R26,LOW(18)
	CALL SUBOPT_0x5A
	LDI  R26,LOW(32)
	CALL SUBOPT_0x5A
	LDI  R26,LOW(15)
	CALL SUBOPT_0x5A
; 0000 036F                          beg_info[t++]=42;                                                    //  
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0370                         if (temperature[ds1820_y]!=0){
	CALL SUBOPT_0x44
	CALL SUBOPT_0x64
	SBIW R30,0
	BREQ _0x14F
; 0000 0371                         if (temperature[ds1820_y]<0) beg_info[t++]=51;     else beg_info[t++]=47;          //     -   
	CALL SUBOPT_0x44
	CALL SUBOPT_0x64
	TST  R31
	BRPL _0x150
	CALL SUBOPT_0x5C
	LDI  R26,LOW(51)
	RJMP _0x26B
_0x150:
	CALL SUBOPT_0x5C
	LDI  R26,LOW(47)
_0x26B:
	STD  Z+0,R26
; 0000 0372                                                       };
_0x14F:
; 0000 0373                         if (abs(temperature[ds1820_y])>99){beg_info[t++]=(abs(temperature[ds1820_y])/100);}//    >10,   ""  
	CALL SUBOPT_0x44
	CALL SUBOPT_0x64
	CALL SUBOPT_0x65
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x152
	CALL SUBOPT_0x5C
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x44
	CALL SUBOPT_0x64
	CALL SUBOPT_0x65
	CALL SUBOPT_0xC
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0374                         if (tu10==0){if (abs(temperature[ds1820_y]%10)>=5) { if (temperature[ds1820_y]<0){temperature[ds1820_y]-=1;}else{temperature[ds1820_y]+=1;}}}  //  1          0.5 C
_0x152:
	TST  R10
	BRNE _0x153
	CALL SUBOPT_0x44
	CALL SUBOPT_0x64
	CALL SUBOPT_0x66
	CALL SUBOPT_0x65
	SBIW R30,5
	BRLT _0x154
	CALL SUBOPT_0x44
	CALL SUBOPT_0x64
	TST  R31
	BRPL _0x155
	CALL SUBOPT_0x44
	CALL SUBOPT_0x67
	SBIW R30,1
	RJMP _0x26C
_0x155:
	CALL SUBOPT_0x44
	CALL SUBOPT_0x67
	ADIW R30,1
_0x26C:
	ST   -X,R31
	ST   -X,R30
_0x154:
; 0000 0375                         beg_info[t++]=(abs(temperature[ds1820_y])%100)/10;                                 //  " "
_0x153:
	CALL SUBOPT_0x5C
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x44
	CALL SUBOPT_0x64
	CALL SUBOPT_0x65
	CALL SUBOPT_0x68
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0376                         //         -    
; 0000 0377                         if (tu10==1){ beg_info[t++]=43;                                                 //  
	LDI  R30,LOW(1)
	CP   R30,R10
	BRNE _0x157
	CALL SUBOPT_0x5C
	LDI  R26,LOW(43)
	CALL SUBOPT_0x5A
; 0000 0378                                    beg_info[t++]=abs(temperature[ds1820_y])%10;                      //   .
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x44
	CALL SUBOPT_0x64
	CALL SUBOPT_0x65
	CALL SUBOPT_0x66
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0379                                   }
; 0000 037A                         beg_info[t++]=48;                                                    //  
_0x157:
	CALL SUBOPT_0x5C
	LDI  R26,LOW(48)
	CALL SUBOPT_0x5A
; 0000 037B                         beg_info[t++]=42;  beg_info[t++]=42;                                 // 
	LDI  R26,LOW(42)
	CALL SUBOPT_0x5A
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 037C                         }
; 0000 037D 
; 0000 037E 
; 0000 037F                 if (time/600!=0) { beg_info[t++]=time/600;} else beg_info[t++]=42;        //     
_0x14C:
	CALL SUBOPT_0x5B
	SBIW R30,0
	BREQ _0x158
	CALL SUBOPT_0x5C
	MOVW R22,R30
	CALL SUBOPT_0x5B
	MOVW R26,R22
	ST   X,R30
	RJMP _0x159
_0x158:
	CALL SUBOPT_0x5C
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0380                 beg_info[t++]=(time%600)/60;         //     
_0x159:
	CALL SUBOPT_0x5C
	MOVW R22,R30
	CALL SUBOPT_0x11
	CALL SUBOPT_0x14
	CALL SUBOPT_0x53
; 0000 0381                 beg_info[t++]=44;                    //     
	CALL SUBOPT_0x60
	CALL SUBOPT_0x54
	CALL SUBOPT_0x51
; 0000 0382                 beg_info[t++]=(time%60)/10;          //     
	CALL SUBOPT_0x11
	CALL SUBOPT_0x15
	CALL SUBOPT_0x53
; 0000 0383                 beg_info[t++]=time%10;               //     
	CALL SUBOPT_0x60
	CALL SUBOPT_0x54
	MOVW R22,R30
	CALL SUBOPT_0x11
	CALL SUBOPT_0x16
	CALL SUBOPT_0x53
; 0000 0384 
; 0000 0385                 beg_info[t]=255;                     //      " "
	CALL SUBOPT_0x54
	CALL SUBOPT_0x55
; 0000 0386 
; 0000 0387                 if (Interval >= speed)  {Interval=0; if (beg_stroka(beg_info)==255) {if (temp==255)  ochistka(); meny=10; data1=time;}}
	BRLO _0x15A
	CALL SUBOPT_0x56
	RCALL _beg_stroka
	CPI  R30,LOW(0xFF)
	BRNE _0x15B
	LDS  R26,_temp
	CPI  R26,LOW(0xFF)
	BRNE _0x15C
	RCALL _ochistka
_0x15C:
	LDI  R30,LOW(10)
	MOV  R5,R30
	CALL SUBOPT_0x59
_0x15B:
; 0000 0388                if (BUT_STEP) { ochistka();  z=0; z1=0;  t=0; temp1=0;   meny=30;}
_0x15A:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x15D
	CALL SUBOPT_0x4C
; 0000 0389                if (BUT_OK)   { ochistka();  z=0; z1=0;  t=0; temp1=0;   meny=10;}
_0x15D:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x15E
	CALL SUBOPT_0x69
	LDI  R30,LOW(10)
	MOV  R5,R30
; 0000 038A         break;
_0x15E:
	JMP  _0x10C
; 0000 038B         case 20: //*********************************************************************
_0x132:
	CPI  R30,LOW(0x14)
	LDI  R26,HIGH(0x14)
	CPC  R31,R26
	BRNE _0x15F
; 0000 038C         sek0=1;
	SET
	BLD  R2,3
; 0000 038D         ekran [12]=0;  ekran [11]=128;
	LDI  R30,LOW(0)
	__PUTB1MN _ekran,12
	LDI  R30,LOW(128)
	__PUTB1MN _ekran,11
; 0000 038E         ekran_cifri(((time-(time/60*60))*60)+sek);
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x4E
	ST   -Y,R31
	ST   -Y,R30
	CALL _ekran_cifri
; 0000 038F         sek0=0;
	CLT
	BLD  R2,3
; 0000 0390         if (BUT_STEP)  {if (sek>40) {time++; if (time==1440) time=0;}  sek=0; TCNT2=0;  temp=10;}
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x160
	LDI  R30,LOW(40)
	CP   R30,R4
	BRSH _0x161
	LDI  R26,LOW(_time)
	LDI  R27,HIGH(_time)
	CALL SUBOPT_0x6
	CALL SUBOPT_0x11
	CPI  R26,LOW(0x5A0)
	LDI  R30,HIGH(0x5A0)
	CPC  R27,R30
	BRNE _0x162
	LDI  R30,LOW(0)
	STS  _time,R30
	STS  _time+1,R30
_0x162:
_0x161:
	CLR  R4
	LDI  R30,LOW(0)
	OUT  0x24,R30
	LDI  R30,LOW(10)
	STS  _temp,R30
; 0000 0391         if (BUT_OK)    {  z=0; z1=0;  t=0; temp1=0;   ochistka(); meny=11;}
_0x160:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x163
	CALL SUBOPT_0x6A
	LDI  R30,LOW(0)
	CALL SUBOPT_0x58
	RCALL _ochistka
	LDI  R30,LOW(11)
	MOV  R5,R30
; 0000 0392         break;
_0x163:
	JMP  _0x10C
; 0000 0393 
; 0000 0394         //**************************** ***********************************
; 0000 0395         case 30: //     - ""
_0x15F:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x164
; 0000 0396             if (Interval>=speed)  {Interval=0;  beg_stroka(budilnik_txt);}
	CALL SUBOPT_0x6B
	BRLO _0x165
	CALL SUBOPT_0x6C
	LDI  R30,LOW(_budilnik_txt)
	LDI  R31,HIGH(_budilnik_txt)
	CALL SUBOPT_0x6D
; 0000 0397             if (BUT_STEP)         {  t=0; temp1=0; meny=40;z=0; z1=0;ochistka();}
_0x165:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x166
	LDI  R30,LOW(0)
	CALL SUBOPT_0x58
	LDI  R30,LOW(40)
	CALL SUBOPT_0x4F
	RCALL _ochistka
; 0000 0398             if (BUT_OK)           {ochistka(); bud=0; temp=0; meny=32;}
_0x166:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x167
	RCALL _ochistka
	LDI  R30,LOW(0)
	STS  _bud,R30
	STS  _temp,R30
	LDI  R30,LOW(32)
	MOV  R5,R30
; 0000 0399         break;
_0x167:
	RJMP _0x10C
; 0000 039A         case 32: //    
_0x164:
	CPI  R30,LOW(0x20)
	LDI  R26,HIGH(0x20)
	CPC  R31,R26
	BRNE _0x168
; 0000 039B             if (BUT_STEP) {meny=34;}
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x169
	LDI  R30,LOW(34)
	MOV  R5,R30
; 0000 039C             if (BUT_OK  ) {bud++; if (bud==9) bud=0;  }
_0x169:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x16A
	LDS  R30,_bud
	SUBI R30,-LOW(1)
	STS  _bud,R30
	LDS  R26,_bud
	CPI  R26,LOW(0x9)
	BRNE _0x16B
	LDI  R30,LOW(0)
	STS  _bud,R30
_0x16B:
; 0000 039D             ekran_1_figure(11,1,1); line=1; ekran_1_figure(bud+1,7,1); line=0; ekran_1_figure(((budilnik_Install[bud] & 0x80) ? (47):(46)),17,1);
_0x16A:
	CALL SUBOPT_0x6E
	SET
	BLD  R3,3
	CALL SUBOPT_0x6F
	CLT
	CALL SUBOPT_0x70
	BREQ _0x16C
	LDI  R30,LOW(47)
	RJMP _0x16D
_0x16C:
	LDI  R30,LOW(46)
_0x16D:
	CALL SUBOPT_0x71
; 0000 039E         break;
	RJMP _0x10C
; 0000 039F         case 34: //     .    -    ""
_0x168:
	CPI  R30,LOW(0x22)
	LDI  R26,HIGH(0x22)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x16F
; 0000 03A0             if (BUT_STEP)
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x170
; 0000 03A1                     {
; 0000 03A2                     if (budilnik_Install[bud] & 0x80)    //    
	CALL SUBOPT_0x72
	LD   R30,Z
	ANDI R30,LOW(0x80)
	BREQ _0x171
; 0000 03A3                         {
; 0000 03A4                         budilnik_time[bud]= ystanovki_23_59 (budilnik_time[bud]);     //    
	LDS  R30,_bud
	CALL SUBOPT_0x3F
	PUSH R31
	PUSH R30
	LDS  R30,_bud
	CALL SUBOPT_0x73
	CALL SUBOPT_0x74
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
; 0000 03A5                             if (bud<3){budilnik_Install[bud] = 0xFF; goto m1;}        //   1-3   "  "  ,         
	LDS  R26,_bud
	CPI  R26,LOW(0x3)
	BRSH _0x172
	CALL SUBOPT_0x72
	LDI  R26,LOW(255)
	STD  Z+0,R26
	RJMP _0x173
; 0000 03A6                             else {temp=0;  meny=36;}                                  //   4-9          
_0x172:
	LDI  R30,LOW(0)
	STS  _temp,R30
	LDI  R30,LOW(36)
	MOV  R5,R30
; 0000 03A7                         }
; 0000 03A8                     else { ochistka(); z=0; z1=0;  t=0; temp1=0; meny=10;}   ochistka();  break;                      //     -    ""
	RJMP _0x175
_0x171:
	CALL SUBOPT_0x69
	LDI  R30,LOW(10)
	MOV  R5,R30
_0x175:
	RCALL _ochistka
	RJMP _0x10C
; 0000 03A9                     }
; 0000 03AA             if (BUT_OK )  {budilnik_Install[bud] ^= 0x80;}                     //    /   (/  1 7)
_0x170:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x176
	CALL SUBOPT_0x72
	MOVW R0,R30
	LD   R26,Z
	LDI  R30,LOW(128)
	EOR  R30,R26
	MOVW R26,R0
	ST   X,R30
; 0000 03AB             ekran_1_figure(11,1,1); ekran_1_figure(bud+1,7,1); line=1; ekran_1_figure(((budilnik_Install[bud] & 0x80) ? (47):(46)),17,1); line=0;
_0x176:
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x6F
	SET
	CALL SUBOPT_0x70
	BREQ _0x177
	LDI  R30,LOW(47)
	RJMP _0x178
_0x177:
	LDI  R30,LOW(46)
_0x178:
	CALL SUBOPT_0x71
	CLT
	BLD  R3,3
; 0000 03AC         break;
	RJMP _0x10C
; 0000 03AD         case 36:  //        ,    .
_0x16F:
	CPI  R30,LOW(0x24)
	LDI  R26,HIGH(0x24)
	CPC  R31,R26
	BRNE _0x17A
; 0000 03AE             ekran_1_figure (den_nedeli_letter[temp][0],0,1);  ekran_1_figure (den_nedeli_letter[temp][1],6,1);                 //    . ( "beg_info"    )
	CALL SUBOPT_0x75
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CALL SUBOPT_0x34
	CALL SUBOPT_0x75
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+1
	CALL SUBOPT_0x35
; 0000 03AF             ekran_1_figure (((budilnik_Install[bud] & (1 << temp)) ? 47:46),17,1);                                             //   "+"  "-"    ./. .
	CALL SUBOPT_0x72
	LD   R1,Z
	LDS  R30,_temp
	CALL SUBOPT_0x76
	BREQ _0x17B
	LDI  R30,LOW(47)
	RJMP _0x17C
_0x17B:
	LDI  R30,LOW(46)
_0x17C:
	CALL SUBOPT_0x71
; 0000 03B0 
; 0000 03B1             if (BUT_STEP) {temp++;  ochistka(); z=0; z1=0;  t=0; temp1=0;                                                      // ""     
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x17E
	CALL SUBOPT_0x42
	CALL SUBOPT_0x69
; 0000 03B2                           if (temp==7){m1:  ochistka(); z=0; z1=0;  t=0; temp1=0;meny=38;  }           //      ,     .
	LDS  R26,_temp
	CPI  R26,LOW(0x7)
	BRNE _0x17F
_0x173:
	CALL SUBOPT_0x69
	LDI  R30,LOW(38)
	MOV  R5,R30
; 0000 03B3                           }
_0x17F:
; 0000 03B4             if (BUT_OK){(budilnik_Install[bud]) ^= (1 << temp);}                                                               // /     .
_0x17E:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x180
	CALL SUBOPT_0x72
	MOVW R22,R30
	LD   R1,Z
	LDS  R30,_temp
	LDI  R26,LOW(1)
	CALL __LSLB12
	EOR  R30,R1
	MOVW R26,R22
	ST   X,R30
; 0000 03B5         break;
_0x180:
	RJMP _0x10C
; 0000 03B6          case 38: //*********************    *********************************//
_0x17A:
	CPI  R30,LOW(0x26)
	LDI  R26,HIGH(0x26)
	CPC  R31,R26
	BRNE _0x181
; 0000 03B7                if (Interval>=speed)  {Interval=0;  if ( beg_stroka(budilnik_Interval_txt)==255) {delay_ms(500);ochistka(); z=0; z1=0;  t=0; temp1=0;meny=39;}} ;
	CALL SUBOPT_0x6B
	BRLO _0x182
	CALL SUBOPT_0x6C
	LDI  R30,LOW(_budilnik_Interval_txt)
	LDI  R31,HIGH(_budilnik_Interval_txt)
	CALL SUBOPT_0x6D
	CPI  R30,LOW(0xFF)
	BRNE _0x183
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	CALL SUBOPT_0x69
	LDI  R30,LOW(39)
	MOV  R5,R30
_0x183:
_0x182:
; 0000 03B8                if (BUT_OK) { ochistka(); z=0; z1=0;  t=0; temp1=0;meny=39; }
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x184
	CALL SUBOPT_0x69
	LDI  R30,LOW(39)
	MOV  R5,R30
; 0000 03B9         break;
_0x184:
	RJMP _0x10C
; 0000 03BA         case 39:
_0x181:
	CPI  R30,LOW(0x27)
	LDI  R26,HIGH(0x27)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x185
; 0000 03BB           if( budilnik_Interval[bud]==0)budilnik_Interval[bud]=1;
	CALL SUBOPT_0x77
	LD   R30,Z
	CPI  R30,0
	BRNE _0x186
	CALL SUBOPT_0x77
	LDI  R26,LOW(1)
	STD  Z+0,R26
; 0000 03BC                if( budilnik_Interval[bud]<10){ ekran_1_figure(((budilnik_Interval[bud])%10),2,1);
_0x186:
	CALL SUBOPT_0x77
	LD   R26,Z
	CPI  R26,LOW(0xA)
	BRSH _0x187
	CALL SUBOPT_0x77
	CALL SUBOPT_0x78
	LDI  R30,LOW(2)
	CALL SUBOPT_0x79
; 0000 03BD                 ekran_1_figure(22,9,0); ekran_1_figure(18,15,0); ekran_1_figure(23,20,0);}
	LDI  R30,LOW(9)
	CALL SUBOPT_0x7A
	LDI  R30,LOW(15)
	RJMP _0x26D
; 0000 03BE                 else {
_0x187:
; 0000 03BF                        ekran_1_figure(((budilnik_Interval[bud])/10),0,1); ekran_1_figure(((budilnik_Interval[bud])%10),5,1);
	CALL SUBOPT_0x77
	LD   R26,Z
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x34
	CALL SUBOPT_0x77
	CALL SUBOPT_0x78
	LDI  R30,LOW(5)
	CALL SUBOPT_0x79
; 0000 03C0                         ekran_1_figure(22,11,0); ekran_1_figure(18,16,0); ekran_1_figure(23,20,0);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x7A
	LDI  R30,LOW(16)
_0x26D:
	ST   -Y,R30
	CALL SUBOPT_0x7B
	LDI  R30,LOW(23)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL SUBOPT_0x7B
; 0000 03C1                      }
; 0000 03C2                  if (BUT_STEP) { ochistka(); z=0; z1=0;  t=0; temp1=0;meny=10; }
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x189
	CALL SUBOPT_0x69
	LDI  R30,LOW(10)
	MOV  R5,R30
; 0000 03C3                  if (BUT_OK)   { budilnik_Interval[bud]+=1; ochistka();  if( budilnik_Interval[bud]>15)budilnik_Interval[bud]=1;};
_0x189:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x18A
	LDS  R26,_bud
	LDI  R27,0
	SUBI R26,LOW(-_budilnik_Interval)
	SBCI R27,HIGH(-_budilnik_Interval)
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	CALL _ochistka
	CALL SUBOPT_0x77
	LD   R26,Z
	CPI  R26,LOW(0x10)
	BRLO _0x18B
	CALL SUBOPT_0x77
	LDI  R26,LOW(1)
	STD  Z+0,R26
_0x18B:
_0x18A:
; 0000 03C4         break;
	RJMP _0x10C
; 0000 03C5 
; 0000 03C6          case 40: //*********************   ****************************
_0x185:
	CPI  R30,LOW(0x28)
	LDI  R26,HIGH(0x28)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x18C
; 0000 03C7 
; 0000 03C8                 if (Interval>=speed)  {Interval=0; beg_stroka(nastroiki_txt);}
	CALL SUBOPT_0x6B
	BRLO _0x18D
	CALL SUBOPT_0x6C
	LDI  R30,LOW(_nastroiki_txt)
	LDI  R31,HIGH(_nastroiki_txt)
	CALL SUBOPT_0x6D
; 0000 03C9                 if (BUT_STEP) {meny=50; z=0; z1=0; ochistka();}
_0x18D:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x18E
	LDI  R30,LOW(50)
	CALL SUBOPT_0x4F
	CALL _ochistka
; 0000 03CA                 if (BUT_OK)
_0x18E:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x18F
; 0000 03CB                         {
; 0000 03CC                         time   =ystanovki_23_59(time);
	CALL SUBOPT_0x45
	CALL SUBOPT_0x74
	STS  _time,R30
	STS  _time+1,R31
; 0000 03CD                         ochistka();
	CALL _ochistka
; 0000 03CE                         ekran_1_figure(33,1,1);          ekran_1_figure(43,6,1);
	LDI  R30,LOW(33)
	CALL SUBOPT_0x7C
	CALL SUBOPT_0x35
; 0000 03CF                         chislo =ystanovki_2 (chislo,31, 13);
	ST   -Y,R7
	LDI  R30,LOW(31)
	CALL SUBOPT_0x37
	MOV  R7,R30
; 0000 03D0                         ekran_1_figure(22,1,1);          ekran_1_figure(43,7,1);
	LDI  R30,LOW(22)
	CALL SUBOPT_0x7C
	ST   -Y,R30
	LDI  R30,LOW(7)
	CALL SUBOPT_0x7D
; 0000 03D1                         mesec  =ystanovki_2 (mesec, 12, 13);
	ST   -Y,R6
	LDI  R30,LOW(12)
	CALL SUBOPT_0x37
	MOV  R6,R30
; 0000 03D2                         ekran_1_figure(13,1,1);          ekran_1_figure(43,5,1);
	LDI  R30,LOW(13)
	CALL SUBOPT_0x7C
	CALL SUBOPT_0x7E
; 0000 03D3                         god    =ystanovki_2 (god,   99, 13);
	ST   -Y,R9
	LDI  R30,LOW(99)
	CALL SUBOPT_0x37
	MOV  R9,R30
; 0000 03D4                         button=0;ochistka(); temp=0 ;meny=10;
	LDI  R30,LOW(0)
	STS  _button,R30
	CALL _ochistka
	LDI  R30,LOW(0)
	STS  _temp,R30
	LDI  R30,LOW(10)
	MOV  R5,R30
; 0000 03D5                         }
; 0000 03D6         break;
_0x18F:
	RJMP _0x10C
; 0000 03D7 
; 0000 03D8         case 50: //    - ""
_0x18C:
	CPI  R30,LOW(0x32)
	LDI  R26,HIGH(0x32)
	CPC  R31,R26
	BRNE _0x190
; 0000 03D9                if (Interval>=speed)  {Interval=0;   beg_stroka(nastr_stroki_txt);}
	CALL SUBOPT_0x6B
	BRLO _0x191
	CALL SUBOPT_0x6C
	LDI  R30,LOW(_nastr_stroki_txt)
	LDI  R31,HIGH(_nastr_stroki_txt)
	CALL SUBOPT_0x6D
; 0000 03DA                if (BUT_STEP) { z=0; z1=0; ochistka();meny=60;}
_0x191:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x192
	CALL SUBOPT_0x6A
	CALL _ochistka
	LDI  R30,LOW(60)
	MOV  R5,R30
; 0000 03DB                if (BUT_OK)   {z=0; z1=0;temp=0;meny=51; ochistka(); }
_0x192:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x193
	CALL SUBOPT_0x4B
	LDI  R30,LOW(51)
	MOV  R5,R30
	CALL _ochistka
; 0000 03DC         break;
_0x193:
	RJMP _0x10C
; 0000 03DD         case 51:
_0x190:
	CPI  R30,LOW(0x33)
	LDI  R26,HIGH(0x33)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x194
; 0000 03DE                 if (BUT_STEP) {temp++; ochistka();}
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x195
	CALL SUBOPT_0x42
	CALL _ochistka
; 0000 03DF                 switch (temp)
_0x195:
	CALL SUBOPT_0x40
; 0000 03E0                         {
; 0000 03E1                         case 0:  if (BUT_OK){str ^= (1 << 0);}      txt_ekran(den_txt);  ekran_1_figure (((str & 0x01) ? 47:46),19,1);            break;
	SBIW R30,0
	BRNE _0x199
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x19A
	CALL SUBOPT_0x4A
	LDI  R26,LOW(1)
	CALL SUBOPT_0x7F
_0x19A:
	LDI  R30,LOW(_den_txt)
	LDI  R31,HIGH(_den_txt)
	CALL SUBOPT_0x80
	ANDI R30,LOW(0x1)
	BREQ _0x19B
	LDI  R30,LOW(47)
	RJMP _0x19C
_0x19B:
	LDI  R30,LOW(46)
_0x19C:
	RCALL SUBOPT_0x32
	RJMP _0x198
; 0000 03E2                         case 1:  if (BUT_OK){str ^= (1 << 1);}      txt_ekran(data_txt); ekran_1_figure (((str & 0x02) ? 47:46),19,1);            break;
_0x199:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x19E
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x19F
	CALL SUBOPT_0x4A
	LDI  R26,LOW(2)
	CALL SUBOPT_0x7F
_0x19F:
	LDI  R30,LOW(_data_txt)
	LDI  R31,HIGH(_data_txt)
	CALL SUBOPT_0x80
	ANDI R30,LOW(0x2)
	BREQ _0x1A0
	LDI  R30,LOW(47)
	RJMP _0x1A1
_0x1A0:
	LDI  R30,LOW(46)
_0x1A1:
	RCALL SUBOPT_0x32
	RJMP _0x198
; 0000 03E3                         case 2:  if (BUT_OK){str ^= (1 << 2);}      txt_ekran(god_txt);  ekran_1_figure (((str & 0x04) ? 47:46),19,1);            break;
_0x19E:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x1A3
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x1A4
	CALL SUBOPT_0x4A
	LDI  R26,LOW(4)
	CALL SUBOPT_0x7F
_0x1A4:
	LDI  R30,LOW(_god_txt)
	LDI  R31,HIGH(_god_txt)
	CALL SUBOPT_0x80
	ANDI R30,LOW(0x4)
	BREQ _0x1A5
	LDI  R30,LOW(47)
	RJMP _0x1A6
_0x1A5:
	LDI  R30,LOW(46)
_0x1A6:
	RCALL SUBOPT_0x32
	RJMP _0x198
; 0000 03E4                         case 3:  if (BUT_OK){sek_ind++;      }      ekran_1_figure (((sek_ind) ? 47:46),19,1);      ekran_1_figure(27,0,1); ekran_1_figure(15,5,1); ekran_1_figure(20,9,1); ekran_1_figure(43,15,1); break;
_0x1A3:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x1A8
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x1A9
	LDI  R30,LOW(64)
	EOR  R2,R30
_0x1A9:
	SBRS R2,6
	RJMP _0x1AA
	LDI  R30,LOW(47)
	RJMP _0x1AB
_0x1AA:
	LDI  R30,LOW(46)
_0x1AB:
	RCALL SUBOPT_0x32
	LDI  R30,LOW(27)
	RCALL SUBOPT_0x34
	LDI  R30,LOW(15)
	CALL SUBOPT_0x7E
	LDI  R30,LOW(20)
	CALL SUBOPT_0x81
	LDI  R30,LOW(43)
	ST   -Y,R30
	LDI  R30,LOW(15)
	CALL SUBOPT_0x7D
	RJMP _0x198
; 0000 03E5                         case 4:  if (BUT_OK){zv_chs++;       }      ekran_1_figure (((zv_chs) ? 47:46),19,1);       ekran_1_figure(16,0,1); ekran_1_figure(12,5,1); ekran_1_figure(43,9,1); ekran_1_figure(33,10,1); ekran_1_figure(27,14,1); break;
_0x1A8:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x1AD
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x1AE
	LDI  R30,LOW(2)
	EOR  R3,R30
_0x1AE:
	SBRS R3,1
	RJMP _0x1AF
	LDI  R30,LOW(47)
	RJMP _0x1B0
_0x1AF:
	LDI  R30,LOW(46)
_0x1B0:
	RCALL SUBOPT_0x32
	LDI  R30,LOW(16)
	RCALL SUBOPT_0x34
	LDI  R30,LOW(12)
	CALL SUBOPT_0x7E
	LDI  R30,LOW(43)
	CALL SUBOPT_0x81
	LDI  R30,LOW(33)
	CALL SUBOPT_0x82
	LDI  R30,LOW(27)
	CALL SUBOPT_0x83
	RJMP _0x198
; 0000 03E6                         case 5:  if (BUT_OK){zv_kn++;        }      ekran_1_figure (((zv_kn)  ? 47:46),19,1);       ekran_1_figure(16,0,1); ekran_1_figure(12,5,1); ekran_1_figure(43,9,1); ekran_1_figure(20,10,1); ekran_1_figure(23,14,1); break;
_0x1AD:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x1B2
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x1B3
	LDI  R30,LOW(1)
	EOR  R3,R30
_0x1B3:
	SBRS R3,0
	RJMP _0x1B4
	LDI  R30,LOW(47)
	RJMP _0x1B5
_0x1B4:
	LDI  R30,LOW(46)
_0x1B5:
	RCALL SUBOPT_0x32
	LDI  R30,LOW(16)
	RCALL SUBOPT_0x34
	LDI  R30,LOW(12)
	CALL SUBOPT_0x7E
	LDI  R30,LOW(43)
	CALL SUBOPT_0x81
	LDI  R30,LOW(20)
	CALL SUBOPT_0x82
	LDI  R30,LOW(23)
	CALL SUBOPT_0x83
	RJMP _0x198
; 0000 03E7                         case 6:  if (devices==2){if (Interval>=speed)  {Interval=0;   beg_stroka(perenazna_datchik);};if (BUT_OK){ochistka();meny=53;};} else {temp++;} break;
_0x1B2:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x1B7
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRNE _0x1B8
	CALL SUBOPT_0x6B
	BRLO _0x1B9
	CALL SUBOPT_0x6C
	LDI  R30,LOW(_perenazna_datchik)
	LDI  R31,HIGH(_perenazna_datchik)
	CALL SUBOPT_0x6D
_0x1B9:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x1BA
	CALL _ochistka
	LDI  R30,LOW(53)
	MOV  R5,R30
_0x1BA:
	RJMP _0x1BB
_0x1B8:
	RCALL SUBOPT_0x42
_0x1BB:
	RJMP _0x198
; 0000 03E8                         case 7:  if (devices==1){ if (BUT_OK){str ^= (1 << 3); }     ekran_1_figure (((str & 0x08) ? 47:46),19,1);   ekran_1_figure(50,0,1); ekran_1_figure(48,4,1);break;}
_0x1B7:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x1BC
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRNE _0x1BD
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x1BE
	RCALL SUBOPT_0x4A
	LDI  R26,LOW(8)
	CALL SUBOPT_0x7F
_0x1BE:
	RCALL SUBOPT_0x4A
	ANDI R30,LOW(0x8)
	BREQ _0x1BF
	LDI  R30,LOW(47)
	RJMP _0x1C0
_0x1BF:
	LDI  R30,LOW(46)
_0x1C0:
	RCALL SUBOPT_0x32
	LDI  R30,LOW(50)
	RCALL SUBOPT_0x34
	CALL SUBOPT_0x84
	RJMP _0x198
; 0000 03E9                         else    {if (devices>1){  if (BUT_OK){str ^= (1 << 3); }     ekran_1_figure (((str & 0x08) ? 47:46),19,1);   ekran_1_figure(50,0,1); ekran_1_figure(48,4,1); ekran_1_figure(14,10,1);} else {temp++;} break;}        //  
_0x1BD:
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRLO _0x1C3
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x1C4
	RCALL SUBOPT_0x4A
	LDI  R26,LOW(8)
	CALL SUBOPT_0x7F
_0x1C4:
	RCALL SUBOPT_0x4A
	ANDI R30,LOW(0x8)
	BREQ _0x1C5
	LDI  R30,LOW(47)
	RJMP _0x1C6
_0x1C5:
	LDI  R30,LOW(46)
_0x1C6:
	RCALL SUBOPT_0x32
	LDI  R30,LOW(50)
	RCALL SUBOPT_0x34
	CALL SUBOPT_0x84
	LDI  R30,LOW(14)
	CALL SUBOPT_0x82
	RJMP _0x1C8
_0x1C3:
	RCALL SUBOPT_0x42
_0x1C8:
	RJMP _0x198
; 0000 03EA                         case 8:  if ((str & 0x08) && (devices>0))  { z=0; z1=0;meny=57;} else {temp++;}  break;
_0x1BC:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x1CA
	RCALL SUBOPT_0x4A
	ANDI R30,LOW(0x8)
	BREQ _0x1CC
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRSH _0x1CD
_0x1CC:
	RJMP _0x1CB
_0x1CD:
	CALL SUBOPT_0x6A
	LDI  R30,LOW(57)
	MOV  R5,R30
	RJMP _0x1CE
_0x1CB:
	RCALL SUBOPT_0x42
_0x1CE:
	RJMP _0x198
; 0000 03EB                         case 9:  if (devices>1){if (BUT_OK){str ^= (1 << 4);}      ekran_1_figure (((str & 0x10) ? 47:46),19,1);   ekran_1_figure(50,0,1); ekran_1_figure(48,4,1); ekran_1_figure(29,10,1);} else {temp++;}  break;       //   
_0x1CA:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x1CF
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRLO _0x1D0
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x1D1
	RCALL SUBOPT_0x4A
	LDI  R26,LOW(16)
	CALL SUBOPT_0x7F
_0x1D1:
	RCALL SUBOPT_0x4A
	ANDI R30,LOW(0x10)
	BREQ _0x1D2
	LDI  R30,LOW(47)
	RJMP _0x1D3
_0x1D2:
	LDI  R30,LOW(46)
_0x1D3:
	RCALL SUBOPT_0x32
	LDI  R30,LOW(50)
	RCALL SUBOPT_0x34
	CALL SUBOPT_0x84
	LDI  R30,LOW(29)
	CALL SUBOPT_0x82
	RJMP _0x1D5
_0x1D0:
	RCALL SUBOPT_0x42
_0x1D5:
	RJMP _0x198
; 0000 03EC                         case 10: if ((str & 0x10) && (devices>1))  {z=0; z1=0; meny=58;} else {temp++;}  break;
_0x1CF:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x1D6
	RCALL SUBOPT_0x4A
	ANDI R30,LOW(0x10)
	BREQ _0x1D8
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRSH _0x1D9
_0x1D8:
	RJMP _0x1D7
_0x1D9:
	CALL SUBOPT_0x6A
	LDI  R30,LOW(58)
	MOV  R5,R30
	RJMP _0x1DA
_0x1D7:
	RCALL SUBOPT_0x42
_0x1DA:
	RJMP _0x198
; 0000 03ED                         case 11: z=0; z1=0; meny=52; temp=speed; break;
_0x1D6:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BRNE _0x198
	CALL SUBOPT_0x6A
	LDI  R30,LOW(52)
	MOV  R5,R30
	LDS  R30,_speed
	STS  _temp,R30
; 0000 03EE                         }
_0x198:
; 0000 03EF         break;
	RJMP _0x10C
; 0000 03F0         case 52: //    
_0x194:
	CPI  R30,LOW(0x34)
	LDI  R26,HIGH(0x34)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x1DC
; 0000 03F1             if (Interval>=temp)  {Interval=0; beg_stroka(speed_txt);}
	LDS  R30,_temp
	LDS  R26,_Interval
	LDS  R27,_Interval+1
	LDI  R31,0
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x1DD
	CALL SUBOPT_0x6C
	LDI  R30,LOW(_speed_txt)
	LDI  R31,HIGH(_speed_txt)
	CALL SUBOPT_0x6D
; 0000 03F2             if (BUT_OK)  {temp+=3;  if (temp>=60) {temp=9;} ochistka();ekran_1_figure((((60-temp)/3)/10),8,1); ekran_1_figure((((60-temp)/3)%10),14,1);delay_ms(1000);z=0; z1=0;  t=0; temp1=0; ochistka(); }
_0x1DD:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x1DE
	LDS  R30,_temp
	SUBI R30,-LOW(3)
	STS  _temp,R30
	LDS  R26,_temp
	CPI  R26,LOW(0x3C)
	BRLO _0x1DF
	LDI  R30,LOW(9)
	STS  _temp,R30
_0x1DF:
	CALL _ochistka
	RCALL SUBOPT_0x40
	CALL SUBOPT_0x85
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	ST   -Y,R30
	LDI  R30,LOW(8)
	CALL SUBOPT_0x7D
	RCALL SUBOPT_0x40
	CALL SUBOPT_0x85
	CALL SUBOPT_0x66
	CALL SUBOPT_0x83
	RCALL SUBOPT_0x57
	STS  _z,R30
	LDI  R30,LOW(0)
	STS  _z1,R30
	RCALL SUBOPT_0x58
	CALL _ochistka
; 0000 03F3             if (BUT_STEP)   {speed=temp;ochistka(); if(foto_r)meny=56; else meny=54;} //    ,     . temp5=0
_0x1DE:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x1E0
	LDS  R30,_temp
	STS  _speed,R30
	CALL _ochistka
	LDS  R30,_foto_r
	CPI  R30,0
	BREQ _0x1E1
	LDI  R30,LOW(56)
	RJMP _0x26E
_0x1E1:
	LDI  R30,LOW(54)
_0x26E:
	MOV  R5,R30
; 0000 03F4                                                                                                                         //   ,            .
; 0000 03F5         break;
_0x1E0:
	RJMP _0x10C
; 0000 03F6         case 53: //    ds18m20 (  2 )
_0x1DC:
	CPI  R30,LOW(0x35)
	LDI  R26,HIGH(0x35)
	CPC  R31,R26
	BRNE _0x1E3
; 0000 03F7 
; 0000 03F8             ekran_1_figure (14,0,1);
	LDI  R30,LOW(14)
	RCALL SUBOPT_0x34
; 0000 03F9             ekran_1_figure (((temperature[temp5]<0) ? 51:47),8,1);
	CALL SUBOPT_0x86
	TST  R31
	BRPL _0x1E4
	LDI  R30,LOW(51)
	RJMP _0x1E5
_0x1E4:
	LDI  R30,LOW(47)
_0x1E5:
	ST   -Y,R30
	LDI  R30,LOW(8)
	CALL SUBOPT_0x7D
; 0000 03FA             ekran_1_figure ((abs(temperature[temp5])/100),13,1);
	CALL SUBOPT_0x86
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x31
; 0000 03FB             ekran_1_figure (((abs(temperature[temp5])%100)/10),19,1);
	CALL SUBOPT_0x86
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x68
	RCALL SUBOPT_0x32
; 0000 03FC             if (BUT_OK)  {temp5++;}
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x1E7
	LDI  R30,LOW(32)
	EOR  R3,R30
; 0000 03FD             if (BUT_STEP)   { ochistka();z=0; z1=0;  t=0; temp1=0;   if (temp5)  {ds1820_d=1; ds1820_y=0;}  else {ds1820_d=0; ds1820_y=1;} ;{ochistka(); temp=7; meny=51;}} ;
_0x1E7:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x1E8
	RCALL SUBOPT_0x69
	SBRS R3,5
	RJMP _0x1E9
	LDI  R26,LOW(_ds1820_d)
	LDI  R27,HIGH(_ds1820_d)
	LDI  R30,LOW(1)
	CALL __EEPROMWRB
	LDI  R26,LOW(_ds1820_y)
	LDI  R27,HIGH(_ds1820_y)
	LDI  R30,LOW(0)
	RJMP _0x26F
_0x1E9:
	RCALL SUBOPT_0xA
	LDI  R26,LOW(_ds1820_y)
	LDI  R27,HIGH(_ds1820_y)
	LDI  R30,LOW(1)
_0x26F:
	CALL __EEPROMWRB
	CALL _ochistka
	LDI  R30,LOW(7)
	CALL SUBOPT_0x87
_0x1E8:
; 0000 03FE         break;
	RJMP _0x10C
; 0000 03FF 
; 0000 0400 
; 0000 0401         case 57:  // __________________________    ________________________________________________________
_0x1E3:
	CPI  R30,LOW(0x39)
	LDI  R26,HIGH(0x39)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x1EB
; 0000 0402            t=0; temp1=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x58
; 0000 0403                  beg_info[t++] = beg_info[t++] = beg_info[t++] = 42;   beg_info[t++]=44;
	RCALL SUBOPT_0x5C
	MOVW R22,R30
	RCALL SUBOPT_0x5C
	MOVW R0,R30
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x5E
	ST   X,R30
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(44)
	STD  Z+0,R26
; 0000 0404                  if (td10==0){
	TST  R11
	BRNE _0x1EC
; 0000 0405                                 beg_info[t++]=11; beg_info[t++]=15;
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(11)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(15)
	RCALL SUBOPT_0x5A
; 0000 0406                                 beg_info[t++]=16; beg_info[t++]=42;
	LDI  R26,LOW(16)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(42)
	RCALL SUBOPT_0x5A
; 0000 0407                                 beg_info[t++]=28; beg_info[t++]=24;   //  "T"
	LDI  R26,LOW(28)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(24)
	RCALL SUBOPT_0x5A
; 0000 0408                                 beg_info[t++]=33;  beg_info[t++]=20;   //  ""
	LDI  R26,LOW(33)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(20)
	RCALL SUBOPT_0x5A
; 0000 0409                                 beg_info[t++]=18;                     //  ""
	LDI  R26,LOW(18)
	RJMP _0x270
; 0000 040A                              }
; 0000 040B 
; 0000 040C             else {
_0x1EC:
; 0000 040D                       beg_info[t++]=27;                     //       ""
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(27)
	RCALL SUBOPT_0x5A
; 0000 040E                       beg_info[t++]=42;
	LDI  R26,LOW(42)
	RCALL SUBOPT_0x5A
; 0000 040F                       beg_info[t++]=28; beg_info[t++]=24;   //  "T"
	LDI  R26,LOW(28)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(24)
	RCALL SUBOPT_0x5A
; 0000 0410                       beg_info[t++]=33;  beg_info[t++]=20;   //  ""
	LDI  R26,LOW(33)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(20)
	RCALL SUBOPT_0x5A
; 0000 0411                       beg_info[t++]=24;  beg_info[t++]=19;   //  ""
	LDI  R26,LOW(24)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(19)
_0x270:
	STD  Z+0,R26
; 0000 0412                   }
; 0000 0413                  beg_info[t++]=42;  beg_info[t++]=50;   //  " t"
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(42)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(50)
	RCALL SUBOPT_0x5A
; 0000 0414                  beg_info[t++]=42;
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0415                 if (devices>1) {   beg_info[t++]=14;  beg_info[t++]=24;   //  ""
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRLO _0x1EE
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(14)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(24)
	RCALL SUBOPT_0x5A
; 0000 0416                                     beg_info[t++]=22;  beg_info[t++]=10;   //  ""
	LDI  R26,LOW(22)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(10)
	RCALL SUBOPT_0x5A
; 0000 0417                                     beg_info[t++]=42;
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0418                                  }
; 0000 0419          if (td10==0){
_0x1EE:
	TST  R11
	BRNE _0x1EF
; 0000 041A                         if (temperature[ds1820_d]!=0){
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	SBIW R30,0
	BREQ _0x1F0
; 0000 041B                          if (temperature[ds1820_d]<0) beg_info[t++]=51;  else beg_info[t++]=47;             //     -   ,    -  
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	TST  R31
	BRPL _0x1F1
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(51)
	RJMP _0x271
_0x1F1:
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(47)
_0x271:
	STD  Z+0,R26
; 0000 041C                               };
_0x1F0:
; 0000 041D                         if (abs(temperature[ds1820_d])>99) {beg_info[t++]=(abs(temperature[ds1820_d])/100);}//   >10,   ""  
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x1F3
	RCALL SUBOPT_0x5C
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0xC
	POP  R26
	POP  R27
	ST   X,R30
; 0000 041E                         if (abs(temperature[ds1820_d]%10)>=5) {if (temperature[ds1820_d]<0){temperature[ds1820_d]-=1;}else{temperature[ds1820_d]+=1;}}  //  1          0.5 C
_0x1F3:
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x65
	SBIW R30,5
	BRLT _0x1F4
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	TST  R31
	BRPL _0x1F5
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x67
	SBIW R30,1
	RJMP _0x272
_0x1F5:
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x67
	ADIW R30,1
_0x272:
	ST   -X,R31
	ST   -X,R30
; 0000 041F                         beg_info[t++]=(abs(temperature[ds1820_d])%100)/10;                   //  " "
_0x1F4:
	RCALL SUBOPT_0x5C
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x68
	POP  R26
	POP  R27
	RJMP _0x273
; 0000 0420                         beg_info[t++]=48;                                                    //  
; 0000 0421                         beg_info[t]=255;
; 0000 0422                      }
; 0000 0423           else {
_0x1EF:
; 0000 0424                         if (temperature[ds1820_d]!=0){
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	SBIW R30,0
	BREQ _0x1F8
; 0000 0425                         if (temperature[ds1820_d]<0) beg_info[t++]=51;  else beg_info[t++]=47;             //     -   ,    -  
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	TST  R31
	BRPL _0x1F9
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(51)
	RJMP _0x274
_0x1F9:
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(47)
_0x274:
	STD  Z+0,R26
; 0000 0426                                                      };
_0x1F8:
; 0000 0427                         if (abs(temperature[ds1820_d])>99) {beg_info[t++]=(abs(temperature[ds1820_d])/100);}//   >10,   ""  
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x1FB
	RCALL SUBOPT_0x5C
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0xC
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0428                         beg_info[t++]=(abs(temperature[ds1820_d])%100)/10;                                  //  " "
_0x1FB:
	RCALL SUBOPT_0x5C
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x68
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0429                         beg_info[t++]=43;                                                                   //  
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(43)
	RCALL SUBOPT_0x5A
; 0000 042A                         beg_info[t++]=abs(temperature[ds1820_d])%10;                                        //   .
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x66
	POP  R26
	POP  R27
_0x273:
	ST   X,R30
; 0000 042B                         beg_info[t++]=48;
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(48)
	STD  Z+0,R26
; 0000 042C                         beg_info[t]=255;
	RCALL SUBOPT_0x5D
	LDI  R26,LOW(255)
	STD  Z+0,R26
; 0000 042D                }
; 0000 042E            if (Interval >= speed)  {Interval=0; if (beg_stroka(beg_info)==255) ;}
	RCALL SUBOPT_0x6B
	BRLO _0x1FC
	RCALL SUBOPT_0x56
	CALL _beg_stroka
; 0000 042F 
; 0000 0430          if (BUT_OK) { ochistka(); z=0; z1=0;temp=0; if (td10==0){td10=1;}
_0x1FC:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x1FE
	CALL _ochistka
	RCALL SUBOPT_0x4B
	TST  R11
	BRNE _0x1FF
	LDI  R30,LOW(1)
	MOV  R11,R30
; 0000 0431                              else  td10=0;
	RJMP _0x200
_0x1FF:
	CLR  R11
; 0000 0432                              meny=57;
_0x200:
	LDI  R30,LOW(57)
	MOV  R5,R30
; 0000 0433                      }
; 0000 0434          if (BUT_STEP) {ochistka(); temp=9; meny=51;}                                     //         .
_0x1FE:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x201
	CALL _ochistka
	LDI  R30,LOW(9)
	RCALL SUBOPT_0x87
; 0000 0435 
; 0000 0436         break;
_0x201:
	RJMP _0x10C
; 0000 0437          case 58:  // __________________________    ________________________________________________________
_0x1EB:
	CPI  R30,LOW(0x3A)
	LDI  R26,HIGH(0x3A)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x202
; 0000 0438            t=0; temp1=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x58
; 0000 0439 
; 0000 043A 
; 0000 043B                  beg_info[t++] = beg_info[t++] = beg_info[t++] = 42;   beg_info[t++]=44;
	RCALL SUBOPT_0x5C
	MOVW R22,R30
	RCALL SUBOPT_0x5C
	MOVW R0,R30
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x5E
	ST   X,R30
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(44)
	STD  Z+0,R26
; 0000 043C                  if (tu10==0){
	TST  R10
	BRNE _0x203
; 0000 043D                                 beg_info[t++]=11; beg_info[t++]=15;
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(11)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(15)
	RCALL SUBOPT_0x5A
; 0000 043E                                 beg_info[t++]=16; beg_info[t++]=42;
	LDI  R26,LOW(16)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(42)
	RCALL SUBOPT_0x5A
; 0000 043F                                 beg_info[t++]=28; beg_info[t++]=24;    //  "T"
	LDI  R26,LOW(28)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(24)
	RCALL SUBOPT_0x5A
; 0000 0440                                 beg_info[t++]=33;  beg_info[t++]=20;   //  ""
	LDI  R26,LOW(33)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(20)
	RCALL SUBOPT_0x5A
; 0000 0441                                 beg_info[t++]=18;                      //  ""
	LDI  R26,LOW(18)
	RJMP _0x275
; 0000 0442                              }
; 0000 0443 
; 0000 0444             else {
_0x203:
; 0000 0445                       beg_info[t++]=27;                     //       ""
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(27)
	RCALL SUBOPT_0x5A
; 0000 0446                       beg_info[t++]=42;
	LDI  R26,LOW(42)
	RCALL SUBOPT_0x5A
; 0000 0447                       beg_info[t++]=28; beg_info[t++]=24;   //  "T"
	LDI  R26,LOW(28)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(24)
	RCALL SUBOPT_0x5A
; 0000 0448                       beg_info[t++]=33;  beg_info[t++]=20;   //  ""
	LDI  R26,LOW(33)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(20)
	RCALL SUBOPT_0x5A
; 0000 0449                       beg_info[t++]=24;  beg_info[t++]=19;   //  ""
	LDI  R26,LOW(24)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(19)
_0x275:
	STD  Z+0,R26
; 0000 044A                   }
; 0000 044B 
; 0000 044C                  beg_info[t++] = 42; beg_info[t++]=50;   //  " t"
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(42)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(50)
	RCALL SUBOPT_0x5A
; 0000 044D                  beg_info[t++] = 42;
	LDI  R26,LOW(42)
	RCALL SUBOPT_0x5A
; 0000 044E                  beg_info[t++]=23;  beg_info[t++]=10;                                                        //   ""
	LDI  R26,LOW(23)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(10)
	RCALL SUBOPT_0x5A
; 0000 044F                  beg_info[t++]=42;                                                                           // 
	LDI  R26,LOW(42)
	RCALL SUBOPT_0x5A
; 0000 0450                  beg_info[t++]=29;  beg_info[t++]=21;                                                        //   ""
	LDI  R26,LOW(29)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(21)
	RCALL SUBOPT_0x5A
; 0000 0451                  beg_info[t++]=18;  beg_info[t++]=32;  beg_info[t++]=15;                                     //   ""
	LDI  R26,LOW(18)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(32)
	RCALL SUBOPT_0x5A
	LDI  R26,LOW(15)
	RCALL SUBOPT_0x5A
; 0000 0452                  beg_info[t++]=42;
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0453          if (tu10==0){
	TST  R10
	BRNE _0x205
; 0000 0454                         if (temperature[ds1820_y]!=0){
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	SBIW R30,0
	BREQ _0x206
; 0000 0455                         if (temperature[ds1820_y]<0) beg_info[t++]=51;  else beg_info[t++]=47;               //     -   ,    -  
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	TST  R31
	BRPL _0x207
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(51)
	RJMP _0x276
_0x207:
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(47)
_0x276:
	STD  Z+0,R26
; 0000 0456                                                        };
_0x206:
; 0000 0457                         if (abs(temperature[ds1820_y])>99) {beg_info[t++]=(abs(temperature[ds1820_y])/100);} //   >10,   ""  
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x209
	RCALL SUBOPT_0x5C
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0xC
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0458                         if (abs(temperature[ds1820_y]%10)>=5) {if (temperature[ds1820_y]<0){temperature[ds1820_y]-=1;}else{temperature[ds1820_y]+=1;}}                    //  1          0.5 C
_0x209:
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x65
	SBIW R30,5
	BRLT _0x20A
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	TST  R31
	BRPL _0x20B
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x67
	SBIW R30,1
	RJMP _0x277
_0x20B:
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x67
	ADIW R30,1
_0x277:
	ST   -X,R31
	ST   -X,R30
; 0000 0459                         beg_info[t++]=(abs(temperature[ds1820_y])%100)/10;                                   //  " "
_0x20A:
	RCALL SUBOPT_0x5C
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x68
	POP  R26
	POP  R27
	RJMP _0x278
; 0000 045A                         beg_info[t++]=48;                                                                    //  
; 0000 045B                         beg_info[t]=255;
; 0000 045C                      }
; 0000 045D           else {
_0x205:
; 0000 045E                          if (temperature[ds1820_y]!=0){
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	SBIW R30,0
	BREQ _0x20E
; 0000 045F                          if (temperature[ds1820_y]<0) beg_info[t++]=51;  else beg_info[t++]=47;             //     -   ,    -  
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	TST  R31
	BRPL _0x20F
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(51)
	RJMP _0x279
_0x20F:
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(47)
_0x279:
	STD  Z+0,R26
; 0000 0460                                                        };
_0x20E:
; 0000 0461                         if (abs(temperature[ds1820_y])>99) {beg_info[t++]=(abs(temperature[ds1820_y])/100);} //   >10,   ""  
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x211
	RCALL SUBOPT_0x5C
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0xC
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0462 
; 0000 0463                         beg_info[t++]=(abs(temperature[ds1820_y])%100)/10;                                   //  " "
_0x211:
	RCALL SUBOPT_0x5C
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x68
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0464                         beg_info[t++]=43;                                                                    //  
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(43)
	RCALL SUBOPT_0x5A
; 0000 0465                         beg_info[t++]=abs(temperature[ds1820_y])%10;                                         //   .
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x66
	POP  R26
	POP  R27
_0x278:
	ST   X,R30
; 0000 0466                         beg_info[t++]=48;
	RCALL SUBOPT_0x5C
	LDI  R26,LOW(48)
	STD  Z+0,R26
; 0000 0467                         beg_info[t]=255;
	RCALL SUBOPT_0x5D
	LDI  R26,LOW(255)
	STD  Z+0,R26
; 0000 0468                }
; 0000 0469            if (Interval >= speed)  {Interval=0; if (beg_stroka(beg_info)==255) ;}
	RCALL SUBOPT_0x6B
	BRLO _0x212
	RCALL SUBOPT_0x56
	CALL _beg_stroka
; 0000 046A 
; 0000 046B          if (BUT_OK) { ochistka();z=0; z1=0;temp=0;if (tu10==0){tu10=1;}
_0x212:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x214
	CALL _ochistka
	RCALL SUBOPT_0x4B
	TST  R10
	BRNE _0x215
	LDI  R30,LOW(1)
	MOV  R10,R30
; 0000 046C                              else  tu10=0;
	RJMP _0x216
_0x215:
	CLR  R10
; 0000 046D                              meny=58;
_0x216:
	LDI  R30,LOW(58)
	MOV  R5,R30
; 0000 046E                      }
; 0000 046F               if (BUT_STEP) {ochistka(); temp=11; meny=51;}
_0x214:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x217
	CALL _ochistka
	LDI  R30,LOW(11)
	RCALL SUBOPT_0x87
; 0000 0470 
; 0000 0471         break;
_0x217:
	RJMP _0x10C
; 0000 0472         case 54: //        ()
_0x202:
	CPI  R30,LOW(0x36)
	LDI  R26,HIGH(0x36)
	CPC  R31,R26
	BRNE _0x218
; 0000 0473             TIMSK&=0x7F;         //   ""  .  (  ,    ""   )
	IN   R30,0x39
	ANDI R30,0x7F
	OUT  0x39,R30
; 0000 0474             brigh_down_time=ystanovki_23_59(brigh_down_time); //     
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x74
	LDI  R26,LOW(_brigh_down_time)
	LDI  R27,HIGH(_brigh_down_time)
	CALL __EEPROMWRW
; 0000 0475             ochistka();
	CALL _ochistka
; 0000 0476             brigh_up_time=ystanovki_23_59(brigh_up_time);     //     
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x74
	LDI  R26,LOW(_brigh_up_time)
	LDI  R27,HIGH(_brigh_up_time)
	CALL __EEPROMWRW
; 0000 0477             ochistka();
	CALL _ochistka
; 0000 0478             meny=55;
	LDI  R30,LOW(55)
	RJMP _0x27A
; 0000 0479         break;
; 0000 047A         case 55: //    
_0x218:
	CPI  R30,LOW(0x37)
	LDI  R26,HIGH(0x37)
	CPC  R31,R26
	BRNE _0x219
; 0000 047B             ekran_1_figure(41,0,1);
	LDI  R30,LOW(41)
	RCALL SUBOPT_0x34
; 0000 047C             ekran_1_figure(26,5,1);
	LDI  R30,LOW(26)
	RCALL SUBOPT_0x7E
; 0000 047D             ekran_1_figure(20,10,1);
	LDI  R30,LOW(20)
	RCALL SUBOPT_0x82
; 0000 047E             ekran_1_figure(brigh_up,18,1);
	RCALL SUBOPT_0xB
	ST   -Y,R30
	LDI  R30,LOW(18)
	RCALL SUBOPT_0x7D
; 0000 047F             TIMSK|=0x02;                //    (    0)
	IN   R30,0x39
	ORI  R30,2
	OUT  0x39,R30
; 0000 0480             OCR0=(brigh_up)*23+5;       //         brigh_up
	RCALL SUBOPT_0xB
	LDI  R26,LOW(23)
	MULS R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(5)
	OUT  0x3C,R30
; 0000 0481             if (BUT_OK)  {brigh_up++; if(brigh_up==10) brigh_up=0;} //
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x21A
	RCALL SUBOPT_0xB
	SUBI R30,-LOW(1)
	CALL __EEPROMWRB
	SUBI R30,LOW(1)
	RCALL SUBOPT_0xB
	CPI  R30,LOW(0xA)
	BRNE _0x21B
	LDI  R26,LOW(_brigh_up)
	LDI  R27,HIGH(_brigh_up)
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
_0x21B:
; 0000 0482             if (BUT_STEP)   {  TIMSK|=0x80; ochistka();z=0; z1=0;  t=0; temp1=0;   data1=time; meny=10;}   //
_0x21A:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x21C
	IN   R30,0x39
	ORI  R30,0x80
	OUT  0x39,R30
	RCALL SUBOPT_0x69
	RCALL SUBOPT_0x59
	LDI  R30,LOW(10)
	MOV  R5,R30
; 0000 0483         break;
_0x21C:
	RJMP _0x10C
; 0000 0484         case 56: //  
_0x219:
	CPI  R30,LOW(0x38)
	LDI  R26,HIGH(0x38)
	CPC  R31,R26
	BRNE _0x21D
; 0000 0485             ekran_1_figure(ADCH/100,3,1);
	IN   R30,0x5
	LDI  R31,0
	RCALL SUBOPT_0xC
	ST   -Y,R30
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x7D
; 0000 0486             ekran_1_figure((ADCH/10)%10,9,1);
	IN   R30,0x5
	RCALL SUBOPT_0x63
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x81
; 0000 0487             ekran_1_figure(ADCH%10,15,1);
	IN   R30,0x5
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x88
	ST   -Y,R30
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x7D
; 0000 0488             if (BUT_OK)  {brigh_up=ADCH;}  //         brigh_up
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x21E
	IN   R30,0x5
	LDI  R26,LOW(_brigh_up)
	LDI  R27,HIGH(_brigh_up)
	CALL __EEPROMWRB
; 0000 0489             if (BUT_STEP)   {ochistka(); z=0; z1=0;  t=0; temp1=0;temp=0;data1=time;meny=10;}
_0x21E:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x21F
	RCALL SUBOPT_0x69
	LDI  R30,LOW(0)
	STS  _temp,R30
	RCALL SUBOPT_0x59
	LDI  R30,LOW(10)
	MOV  R5,R30
; 0000 048A         break;
_0x21F:
	RJMP _0x10C
; 0000 048B         //**************************  *******************************
; 0000 048C         case 60: //    - ""
_0x21D:
	CPI  R30,LOW(0x3C)
	LDI  R26,HIGH(0x3C)
	CPC  R31,R26
	BRNE _0x220
; 0000 048D             if (Interval>=speed)  {Interval=0;   beg_stroka(korekt_txt);}
	RCALL SUBOPT_0x6B
	BRLO _0x221
	RCALL SUBOPT_0x6C
	LDI  R30,LOW(_korekt_txt)
	LDI  R31,HIGH(_korekt_txt)
	RCALL SUBOPT_0x6D
; 0000 048E             if (BUT_STEP) {ochistka(); z=0; z1=0;  t=0; temp1=0;temp=0;meny=10; }
_0x221:
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x222
	RCALL SUBOPT_0x69
	LDI  R30,LOW(0)
	STS  _temp,R30
	LDI  R30,LOW(10)
	MOV  R5,R30
; 0000 048F             if (BUT_OK)   {ochistka();meny=61;}
_0x222:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x223
	CALL _ochistka
	LDI  R30,LOW(61)
	MOV  R5,R30
; 0000 0490         break;
_0x223:
	RJMP _0x10C
; 0000 0491         case 61: //  "" 
_0x220:
	CPI  R30,LOW(0x3D)
	LDI  R26,HIGH(0x3D)
	CPC  R31,R26
	BRNE _0x224
; 0000 0492             if (BUT_STEP) {meny=62;}
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x225
	LDI  R30,LOW(62)
	MOV  R5,R30
; 0000 0493             if (BUT_OK)   {korr_den = (korr_den * (-1));}
_0x225:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x226
	RCALL SUBOPT_0x89
	LDI  R26,LOW(65535)
	LDI  R27,HIGH(65535)
	CALL __MULW12
	RCALL SUBOPT_0x8A
; 0000 0494               ekran [11]=192;line=1; ekran_1_figure(((korr_den<0)?46:47),0,1);
_0x226:
	LDI  R30,LOW(192)
	__PUTB1MN _ekran,11
	SET
	BLD  R3,3
	RCALL SUBOPT_0x2
	BRPL _0x227
	LDI  R30,LOW(46)
	RJMP _0x228
_0x227:
	LDI  R30,LOW(47)
_0x228:
	RCALL SUBOPT_0x34
; 0000 0495             line=0;/* ekran_1_figure((abs((korr_den))/100),6);*/ ekran_1_figure(((abs(korr_den)%100)/10),6,1); ekran_1_figure((abs(korr_den)%10),12,1);ekran_1_figure(27,19,0);   //   
	CLT
	BLD  R3,3
	RCALL SUBOPT_0x89
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x68
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x89
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x8B
	RCALL SUBOPT_0x8C
; 0000 0496         break;
	RJMP _0x10C
; 0000 0497         case 62: //   
_0x224:
	CPI  R30,LOW(0x3E)
	LDI  R26,HIGH(0x3E)
	CPC  R31,R26
	BRNE _0x22A
; 0000 0498             if (BUT_STEP) {;meny=63;}
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x22B
	LDI  R30,LOW(63)
	MOV  R5,R30
; 0000 0499             if (BUT_OK)   {korr_den=((korr_den<0)?(korr_den-=10):(korr_den+=10));if(abs(korr_den)>99){korr_den=korr_den%10;}}
_0x22B:
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x22C
	RCALL SUBOPT_0x2
	BRPL _0x22D
	RCALL SUBOPT_0x89
	SBIW R30,10
	RJMP _0x27B
_0x22D:
	RCALL SUBOPT_0x89
	ADIW R30,10
_0x27B:
	LDI  R26,LOW(_korr_den)
	LDI  R27,HIGH(_korr_den)
	CALL __EEPROMWRW
	RCALL SUBOPT_0x8A
	RCALL SUBOPT_0x89
	RCALL SUBOPT_0x65
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x230
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x88
	RCALL SUBOPT_0x8A
_0x230:
; 0000 049A             ekran [11]=192; ekran_1_figure(((korr_den<0)?46:47),0,1);
_0x22C:
	LDI  R30,LOW(192)
	__PUTB1MN _ekran,11
	RCALL SUBOPT_0x2
	BRPL _0x231
	LDI  R30,LOW(46)
	RJMP _0x232
_0x231:
	LDI  R30,LOW(47)
_0x232:
	RCALL SUBOPT_0x34
; 0000 049B             line=1; /*ekran_1_figure((abs((korr_den))/100),6);*/ ekran_1_figure(((abs(korr_den)%100)/10),6,1);
	SET
	BLD  R3,3
	RCALL SUBOPT_0x89
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x68
	RCALL SUBOPT_0x35
; 0000 049C             line=0; ekran_1_figure((abs(korr_den)%10),12,1);ekran_1_figure(27,19,0);
	CLT
	BLD  R3,3
	RCALL SUBOPT_0x89
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x8B
	RCALL SUBOPT_0x8C
; 0000 049D         break;
	RJMP _0x10C
; 0000 049E         case 63: //     
_0x22A:
	CPI  R30,LOW(0x3F)
	LDI  R26,HIGH(0x3F)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x10C
; 0000 049F 
; 0000 04A0             if (BUT_OK)   {if(korr_den<0){korr_den--;if(korr_den%10==0)korr_den+=10;}else{korr_den++;if(korr_den%10==0)korr_den-=10;}}
	LDS  R26,_button
	CPI  R26,LOW(0x1)
	BRNE _0x235
	RCALL SUBOPT_0x2
	BRPL _0x236
	RCALL SUBOPT_0x89
	SBIW R30,1
	CALL __EEPROMWRW
	ADIW R30,1
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x88
	SBIW R30,0
	BRNE _0x237
	RCALL SUBOPT_0x89
	ADIW R30,10
	RCALL SUBOPT_0x8A
_0x237:
	RJMP _0x238
_0x236:
	RCALL SUBOPT_0x89
	ADIW R30,1
	CALL __EEPROMWRW
	SBIW R30,1
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x88
	SBIW R30,0
	BRNE _0x239
	RCALL SUBOPT_0x89
	SBIW R30,10
	RCALL SUBOPT_0x8A
_0x239:
_0x238:
; 0000 04A1              ekran [11]=192;ekran_1_figure(((korr_den<0)?46:47),0,1); /* ekran_1_figure((abs((korr_den))/100),6);*/ ekran_1_figure(((abs(korr_den)%100)/10),6,1);
_0x235:
	LDI  R30,LOW(192)
	__PUTB1MN _ekran,11
	RCALL SUBOPT_0x2
	BRPL _0x23A
	LDI  R30,LOW(46)
	RJMP _0x23B
_0x23A:
	LDI  R30,LOW(47)
_0x23B:
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x89
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x68
	RCALL SUBOPT_0x35
; 0000 04A2             line=1; ekran_1_figure((abs(korr_den)%10),12,1);ekran_1_figure(27,19,0);   line=0;
	SET
	BLD  R3,3
	RCALL SUBOPT_0x89
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x8B
	RCALL SUBOPT_0x8C
	CLT
	BLD  R3,3
; 0000 04A3               if (BUT_STEP) { z=0; z1=0;  t=0; temp1=0;ochistka(); meny=10;}
	LDS  R26,_button
	CPI  R26,LOW(0x2)
	BRNE _0x23D
	RCALL SUBOPT_0x6A
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x58
	CALL _ochistka
	LDI  R30,LOW(10)
_0x27A:
	MOV  R5,R30
; 0000 04A4         break;
_0x23D:
; 0000 04A5         }
_0x10C:
; 0000 04A6 
; 0000 04A7 //****************************************************   *******************************************
; 0000 04A8 if (flg_min)
	SBRS R2,2
	RJMP _0x23E
; 0000 04A9 {
; 0000 04AA flg_min=0;
	CLT
	BLD  R2,2
; 0000 04AB         //_____________________ 
; 0000 04AC         for (bud_temp=0; bud_temp<9; bud_temp++)
	CLR  R13
_0x240:
	LDI  R30,LOW(9)
	CP   R13,R30
	BRSH _0x241
; 0000 04AD         {
; 0000 04AE                 if  (
; 0000 04AF                     ( time==budilnik_time[bud_temp] )                                 //      
; 0000 04B0                 &&  ( budilnik_Install[bud_temp] & 0x80)                              //      ( )
; 0000 04B1                 &&  ( budilnik_Install[bud_temp] & (1 << den_nedeli) )                //        
; 0000 04B2                 )
	MOV  R30,R13
	RCALL SUBOPT_0x73
	RCALL SUBOPT_0x11
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x243
	RCALL SUBOPT_0x8D
	LD   R30,Z
	ANDI R30,LOW(0x80)
	BREQ _0x243
	RCALL SUBOPT_0x8D
	LD   R1,Z
	MOV  R30,R8
	RCALL SUBOPT_0x76
	BRNE _0x244
_0x243:
	RJMP _0x242
_0x244:
; 0000 04B3                 bud_flg=1;                                                            //    
	SET
	BLD  R2,4
; 0000 04B4 
; 0000 04B5         //______________________ 
; 0000 04B6                 if ( time==budilnik_time[bud_temp] +  budilnik_Interval[bud_temp])    //    ""  ( 1  15 )
_0x242:
	MOV  R30,R13
	RCALL SUBOPT_0x73
	MOVW R26,R30
	MOV  R30,R13
	LDI  R31,0
	SUBI R30,LOW(-_budilnik_Interval)
	SBCI R31,HIGH(-_budilnik_Interval)
	LD   R30,Z
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RCALL SUBOPT_0x11
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x245
; 0000 04B7                 {
; 0000 04B8                 bud_flg=0;                                                            //    
	CLT
	BLD  R2,4
; 0000 04B9                 if (bud_temp<3)  {budilnik_Install[bud_temp] = 0;}                    //     "" ( 1-3),     
	LDI  R30,LOW(3)
	CP   R13,R30
	BRSH _0x246
	RCALL SUBOPT_0x8D
	LDI  R26,LOW(0)
	STD  Z+0,R26
; 0000 04BA                 }
_0x246:
; 0000 04BB 
; 0000 04BC         }
_0x245:
	INC  R13
	RJMP _0x240
_0x241:
; 0000 04BD         //______________________ 
; 0000 04BE         if ( (time%60==0)&&( (time > 479) && (time < 1321) )&&(zv_chs) ) {  but_flg=1;   TIMSK|=0x10;    but_pause=0;  }    //     ( 08-00  22-00   )
	RCALL SUBOPT_0x11
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __MODW21U
	SBIW R30,0
	BRNE _0x248
	RCALL SUBOPT_0x11
	CPI  R26,LOW(0x1E0)
	LDI  R30,HIGH(0x1E0)
	CPC  R27,R30
	BRLO _0x249
	RCALL SUBOPT_0x11
	CPI  R26,LOW(0x529)
	LDI  R30,HIGH(0x529)
	CPC  R27,R30
	BRLO _0x24A
_0x249:
	RJMP _0x248
_0x24A:
	SBRC R3,1
	RJMP _0x24B
_0x248:
	RJMP _0x247
_0x24B:
	SET
	BLD  R2,7
	IN   R30,0x39
	ORI  R30,0x10
	OUT  0x39,R30
	LDI  R30,LOW(0)
	STS  _but_pause,R30
; 0000 04BF }
_0x247:
; 0000 04C0 
; 0000 04C1 if ( ((bud_flg)&&(mig))  ||  (but_flg) )   { TIMSK|=0x10;}    //     ""  1 ( . )
_0x23E:
	SBRS R2,4
	RJMP _0x24D
	SBRC R2,0
	RJMP _0x24F
_0x24D:
	SBRS R2,7
	RJMP _0x24C
_0x24F:
	IN   R30,0x39
	ORI  R30,0x10
	RJMP _0x27C
; 0000 04C2 else  {PORTB.5=0; TIMSK&=0xEF;}
_0x24C:
	CBI  0x18,5
	IN   R30,0x39
	ANDI R30,0xEF
_0x27C:
	OUT  0x39,R30
; 0000 04C3 
; 0000 04C4 
; 0000 04C5 //****************************************************************************************************************************
; 0000 04C6 while (POWER == OFF )   //    ,       -  
_0x254:
	SBRC R3,4
	RJMP _0x256
; 0000 04C7     {
; 0000 04C8     ACSR=0x80;          //         (   )
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 04C9     #asm("sleep")       // ......
	sleep
; 0000 04CA     ACSR=0x4b;          //  ,  .
	LDI  R30,LOW(75)
	OUT  0x8,R30
; 0000 04CB     }
	RJMP _0x254
_0x256:
; 0000 04CC //****************************************************************************************************************************
; 0000 04CD };
	JMP  _0x106
; 0000 04CE }
_0x257:
	RJMP _0x257

	.CSEG
_ds18b20_select:
	ST   -Y,R17
	CALL _w1_init
	CPI  R30,0
	BRNE _0x2000003
	LDI  R30,LOW(0)
	RJMP _0x2020001
_0x2000003:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	SBIW R30,0
	BREQ _0x2000004
	LDI  R30,LOW(85)
	ST   -Y,R30
	CALL _w1_write
	LDI  R17,LOW(0)
_0x2000006:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	ST   -Y,R30
	CALL _w1_write
	SUBI R17,-LOW(1)
	CPI  R17,8
	BRLO _0x2000006
	RJMP _0x2000008
_0x2000004:
	LDI  R30,LOW(204)
	ST   -Y,R30
	CALL _w1_write
_0x2000008:
	LDI  R30,LOW(1)
	RJMP _0x2020001
_ds18b20_read_spd:
	CALL __SAVELOCR4
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	RCALL SUBOPT_0x8E
	CPI  R30,0
	BRNE _0x2000009
	LDI  R30,LOW(0)
	RJMP _0x2020002
_0x2000009:
	LDI  R30,LOW(190)
	ST   -Y,R30
	CALL _w1_write
	LDI  R17,LOW(0)
	__POINTWRM 18,19,___ds18b20_scratch_pad
_0x200000B:
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	CALL _w1_read
	POP  R26
	POP  R27
	ST   X,R30
	SUBI R17,-LOW(1)
	CPI  R17,9
	BRLO _0x200000B
	LDI  R30,LOW(___ds18b20_scratch_pad)
	LDI  R31,HIGH(___ds18b20_scratch_pad)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	CALL _w1_dow_crc8
	CALL __LNEGB1
_0x2020002:
	CALL __LOADLOCR4
	ADIW R28,6
	RET
_ds18b20_convert_temp:
	RCALL SUBOPT_0x8F
	RCALL SUBOPT_0x90
	LDI  R26,LOW(0)
	CALL __EQB12
	LDI  R30,LOW(68)
	ST   -Y,R30
	CALL _w1_write
	RJMP _0x2020001
_ds18b20_read_temp:
	RCALL SUBOPT_0x8F
	CPI  R30,0
	BRNE _0x200000D
	RCALL SUBOPT_0x91
	RJMP _0x2020001
_0x200000D:
	RCALL SUBOPT_0x90
	CPI  R30,0
	BRNE _0x200000E
	RCALL SUBOPT_0x91
	RJMP _0x2020001
_0x200000E:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ds18b20_read_spd
	CPI  R30,0
	BRNE _0x200000F
	RCALL SUBOPT_0x91
	RJMP _0x2020001
_0x200000F:
	CALL _w1_init
	MOV  R30,R17
	LDI  R26,LOW(_bit_mask_G100*2)
	LDI  R27,HIGH(_bit_mask_G100*2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW1PF
	LDS  R26,___ds18b20_scratch_pad
	LDS  R27,___ds18b20_scratch_pad+1
	AND  R30,R26
	AND  R31,R27
	CALL __CWD1
	CALL __CDF1
	__GETD2N 0x3D800000
	CALL __MULF12
_0x2020001:
	LDD  R17,Y+0
	ADIW R28,3
	RET

	.DSEG
___ds18b20_scratch_pad:
	.BYTE 0x9
_button:
	.BYTE 0x1
_but_pause:
	.BYTE 0x1
_z:
	.BYTE 0x1
_z1:
	.BYTE 0x1
_bud:
	.BYTE 0x1
_temp:
	.BYTE 0x1
_temp1:
	.BYTE 0x1
_temp2:
	.BYTE 0x1
_t:
	.BYTE 0x1
_flg_korr:
	.BYTE 0x1
_speed:
	.BYTE 0x1
_foto_r:
	.BYTE 0x1
_ekran:
	.BYTE 0x18
_beg_info:
	.BYTE 0x63
_rom_code:
	.BYTE 0x12
_budilnik_Install:
	.BYTE 0x9
_budilnik_Interval:
	.BYTE 0x9
_budilnik_time:
	.BYTE 0x12
_budilnik_txt:
	.BYTE 0xB
_korekt_txt:
	.BYTE 0xC
_nastroiki_txt:
	.BYTE 0xB
_den_txt:
	.BYTE 0x5
_data_txt:
	.BYTE 0x5
_god_txt:
	.BYTE 0x4
_nastr_stroki_txt:
	.BYTE 0xB
_speed_txt:
	.BYTE 0x19
_perenazna_datchik:
	.BYTE 0x19
_budilnik_Interval_txt:
	.BYTE 0x16
_den_nedeli_txt:
	.BYTE 0x54
_den_nedeli_letter:
	.BYTE 0xE
_name_mesec_txt:
	.BYTE 0x6C
_time:
	.BYTE 0x2
_Interval:
	.BYTE 0x2
_Interval_2:
	.BYTE 0x2
_data1:
	.BYTE 0x2
_time_meny:
	.BYTE 0x2
_temperature_temp:
	.BYTE 0x4

	.ESEG
_korr_den:
	.BYTE 0x2
_brigh_up_time:
	.BYTE 0x2
_brigh_down_time:
	.BYTE 0x2
_brigh_up:
	.BYTE 0x1
_str:
	.DB  0x1B

	.DSEG
_devices_G000:
	.BYTE 0x1
_i_G000:
	.BYTE 0x1
_temperature_G000:
	.BYTE 0x18

	.ESEG
_ds1820_d:
	.BYTE 0x1
_ds1820_y:
	.BYTE 0x1

	.DSEG
_error_ds18b20:
	.BYTE 0x1
_dl_1_S0000007000:
	.BYTE 0x1
_dl_2_S0000007000:
	.BYTE 0x1
_Shift_zn_S000000A000:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x0:
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	MOV  R30,R19
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x2:
	LDI  R26,LOW(_korr_den+1)
	LDI  R27,HIGH(_korr_den+1)
	CALL __EEPROMRDB
	TST  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x3:
	LDI  R26,LOW(_korr_den)
	LDI  R27,HIGH(_korr_den)
	CALL __EEPROMRDW
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	LDI  R26,LOW(25)
	MULS R30,R26
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	CALL __MODW21
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x6:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(0)
	STS  _time_meny,R30
	STS  _time_meny+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x8:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(240)
	ST   -Y,R30
	LDI  R30,LOW(_rom_code)
	LDI  R31,HIGH(_rom_code)
	ST   -Y,R31
	ST   -Y,R30
	CALL _w1_search
	STS  _devices_G000,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA:
	LDI  R26,LOW(_ds1820_d)
	LDI  R27,HIGH(_ds1820_d)
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xB:
	LDI  R26,LOW(_brigh_up)
	LDI  R27,HIGH(_brigh_up)
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0xC:
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xD:
	LDI  R26,LOW(_brigh_down_time)
	LDI  R27,HIGH(_brigh_down_time)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xE:
	LDI  R26,LOW(_brigh_up_time)
	LDI  R27,HIGH(_brigh_up_time)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xF:
	LDS  R26,_time
	LDS  R27,_time+1
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x10:
	LDI  R26,LOW(23)
	MULS R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(1)
	OUT  0x3C,R30
	IN   R30,0x39
	ORI  R30,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 22 TIMES, CODE SIZE REDUCTION:39 WORDS
SUBOPT_0x11:
	LDS  R26,_time
	LDS  R27,_time+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x12:
	MOV  R30,R6
	LDI  R31,0
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	CALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	CALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x17:
	LDS  R26,_data1
	LDS  R27,_data1+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x18:
	STS  _data1,R30
	STS  _data1+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x19:
	RCALL SUBOPT_0x11
	CPI  R26,LOW(0x258)
	LDI  R30,HIGH(0x258)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x1A:
	LDD  R30,Y+6
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x1B:
	SUBI R30,LOW(-_simvol*2)
	SBCI R31,HIGH(-_simvol*2)
	ADD  R30,R22
	ADC  R31,R23
	LPM  R26,Z
	LDS  R30,_Shift_zn_S000000A000
	CALL __LSLB12
	MOV  R24,R30
	LDI  R26,LOW(5)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol*2)
	SBCI R31,HIGH(-_simvol*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:48 WORDS
SUBOPT_0x1D:
	ADD  R30,R26
	ADC  R31,R27
	LPM  R22,Z
	CLR  R23
	LDS  R30,_Shift_zn_S000000A000
	LDI  R31,0
	LDI  R26,LOW(8)
	LDI  R27,HIGH(8)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R22
	CALL __ASRW12
	ADD  R30,R24
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1E:
	MOVW R24,R30
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	MOVW R22,R30
	LDI  R26,LOW(5)
	RJMP SUBOPT_0x1C

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	ADD  R30,R24
	ADC  R31,R25
	LPM  R30,Z
	MOVW R26,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x20:
	MOVW R22,R30
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	MOVW R0,R30
	__POINTW1FN _simvol,275
	ADD  R30,R22
	ADC  R31,R23
	LPM  R30,Z
	MOVW R26,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x21:
	MUL  R16,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol*2)
	SBCI R31,HIGH(-_simvol*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x22:
	LDD  R26,Y+6
	LDI  R30,LOW(4)
	CALL __EQB12
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,1
	LDI  R30,1
	AND  R30,R26
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,5
	LDI  R30,1
	AND  R30,R26
	MOV  R26,R30
	LDI  R30,0
	SBRS R2,0
	LDI  R30,1
	AND  R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x23:
	MOVW R24,R30
	__ADDW1MN _ekran,6
	MOVW R22,R30
	LDI  R26,LOW(5)
	RJMP SUBOPT_0x21

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x24:
	ADD  R30,R24
	ADC  R31,R25
	LPM  R30,Z
	SUBI R30,-LOW(128)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x25:
	MUL  R19,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol*2)
	SBCI R31,HIGH(-_simvol*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x26:
	LDD  R26,Y+6
	LDI  R30,LOW(0)
	CALL __EQB12
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,1
	LDI  R30,1
	AND  R30,R26
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,5
	LDI  R30,1
	AND  R30,R26
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
	AND  R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x27:
	MOVW R24,R30
	__ADDW1MN _ekran,13
	MOVW R22,R30
	LDI  R26,LOW(5)
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x28:
	LDD  R30,Y+3
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol*2)
	SBCI R31,HIGH(-_simvol*2)
	MOVW R26,R30
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x29:
	ADD  R30,R26
	ADC  R31,R27
	LPM  R26,Z
	CPI  R26,LOW(0xAA)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2A:
	MOV  R26,R17
	CLR  R27
	LDD  R30,Y+2
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x2B:
	ADD  R30,R26
	ADC  R31,R27
	LPM  R22,Z
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
	LDI  R26,LOW(128)
	MULS R30,R26
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2C:
	LDS  R26,_time_meny
	LDS  R27,_time_meny+1
	CPI  R26,LOW(0x78)
	LDI  R30,HIGH(0x78)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2D:
	MOV  R26,R17
	CLR  R27
	LDD  R30,Y+1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2E:
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2F:
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12U
	SUBI R30,LOW(-_simvol*2)
	SBCI R31,HIGH(-_simvol*2)
	MOVW R26,R30
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x30:
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x31:
	ST   -Y,R30
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x32:
	ST   -Y,R30
	LDI  R30,LOW(19)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x33:
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:62 WORDS
SUBOPT_0x34:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x35:
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x36:
	CALL __DIVW21U
	LDI  R26,LOW(60)
	LDI  R27,HIGH(60)
	CALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x37:
	ST   -Y,R30
	LDI  R30,LOW(13)
	ST   -Y,R30
	JMP  _ystanovki_2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x38:
	MOV  R26,R17
	LDI  R27,0
	SUBI R26,LOW(-_ekran)
	SBCI R27,HIGH(-_ekran)
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x39:
	LDS  R30,_z1
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3A:
	LD   R30,X
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol*2)
	SBCI R31,HIGH(-_simvol*2)
	MOVW R26,R30
	LDS  R30,_z
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3B:
	LDI  R30,LOW(0)
	STS  _z,R30
	LDS  R30,_z1
	SUBI R30,-LOW(1)
	STS  _z1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x3C:
	LD   R30,X
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol*2)
	SBCI R31,HIGH(-_simvol*2)
	MOVW R22,R30
	LDS  R30,_z
	LDI  R31,0
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	ADD  R30,R22
	ADC  R31,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3D:
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0xFF)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x3E:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	LD   R30,X
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol*2)
	SBCI R31,HIGH(-_simvol*2)
	MOVW R26,R30
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3F:
	LDI  R26,LOW(_budilnik_time)
	LDI  R27,HIGH(_budilnik_time)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x40:
	LDS  R30,_temp
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x41:
	ST   X,R30
	MOVW R26,R0
	ST   X,R30
	MOVW R26,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x42:
	LDS  R30,_temp
	SUBI R30,-LOW(1)
	STS  _temp,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 26 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x43:
	LDI  R26,LOW(_ds1820_d)
	LDI  R27,HIGH(_ds1820_d)
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 26 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x44:
	LDI  R26,LOW(_ds1820_y)
	LDI  R27,HIGH(_ds1820_y)
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x45:
	LDS  R30,_time
	LDS  R31,_time+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x46:
	LDS  R30,_i_G000
	LDI  R26,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_rom_code)
	SBCI R31,HIGH(-_rom_code)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x47:
	LDS  R26,_temperature_temp
	LDS  R27,_temperature_temp+1
	LDS  R24,_temperature_temp+2
	LDS  R25,_temperature_temp+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x48:
	LDS  R30,_i_G000
	LDI  R26,LOW(_temperature_G000)
	LDI  R27,HIGH(_temperature_G000)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x49:
	LDS  R30,_i_G000
	LDI  R31,0
	SUBI R30,LOW(-_error_ds18b20)
	SBCI R31,HIGH(-_error_ds18b20)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x4A:
	LDI  R26,LOW(_str)
	LDI  R27,HIGH(_str)
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x4B:
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z1,R30
	STS  _temp,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:39 WORDS
SUBOPT_0x4C:
	CALL _ochistka
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z1,R30
	STS  _t,R30
	STS  _temp1,R30
	LDI  R30,LOW(30)
	MOV  R5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4D:
	RCALL SUBOPT_0x11
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	RJMP SUBOPT_0x36

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x4E:
	RCALL SUBOPT_0x11
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __MULW12U
	MOVW R26,R30
	MOV  R30,R4
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x4F:
	MOV  R5,R30
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x50:
	CLT
	BLD  R2,1
	LDI  R30,LOW(0)
	STS  _t,R30
	STS  _temp1,R30
	LDS  R30,_t
	SUBI R30,-LOW(1)
	STS  _t,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x51:
	LDI  R26,LOW(44)
	STD  Z+0,R26
	LDS  R30,_t
	SUBI R30,-LOW(1)
	STS  _t,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	MOVW R22,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x52:
	CALL __MODW21
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	MOVW R26,R22
	ST   X,R30
	LDS  R30,_t
	SUBI R30,-LOW(1)
	STS  _t,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	MOVW R22,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x53:
	MOVW R26,R22
	ST   X,R30
	LDS  R30,_t
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 146 TIMES, CODE SIZE REDUCTION:432 WORDS
SUBOPT_0x54:
	LDI  R31,0
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x55:
	LDI  R26,LOW(255)
	STD  Z+0,R26
	LDS  R30,_speed
	LDS  R26,_Interval
	LDS  R27,_Interval+1
	LDI  R31,0
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x56:
	LDI  R30,LOW(0)
	STS  _Interval,R30
	STS  _Interval+1,R30
	LDI  R30,LOW(_beg_info)
	LDI  R31,HIGH(_beg_info)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x57:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:51 WORDS
SUBOPT_0x58:
	STS  _t,R30
	LDI  R30,LOW(0)
	STS  _temp1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x59:
	RCALL SUBOPT_0x45
	RJMP SUBOPT_0x18

;OPTIMIZER ADDED SUBROUTINE, CALLED 71 TIMES, CODE SIZE REDUCTION:487 WORDS
SUBOPT_0x5A:
	STD  Z+0,R26
	LDS  R30,_t
	SUBI R30,-LOW(1)
	STS  _t,R30
	SUBI R30,LOW(1)
	RJMP SUBOPT_0x54

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5B:
	RCALL SUBOPT_0x11
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 64 TIMES, CODE SIZE REDUCTION:375 WORDS
SUBOPT_0x5C:
	LDS  R30,_t
	SUBI R30,-LOW(1)
	STS  _t,R30
	SUBI R30,LOW(1)
	RJMP SUBOPT_0x54

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5D:
	LDS  R30,_t
	RJMP SUBOPT_0x54

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5E:
	MOVW R26,R30
	LDI  R30,LOW(42)
	RJMP SUBOPT_0x41

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5F:
	MOV  R30,R8
	LDI  R26,LOW(12)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_den_nedeli_txt)
	SBCI R31,HIGH(-_den_nedeli_txt)
	MOVW R26,R30
	LDS  R30,_t
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x60:
	SUBI R30,-LOW(1)
	STS  _t,R30
	SUBI R30,LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x61:
	LDI  R26,LOW(9)
	LDI  R27,HIGH(9)
	CALL __MULW12U
	SUBI R30,LOW(-_name_mesec_txt)
	SBCI R31,HIGH(-_name_mesec_txt)
	MOVW R22,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x62:
	LDS  R30,_temp1
	LDI  R31,0
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x63:
	LDI  R31,0
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 45 TIMES, CODE SIZE REDUCTION:393 WORDS
SUBOPT_0x64:
	LDI  R26,LOW(_temperature_G000)
	LDI  R27,HIGH(_temperature_G000)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 35 TIMES, CODE SIZE REDUCTION:65 WORDS
SUBOPT_0x65:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _abs

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x66:
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:60 WORDS
SUBOPT_0x67:
	LDI  R26,LOW(_temperature_G000)
	LDI  R27,HIGH(_temperature_G000)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X+
	LD   R31,X+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:69 WORDS
SUBOPT_0x68:
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __MODW21
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:87 WORDS
SUBOPT_0x69:
	CALL _ochistka
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z1,R30
	RJMP SUBOPT_0x58

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x6A:
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:60 WORDS
SUBOPT_0x6B:
	LDS  R30,_speed
	LDS  R26,_Interval
	LDS  R27,_Interval+1
	LDI  R31,0
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x6C:
	LDI  R30,LOW(0)
	STS  _Interval,R30
	STS  _Interval+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x6D:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _beg_stroka

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6E:
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6F:
	LDS  R30,_bud
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x70:
	BLD  R3,3
	LDS  R30,_bud
	LDI  R31,0
	SUBI R30,LOW(-_budilnik_Install)
	SBCI R31,HIGH(-_budilnik_Install)
	LD   R30,Z
	ANDI R30,LOW(0x80)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x71:
	ST   -Y,R30
	LDI  R30,LOW(17)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x72:
	LDS  R30,_bud
	LDI  R31,0
	SUBI R30,LOW(-_budilnik_Install)
	SBCI R31,HIGH(-_budilnik_Install)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x73:
	LDI  R26,LOW(_budilnik_time)
	LDI  R27,HIGH(_budilnik_time)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x74:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _ystanovki_23_59

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x75:
	LDS  R30,_temp
	LDI  R26,LOW(_den_nedeli_letter)
	LDI  R27,HIGH(_den_nedeli_letter)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x76:
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	CALL __LSLW12
	MOV  R26,R1
	LDI  R27,0
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0x77:
	LDS  R30,_bud
	LDI  R31,0
	SUBI R30,LOW(-_budilnik_Interval)
	SBCI R31,HIGH(-_budilnik_Interval)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x78:
	LD   R26,Z
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x79:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _ekran_1_figure
	LDI  R30,LOW(22)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7A:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _ekran_1_figure
	LDI  R30,LOW(18)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7B:
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x7C:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	CALL _ekran_1_figure
	LDI  R30,LOW(43)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 30 TIMES, CODE SIZE REDUCTION:84 WORDS
SUBOPT_0x7D:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7E:
	ST   -Y,R30
	LDI  R30,LOW(5)
	RJMP SUBOPT_0x7D

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x7F:
	EOR  R30,R26
	LDI  R26,LOW(_str)
	LDI  R27,HIGH(_str)
	CALL __EEPROMWRB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x80:
	ST   -Y,R31
	ST   -Y,R30
	CALL _txt_ekran
	RJMP SUBOPT_0x4A

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x81:
	ST   -Y,R30
	LDI  R30,LOW(9)
	RJMP SUBOPT_0x7D

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x82:
	ST   -Y,R30
	LDI  R30,LOW(10)
	RJMP SUBOPT_0x7D

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x83:
	ST   -Y,R30
	LDI  R30,LOW(14)
	RJMP SUBOPT_0x7D

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x84:
	LDI  R30,LOW(48)
	ST   -Y,R30
	LDI  R30,LOW(4)
	RJMP SUBOPT_0x7D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x85:
	LDI  R26,LOW(60)
	LDI  R27,HIGH(60)
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x86:
	LDI  R30,0
	SBRC R3,5
	LDI  R30,1
	RJMP SUBOPT_0x64

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x87:
	STS  _temp,R30
	LDI  R30,LOW(51)
	MOV  R5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x88:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x89:
	LDI  R26,LOW(_korr_den)
	LDI  R27,HIGH(_korr_den)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8A:
	LDI  R26,LOW(_korr_den)
	LDI  R27,HIGH(_korr_den)
	CALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8B:
	ST   -Y,R30
	LDI  R30,LOW(12)
	RJMP SUBOPT_0x7D

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8C:
	LDI  R30,LOW(27)
	ST   -Y,R30
	LDI  R30,LOW(19)
	ST   -Y,R30
	RJMP SUBOPT_0x7B

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8D:
	MOV  R30,R13
	LDI  R31,0
	SUBI R30,LOW(-_budilnik_Install)
	SBCI R31,HIGH(-_budilnik_Install)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8E:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _ds18b20_select

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8F:
	ST   -Y,R17
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP _ds18b20_read_spd

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x90:
	__GETB2MN ___ds18b20_scratch_pad,4
	LDI  R27,0
	LDI  R30,LOW(5)
	CALL __ASRW12
	ANDI R30,LOW(0x3)
	MOV  R17,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	RJMP SUBOPT_0x8E

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x91:
	__GETD1N 0xC61C3C00
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_port-1,__w1_bit
	__DELAY_USW 0x3C0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x25
	sbis __w1_port-2,__w1_bit
	ret
	__DELAY_USB 0xCB
	sbis __w1_port-2,__w1_bit
	ldi  r30,1
	__DELAY_USW 0x30C
	ret

__w1_read_bit:
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x5
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x1D
	clc
	sbic __w1_port-2,__w1_bit
	sec
	ror  r30
	__DELAY_USB 0xD5
	ret

__w1_write_bit:
	clt
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x5
	sbrc r23,0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x23
	sbic __w1_port-2,__w1_bit
	rjmp __w1_write_bit0
	sbrs r23,0
	rjmp __w1_write_bit1
	ret
__w1_write_bit0:
	sbrs r23,0
	ret
__w1_write_bit1:
	__DELAY_USB 0xC8
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0xD
	set
	ret

_w1_read:
	ldi  r22,8
	__w1_read0:
	rcall __w1_read_bit
	dec  r22
	brne __w1_read0
	ret

_w1_write:
	ldi  r22,8
	ld   r23,y+
	clr  r30
__w1_write0:
	rcall __w1_write_bit
	brtc __w1_write1
	ror  r23
	dec  r22
	brne __w1_write0
	inc  r30
__w1_write1:
	ret

_w1_search:
	push r20
	push r21
	clr  r1
	clr  r20
	ld   r26,y
	ldd  r27,y+1
__w1_search0:
	mov  r0,r1
	clr  r1
	rcall _w1_init
	tst  r30
	breq __w1_search7
	ldd  r30,y+2
	st   -y,r30
	rcall _w1_write
	ldi  r21,1
__w1_search1:
	cp   r21,r0
	brsh __w1_search6
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search2
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search3
	rcall __sel_bit
	and  r24,r25
	brne __w1_search3
	mov  r1,r21
	rjmp __w1_search3
__w1_search2:
	rcall __w1_read_bit
__w1_search3:
	rcall __sel_bit
	and  r24,r25
	ldi  r23,0
	breq __w1_search5
__w1_search4:
	ldi  r23,1
__w1_search5:
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search6:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search9
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search8
__w1_search7:
	mov  r30,r20
	pop  r21
	pop  r20
	adiw r28,3
	ret
__w1_search8:
	set
	rcall __set_bit
	rjmp __w1_search4
__w1_search9:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search10
	rjmp __w1_search11
__w1_search10:
	cp   r21,r0
	breq __w1_search12
	mov  r1,r21
__w1_search11:
	clt
	rcall __set_bit
	clr  r23
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search12:
	set
	rcall __set_bit
	ldi  r23,1
	rcall __w1_write_bit
__w1_search13:
	inc  r21
	cpi  r21,65
	brlt __w1_search1
	rcall __w1_read_bit
	rol  r30
	rol  r30
	andi r30,1
	adiw r26,8
	st   x,r30
	sbiw r26,8
	inc  r20
	tst  r1
	breq __w1_search7
	ldi  r21,9
__w1_search14:
	ld   r30,x
	adiw r26,9
	st   x,r30
	sbiw r26,8
	dec  r21
	brne __w1_search14
	rjmp __w1_search0

__sel_bit:
	mov  r30,r21
	dec  r30
	mov  r22,r30
	lsr  r30
	lsr  r30
	lsr  r30
	clr  r31
	add  r30,r26
	adc  r31,r27
	ld   r24,z
	ldi  r25,1
	andi r22,7
__sel_bit0:
	breq __sel_bit1
	lsl  r25
	dec  r22
	rjmp __sel_bit0
__sel_bit1:
	ret

__set_bit:
	rcall __sel_bit
	brts __set_bit2
	com  r25
	and  r24,r25
	rjmp __set_bit3
__set_bit2:
	or   r24,r25
__set_bit3:
	st   z,r24
	ret

_w1_dow_crc8:
	clr  r30
	ld   r24,y
	tst  r24
	breq __w1_dow_crc83
	ldi  r22,0x18
	ldd  r26,y+1
	ldd  r27,y+2
__w1_dow_crc80:
	ldi  r25,8
	ld   r31,x+
__w1_dow_crc81:
	mov  r23,r31
	eor  r23,r30
	ror  r23
	brcc __w1_dow_crc82
	eor  r30,r22
__w1_dow_crc82:
	ror  r30
	lsr  r31
	dec  r25
	brne __w1_dow_crc81
	dec  r24
	brne __w1_dow_crc80
__w1_dow_crc83:
	adiw r28,3
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
